<?
/**
 * Here are some examples for using IceWarp COM API with IceWarp webserver
 *  PHP engine
 *  
 * for more info and object function list reffer to merak\api\classes.txt
 * for the list of API variables reffer to merak\api\delphi\apiconst.pas
 * 
 * 
 *    
 */   

echo "Start API example<br /><br />";

//
// Invoke Global API COM object - "IceWarpServer.APIObject"
//
if ($com = new COM("IceWarpServer.APIObject"))
{
  echo "IceWarpServer.APIObject invoked<br /><br />";
}
else
{
  echo "API couldn't be invoked";
  return;
}

//
// Global API - "IceWarpServer.APIObject" usage
//
$domcount = $com->GetDomainCount();
echo "Domain count: $domcount<br />\r\n";

$domlist = $com->GetDomainList();
echo "Domain list: $domlist<br />\r\n";

$domainname = $com->GetDomain(0);
echo "First domain: $domainname<br />\r\n";
echo "<br />\r\n";

//
// Domain work - "IceWarpServer.DomainObject" usage
//
$domain = $com->OpenDomain($domainname);
$domname = $domain->Name;
echo "Loaded domain: $domname<br />\r\n";

$accnum = $domain->GetAccountCount();
echo "Account count: $accnum<br />\r\n";

$acclist = $domain->GetAccountList();
echo "Account list: $acclist<br />\r\n";

$acc = $domain->GetAccount(0);
echo "First account: $acc<br />\r\n";
echo "<br />\r\n";

//
// Account work - "IceWarpServer.AccountObject" usage
//
$account = $domain->OpenAccount($acc);
echo "Loaded account: $acc<br />\r\n";

// get account name and aliases using API variables
$accname = $account->GetProperty("U_Name");
$accalias = $account->GetProperty("U_Alias");
echo "Account: name \"$accname\", alias \"$accalias\"<br />\r\n";

$accdom = $account->Domain;
echo "Account's domain: $accdom<br />\r\n";
echo "<br />\r\n";
?>
