function class_cookie(){
	var me = this;

	this._toStore = {};

	this._notSave = false;
	
	storage.library('gw_others');

	var tmp = GWOthers.get('COOKIE_SETTINGS','storage');
	if (tmp && tmp.VALUES){

		var aData = {};
		for(var i in tmp.VALUES)
			try{
				if (tmp.VALUES[i].charAt(0) == '{' || tmp.VALUES[i].charAt(0) == '[')
					aData[i] = new Function("return "+tmp.VALUES[i])();
				else
					aData[i] = tmp.VALUES[i];
			}
			catch(r){
				aData[i] = tmp.VALUES[i];
			}

		dataSet.add('cookies','',aData);
	}
	dataSet.obey(this,'','cookies',true);

	//smaz resource
	dataSet.remove('storage',['COOKIE_SETTINGS']);

	// for cookie.views
	this.__defaultViews =  {'C':{type:'C',view:'list_view',sort:{column:'ITMCLASSIFYAS',type:'asc'},offset:0},
							'E':{type:'E',view:GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','event_view'),sort:{column:'EVENT_STARTDATE',type:'desc'},offset:0},
							'J':{type:'J',view:'list_view',sort:{column:'EVENT_STARTDATE',type:'desc'},offset:0},
							'M':{type:'M',view:'mail_view',sort:{column:'DATE',type:'desc'},offset:0},
							'R':{type:'R',view:'mail_view',sort:{column:'DATE',type:'desc'},offset:0},
							'N':{type:'N',view:'list_view',sort:{column:'EVNTITLE',type:'asc'},offset:0},
							'F':{type:'F',view:'list_view',sort:{column:'EVNLOCATION',type:'asc'},offset:0},
							'Q':{type:'Q',view:'mail_view',sort:{column:'QDATE',type:'desc'},offset:0},
							'QL':{type:'QL',view:'list_view',sort:{column:'SNDEMAIL',type:'asc'},offset:0},
							'T':{type:'T',view:'list_view',sort:{column:'TASK_ENDDATE',type:'desc'},offset:0},
							'S':{type:'X',view:'nothing'},
							'X':{type:'X',view:'nothing'}};

	this.__defaultRights = ['r','i','w','t','l','k','x','a'];

	//recursive store() executing
	this._interval = setInterval(function(){
		me.store();
	}, 10000);
};

class_cookie.prototype.set = function (aPath,aData,bForce){

	if (!Is.Array(aPath)) return;

	//VIEWS
	if (aPath[0]=='views' && aPath[1] && aPath[2]){
		if (!dataSet.get('cookies',[aPath[0],aPath[1],aPath[2]])){
			this._notSave = true;

			var sFolType = WMFolders.getType([aPath[1],aPath[2]]);
			dataSet.add('cookies',[aPath[0],aPath[1],aPath[2]],this.__defaultViews[sFolType],true);
		}
	}

	//RIGHTS - do not save full rights
	if (aPath[0]=='rights' && aPath[1] && aPath[2] && aData && arrayCompare(aData, this.__defaultRights)){
		if (!dataSet.get('cookies',aPath))
			return;
		else
			aData = '';
	}


	if (!aData && aPath.length>1)
		dataSet.remove('cookies',aPath,bForce);
	else{
		dataSet.add('cookies',aPath,aData,bForce);

		//DEBUG
		//if (aPath[0]=='rights') inspect2({aPath:aPath,aData:aData,SET:dataSet.get('cookies',[aPath[0]])});
	}

	if (bForce)
		dataSet.update('cookies',aPath);
	
	this._notSave = false;
};

class_cookie.prototype.get = function (aPath){

	if (aPath){
		if (aPath[0]=='rights' && aPath[1] && aPath[2])
			return dataSet.get('cookies',aPath) || this.__defaultRights;
		else
		if (aPath[0]=='views' && aPath[1] && aPath[2]){

			var sFolType = WMFolders.getType([aPath[1],aPath[2]]);

			var tmp = dataSet.get('cookies',[aPath[0],aPath[1],aPath[2]]);

			if (typeof tmp != 'object' || !tmp.view || tmp.type != sFolType){

				dataSet.remove('cookies',[aPath[0],aPath[1],aPath[2]]);

				if (typeof aPath[3] == 'undefined')
					return this.__defaultViews[sFolType];

				tmp = this.__defaultViews[sFolType];

				return arrayPath(tmp, aPath.slice(3)) || '';
				/*
				try {
					return eval('tmp["' + aPath.slice(3).join('"]["')+'"]');
				}
				catch(e){
					return '';
				}
				*/
			}
		}
	}

	return dataSet.get('cookies',aPath);
};

class_cookie.prototype.__update = function(sName, aDPath){
	if (aDPath && aDPath[0])
		this._toStore[aDPath[0]] = true;
};

class_cookie.prototype.store = function(aHandler){

	if (this._notSave) return;

	var yes = false,aData = {};

	for (var i in this._toStore){
		yes = true;
		aData[i] = dataSet.get('cookies',[i]);

		if (typeof aData[i] == 'object'){
			aData[i] = arrToString(aData[i]);
			if (aData[i].length == 2) aData[i] = '';
		}
	}

	this._toStore = {};

	if (yes){
		//vytvorit
		GWOthers.set('COOKIE_SETTINGS',aData,'storage');
		//zapsat
		WMStorage.set({'resources':{'COOKIE_SETTINGS':dataSet.get('storage',['COOKIE_SETTINGS'])}},'storage','',aHandler);
		//smaz
		dataSet.remove('storage',['COOKIE_SETTINGS']);
	}

	return yes;
};