_me = frm_im_history.prototype;
function frm_im_history(){};

_me.__constructor = function(xmpp, sJID) {
	var me = this;

	this.__sJID = sJID;
	this.__xmpp = xmpp;

	this.__before = '';
	this.__search = '';
	this.__timestamp = [];

	this._defaultSize(-1,-1,500,350);

	this._title(getLang('IM::HISTORY')+': '+sJID,true);

	this._draw('frm_im_history_top','header');
	this._draw('frm_im_history','main');

	this.search._onsubmit = function(){
		me.btn_search._onclick();
	};
	this.btn_search._onclick = function(){
		me.__before = '';
		me.__after = '';
		me.__search = me.search._value();

		me._refresh();
	};

	this.btn_prev._onclick = function(){
		me.__before = me.__timestamp[0] || '';
		me.__after = '';

		me._refresh();
	};
	this.btn_next._onclick = function(){
		me.__after = me.__timestamp[1] || 0;
		me.__before = '';

		me._refresh();
	};

	this._refresh();
};

_me._refresh = function(){

	var tmp = {'from':this.__sJID,'max':50,'search':this.__search,'start':this.__start};

	if (this.__after)
		tmp.after = this.__after;
	else
		tmp.before = this.__before;

	this.__xmpp.history_get(tmp,[this,'__history']);
};

_me.__history = function(aData){
	var tmd, arr = [];
	if (aData.CHAT[0].TO){
		var sName = dataSet.get('main',['fullname']) || dataSet.get('main',['user']);

		for (var i in aData.CHAT[0].TO){
			tmp = new Date();
			tmp.setVersit(aData.CHAT[0].ATTRIBUTES.START,aData.CHAT[0].TO[i].ATTRIBUTES.SECS);
			arr.push ({from: sName, body:aData.CHAT[0].TO[i].BODY[0].VALUE, reply:true, date:tmp});
		}
	}

	if (aData.CHAT[0].FROM)
		for (var i in aData.CHAT[0].FROM){
			tmp = new Date();
			tmp.setVersit(aData.CHAT[0].ATTRIBUTES.START,aData.CHAT[0].FROM[i].ATTRIBUTES.SECS);

			arr.push ({from: aData.CHAT[0].FROM[i].ATTRIBUTES.JID, body:aData.CHAT[0].FROM[i].BODY[0].VALUE, reply:false, date:tmp});
		}

	if (arr.length>0){
		arr.sort(function arrsrt (a,b){
			return a.date-b.date;
		});
		
		this.__start = aData.CHAT[0].ATTRIBUTES.START;
		this.__timestamp = [aData.CHAT[0].SET[0].FIRST[0].VALUE, aData.CHAT[0].SET[0].LAST[0].VALUE];

		this.chat._fill(arr);
	}
	else
	if (!this.__before && !this.__after)
		this.chat._fill([]);
};