_me = frm_mail_settings.prototype;
function frm_mail_settings(){};

_me.__constructor = function(aInitValues, bHideHtml, aCallback) {

	var me = this;
	this._title('SETTINGS::MAIL_SETTINGS');
	this._defaultSize(-1,-1,500,300);

	this._draw('frm_mail_settings_default','main',{msgsettings:true,"disable_personalities":GWOthers.getItem('RESTRICTIONS', 'disable_personalities')>0});

	//fill spellchecker lang
	var aLang = dataSet.get('storage',['SPELLCHECKER_LANGUAGES','ITEMS']);
	var aData = {};
	for (var i in aLang)
		if (aLang[i].VALUES && aLang[i].VALUES.PATH && aLang[i].VALUES.NAME)
			aData[aLang[i].VALUES.PATH.VALUE] = aLang[i].VALUES.NAME.VALUE;

	this.spellchecker._fill(aData);
	this.spellchecker._value(aInitValues['VALUES']['spellchecker'] || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','spellchecker'))

	//fill priority
	this.priority._fillLang({
		'1':"EMAIL_PRIORITY::HIGHEST",
		'2':"EMAIL_PRIORITY::HIGH",
		'3':"EMAIL_PRIORITY::NORMAL",
		'4':"EMAIL_PRIORITY::LOW",
		'5':"EMAIL_PRIORITY::LOWEST"
	});
	this.priority._value(aInitValues['VALUES']['priority'] || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','priority'));

	//alias
    if(GWOthers.getItem('RESTRICTIONS', 'disable_personalities')<1){
		var sAdr = getPrimaryAccountFromAddress(),
            aData = {},
			aPers = dataSet.get('storage',['PERSONALITIES','ITEMS']);
			
		aData[sAdr] = sAdr;
		for(var i in aPers)
			aData[aPers[i].VALUES.PERSON.VALUE] = aPers[i].VALUES.PERSON.VALUE;

		this.from._fill(aData);
		this.from._value(aInitValues.VALUES['from'] || sAdr);
	}

	//sent
	this.sent._value(aInitValues['VALUES']['sent'] || GWOthers.getItem('DEFAULT_FOLDERS','sent'));
	
	//fill charset
	this.charset._value(aInitValues['VALUES']['charset'] || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','charset'));
	
	//smart attach
	if (this.smart_attach)
		this.smart_attach._value(aInitValues['VALUES']['smart_attach']);
	
	if (Is.Object(aInitValues))
		loadDataIntoFormOnAccess(this, aInitValues);

	this.x_btn_ok._onclick = function() {
		if (Is.Defined(aCallback)) {
			// Save non-well known resources
			var aValues = {};
			storeDataFromForm(me, aValues);
			executeCallbackFunction(aCallback, aValues);
		}
		me._destruct();
	};
};