_me = frm_main.prototype;
function frm_main(){};

_me.__constructor = function(bAlreadySynced)
{
	//Page leave confirmation dialog
	//Do not apply in debug mode
	if (window.oWM_INIT)
		window.onbeforeunload= function(e){
			e = e || window.event;

			//MSIE think that href="javascript: void(0)" is a link...
			if (typeof e.clientX == 'undefined' || e.clientX<0 || e.clientY<0){

				e.cancelBubble = true;

				//This is displayed on the dialog
				e.returnValue = getLang('CONFIRMATION::UNLOAD');

				//e.stopPropagation works in Firefox.
				if (e.stopPropagation) {
					e.stopPropagation();
					e.preventDefault();
				}
			}
		};

	if (gui.copyright)
		gui.copyright._destruct();

	//Create SOUND object
	this.sound = gui._create('sound','obj_sound');

	//Create TITLE object
	this._create('title', 'obj_title');
	
	//Create DRAG AND DROP
	storage.library('dragndrop');
	this.dnd = new cDnD();

	// load libraries
	storage.library('class_old_message');
	storage.library('class_new_message');
	storage.library('class_item');
	storage.library('gw_others');
	storage.library('class_cookie');

	//Synchro-set accounts dataset
	var aAccounts;
	if (!bAlreadySynced){
		aAccounts = WMAccounts.list();
		dataSet.add('accounts','',aAccounts);
		
		//tento kod se muze odendat, jakmile prestaneme pouzivat ?frm=main... v URL
		//Synchro-set storage dataset
		GWOthers.load([	'skins',
						'im',
						'sip',
						'mail_settings_default',
						'mail_settings_general',
						'layout_settings',
						'homepage_settings',
						'calendar_settings',
						'default_calendar_settings',
						'cookie_settings',
						'default_reminder_settings',
					//	'default_folders',
						'spellchecker_languages',
						'signature',
						'restrictions',
						'personalities',
						'read_confirmation',
						'global_settings',
						'paths']);
	}
	else
		aAccounts = dataSet.get('accounts');

	//Synchro-set folders dataset
	this.__goNextCount = 0;
	for (var sAccId in aAccounts)
		if (aAccounts[sAccId])
			if (aAccounts[sAccId]['PRIMARY']){
				if (!bAlreadySynced)
					dataSet.add('folders',[sAccId],WMAccounts.refresh({'aid':sAccId})[sAccId]);
			}
			else
			if (GWOthers.getItem('RESTRICTIONS','disable_otheraccounts') == 0 || aAccounts[sAccId].TYPE == 'rss'){
				//old solution, chenged to goNext/constructor2 solution
				//dataSet.add('folders',[sAccId],WMFolders.list({'aid':sAccId})[sAccId]);
				this.__goNextCount++;
				WMFolders.list({'aid':sAccId},'folders',[sAccId],[this,'_goNext']);
			}
			
	if (!this.__goNextCount)
		this.__constructor2();
};

_me._goNext = function(){
	this.__goNextCount--;
	if (!this.__goNextCount)
		this.__constructor2();
};

_me.__constructor2 = function (){
    var me = this;
    
	//Načtení Folderu (kuli filtrovani views a tree cookie)
	var aFolders = dataSet.get('folders');

	//Načtení cookies
	window.Cookie = new class_cookie();


	//FILTER RIGHTS
	var aRights = Cookie.get(['rights']);
	if (typeof aRights == 'object'){
		for(var sAccId in aRights){

			if (!aFolders[sAccId]){
				Cookie.set(['rights',sAccId],'');
				continue;
			}

			for(var sFolId in aRights[sAccId]){
				if (!aFolders[sAccId][sFolId])
					Cookie.set(['rights',sAccId,sFolId],'');
			}
		}
	}
	Cookie.get(['rights',sAccId,sFolId],'');


	//FILTER VIEWS
	var aViews = Cookie.get(['views']);
	if (typeof aViews == 'object'){
		for(var sAccId in aViews){
			if (!aFolders[sAccId])
				delete aViews[sAccId];
			else
			for(var sFolId in aViews[sAccId]){

				//JESTE SMAZAT POKUD == DEFAULT
				
				if (!aFolders[sAccId][sFolId])
					delete aViews[sAccId][sFolId];
			}
		}
		Cookie.set(['views'],aViews);
	}
	else
		aViews = {};


	//FILTER TREE NODES
	var aTree = Cookie.get(['tree']);
	if (Is.Array(aTree) && aTree.length > 0){
		var pos;
		for (var i = aTree.length-1;i>=0;i--){
			if ((pos = aTree[i].indexOf('/'))>1){
				sAccId = aTree[i].substr(0,pos);
				sFolId = aTree[i].substr(pos+1);

				if (!aFolders[sAccId] || (!aFolders[sAccId][sFolId] && sFolId!='SPAM_QUEUE' && sFolId!='__@@VIRTUAL@@__'))
                	aTree.splice(i,1);
                else{
					var bf = false;
					for(var f in aFolders[sAccId])
						if (f!=sFolId && f.indexOf(sFolId)==0){
                            bf = true;
                            break;
						}

					//has no childnodes
					if (!bf)
						aTree.splice(i,1);
                }
			}
			else
			if (!aFolders[aTree[i]])
                aTree.splice(i,1);
		}
		Cookie.set(['tree'],aTree);
	}


	/*** BAR MENU ***/
	this._create('bar','obj_barmenu','left');
	this.bar._listen('cookies',['barmenu']);
	this.bar._create('tree','obj_barmenu_cell','middle');
	this.bar._create('fav','obj_barmenu_favorites','top','',0,'FAVORITES::FAVORITES');
	//this.bar._create('virtual','obj_barmenu_cell','bottom','',0,'VIRTUAL::TITLE');

	/*** TREE ***/
	this.bar.tree._create('folders','obj_tree_folder_context','middle');

	/*** TOP MENU 1 ***/
	this._create('hmenu1','obj_hmenu_basic','menu1','obj_hmenu_basic');
	this._create('hmenu3','obj_hmenu_basic2','menu1');

	/*** TOP MENU 2 part1 ***/
	this._create('hmenu2','obj_hmenu','menu2');
	this.hmenu2._fill({"logout":{"title":'',"arg":'logout'}});


	//*** resize interface ***/
	this._initResize();

	if (window.sPrimaryAccountIM && GWOthers.getItem('RESTRICTIONS', 'disable_im')<1) {
		if (!Cookie.get(['hide_im']))
			this._showRightDock();

		this._create('im','obj_im','im');
	}

	//*** Activate last opened folder ***
	var oActiveFolder = {},
		sActiveFolder = '';

	if (GWOthers.getItem('LAYOUT_SETTINGS','init_page') == 'r'){
		if ((sActiveFolder = Cookie.get(['last_folder']))){
			var aTmp = Path.split(sActiveFolder);
			if (!aFolders[aTmp[0]] || (aTmp[1] && !aFolders[aTmp[0]][aTmp[1]]))
				sActiveFolder = '';
			else{
				oActiveFolder.aid = aTmp[0];
				if (aTmp[1])
					oActiveFolder.fid = aTmp[1];
			}
		}
	}

	if (GWOthers.getItem('LAYOUT_SETTINGS','init_page') == 'i'){
		sActiveFolder = sPrimaryAccount+'/INBOX';
		oActiveFolder = {'aid':sPrimaryAccount,'fid':'INBOX'};
	}
	else
	if (!sActiveFolder || GWOthers.getItem('LAYOUT_SETTINGS','init_page') == 'h'){
		sActiveFolder = sPrimaryAccount+'/~';
		oActiveFolder = {'aid':sPrimaryAccount,'fid':'~'};
	}

	this.bar.tree.folders._setActive(sActiveFolder);
	this.bar.tree.folders._handleNode(oActiveFolder);


	//*** Set page title = account ***
	var sPgTitle = GWOthers.getItem('LAYOUT_SETTINGS','title') || '';
	var aAccounts = dataSet.get('accounts');
	
	for(var mail in aAccounts)
		if (aAccounts[mail].PRIMARY){
			if (this.title)
				this.title._add((sPgTitle?sPgTitle+' - ':'')+(aAccounts[mail].FULLNAME?aAccounts[mail].FULLNAME+' <'+mail+'>':mail));
			break;
		}


	// [ASync] Refresh after login
    if (window.oWM_INIT && !window.oWM_INIT.__refreshed)
		this._getNew(true);

	// Expired Account warning check
	if (aAccounts[sPrimaryAccount].EXPIRED)
		gui._create('expired','frm_passexpired');
		
	//Add destructor because of SIP
	this._add_destructor('__onDestruct');
	
	//SIP Autologin
	if (GWOthers.getItem('SIP','start')>0 && Cookie.get(['sip','online']))
	    this.__sipAutoLogin = setTimeout(
		function(){
			if (me && me._loginSIP && GWOthers.getItem('SIP','start')>0)
				me._loginSIP();
		}
		,15000);
		
	/*** TOP MENU 2 part2 ***/
	this.hmenu2._onclick = function(e,elm,id,arg){
		switch(arg){
			case 'logout':
			if (Cookie && !Cookie.store([me,'__logout']))
				me.__logout();
		}
	}
};


_me.__createLicense = function(aData){
	if (aData){
		if (aData.IQ && aData.IQ[0] && aData.IQ[0].QUERY && aData.IQ[0].QUERY[0].ACCOUNT && aData.IQ[0].QUERY[0].ACCOUNT[0] && aData.IQ[0].QUERY[0].ACCOUNT[0].LICENSE && aData.IQ[0].QUERY[0].ACCOUNT[0].LICENSE[0] && !Is.Empty(aData.IQ[0].QUERY[0].ACCOUNT[0].LICENSE[0]))
			aData = aData.IQ[0].QUERY[0].ACCOUNT[0].LICENSE[0];
		else
			aData = {};

		gui._create('license','frm_license','','',aData);
	}
	else
		WMAccounts.license([this,'__createLicense']);
};

_me._loginSIP = function(){
    if (window.sPrimaryAccountSIP && GWOthers.getItem('RESTRICTIONS', 'disable_sip')<1 && !this.sip)
		this._create('sip','obj_sip','dock');
};

_me.__onDestruct = function (){
	//kill sip autologin timeout
	if (this.__sipAutoLogin)
	    clearTimeout(this.__sipAutoLogin);

	//destruct SIP before itself
	if (gui.dial)
		gui.dial._destruct();
};


_me._logout = function(){

	//catch all opened compose windows
	var aChild = gui._getChildObjects('','frm_compose');
	var bReturn = false;
	for (var i in aChild){
		if (!aChild[i].__logoutOnDestruct && aChild[i]._onclose())
			aChild[i]._destruct();
		else{
			aChild[i].__logoutOnDestruct = true;
			bReturn = true;
		}
	}

	if (bReturn) return;

	//logout user
};

/**
 * GetNew (Get New button)
 **/
_me._getNew = function(bMain){
	var aAccounts = dataSet.get('accounts');
	if (!aAccounts)	return;

	var disable_other = (GWOthers.getItem('RESTRICTIONS','disable_otheraccounts') == 1);

	for(var sAccId in aAccounts){
		if (!aAccounts[sAccId] || (!aAccounts[sAccId]['PRIMARY'] && (bMain || (disable_other && aAccounts[sAccId]['TYPE']!='rss'))))
			continue;

		accounts.refresh({'aid':sAccId},'folders','',[gui.frm_main,'_refreshItems',[sAccId]]);
        if (bMain) return;
	}
};

/**
 * refreshne pravou stranu je-li refreshovan account s prave aktivnim adresarem
 **/
_me._refreshItems = function(sAccId)
{
	var aSelected = this.bar.tree.folders._getActive();

	if (aSelected[0] == sAccId && aSelected[1])
	{
		var sFolID = aSelected[1];

		if (dataSet.get('folders',[sAccId,sFolID]))
			this.bar.tree.folders._handleNode({'aid':sAccId,'fid':sFolID},true);
		else{
			if (this.main)
				this.main._destruct();

			this.bar.tree.folders._invalidateActive();
			this._lastView = '';
			this.hmenu3._fill();

			dataSet.remove('items');
			dataSet.remove('mailview');
		}
	}
};

_me._selectView = function(aFolder,sView,bUpdate,oDate,bForceUpdate){
	var me = this;

	// promazat datasety
	dataSet.remove('items','',true);

	// HomePage
	if (!aFolder['fid']){

		if(!aFolder['aid'])
			aFolder['aid'] = sPrimaryAccount;
			
		aFolder['fid'] = '~'; // INBOX
	}

	//Ziskat pohled a jeho nastaveni
	var aView = Cookie.get(['views',aFolder.aid,aFolder.fid]),
	sFolType = aView.type;

	if (sView && aView.view != sView)
		Cookie.set(['views',aFolder['aid'],aFolder['fid'],'view'],sView);
	else
		sView = aView.view;


	// nastavit horni menu
	this.hmenu3._contextFill(sFolType,aFolder,sView,false);

	//Změnil se pohled?
	if (sView != this._lastView || bForceUpdate)
	{
		//Změnil se pohled v rámci stejného objektu?
		if ((sView == 'day_view' || sView =='week_view') && (this._lastView == 'day_view' || this._lastView =='week_view'))
		{
			//NEni li zadan Date veme se range[start] z obj_evnview nebo dnesni den
			if (!oDate){
				var oDate = new Date();
				if (this.main.calendar._selection && this.main.calendar._selection.startdate)
					oDate.setQTime(this.main.calendar._selection.startdate);
				else {
					var aRange = this.main.calendar._range();
					if (aRange['start'])
						oDate.setQTime(aRange['start']);
				}
			}
/*
			switch(sView){
				case 'day_view':
					this.main._setDayView(oDate);
//					if (bUpdate) gui.frm_main.main.__update();
					break;
				case 'week_view':
					this.main._setWeekView(oDate);
//					if (bUpdate) gui.frm_main.main.__update();
			}
*/
		}
		else {
			if (this.main){
				if (this._lastView == 'day_view' || this._lastView == 'week_view' || this._lastView == 'month_view')
					oDate = oDate || this.main._getDate();
				else
					oDate = new Date();

				this.main._destruct();
			}
			else
				oDate = new Date();

			switch(sView){
				case 'nothing':
					this._create('main','frm_main_home');
					break;

				case 'mail_view_wide':

					dataSet.remove('mailview');
					this._create('main','frm_main_mail_wide');

					if (aView.search)
						this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'mail_view':

					dataSet.remove('mailview');
					this._create('main','frm_main_mail');

					if (aView.search)
						this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'list_view':
					this._create('main','frm_main_datagrid');
					if (sFolType=='C' || aView.search)
						this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'day_view':
					this._create('main','frm_main_calendar_dayweek','','','items');
					//this.main._setDayView(date);
					break;

				case 'week_view':
					this._create('main','frm_main_calendar_dayweek','','','items');
					//this.main._setWeekView(date);
					break;
				case 'month_view':
					this._create('main','frm_main_calendar_month','','','items',oDate);
					break;
			}
		}
		this._lastView = sView;
	}
	else
	switch(sView){
	case 'mail_view_wide':
	case 'mail_view':
	case 'list_view':
		if (dataSet.get('active_folder') != aFolder['aid'] + '/' + aFolder['fid']){
			if (sFolType=='C' || aView.search)
				this.main._showsearch(sFolType, aFolder['aid']+'/'+aFolder['fid'],true);
			else
				this.main._hidesearch(true);
		}
		break;
	case 'day_view':
	case 'week_view':
		//NEni li zadan Date veme se range[start] z obj_evnview nebo dnesni den
		if (!oDate){
			oDate = new Date();
			if (this.main.calendar._selection && this.main.calendar._selection.startdate)
				oDate.setQTime(this.main.calendar._selection.startdate);
			else{
				var aRange = this.main.calendar._range();
				if (aRange['start'])
					oDate.setQTime(aRange['start']);
			}
		}
	}


	switch(sView){
		case 'mail_view_wide':
		case 'mail_view':
		case 'list_view':
			//Máme mailový pohled?
			if (sView == 'mail_view' || sView == 'mail_view_wide'){
				var aActiveMails = dataSet.get('active_mails');

				if (!aActiveMails || !aActiveMails[aFolder['aid']] || !aActiveMails[aFolder['aid']][aFolder['fid']])
					 dataSet.remove('mailview');

				this.main.list._serverSort(aFolder,aView['sort']['column'],aView['sort']['type'],[this,'__synchroDatasetHandler',[aFolder['aid'],aFolder['fid']]]);
			}
			else
				this.main.list._serverSort(aFolder,aView['sort']['column'],aView['sort']['type']);

			break;

		case 'home':
			break;

		case 'day_view':
			this.main._setDayView(oDate);
			this.main._serverSort();
			break;

		case 'week_view':
			this.main._setWeekView(oDate);
			this.main._serverSort();
			break;

		case 'month_view':
			this.main._serverSort();
	}
	
	// smazat mailview nejedna-li se o mailovy pohled (jinak se nenacita obj_mailview pri zmene folderu C->M)
	if (sView != 'mail_view_wide' && sView != 'mail_view')
		dataSet.remove('mailview');

	dataSet.add('active_folder','',aFolder['aid'] + '/' + aFolder['fid']);
	
	//zapsat do cookies last folder
	if (GWOthers.getItem('LAYOUT_SETTINGS','init_page')=='r')
	    Cookie.set(['last_folder'],aFolder['aid'] + '/' + aFolder['fid']);
};

/* pokud je posledni aktivni email v danem folderu otevre ho v mailview */
_me.__synchroDatasetHandler = function(sAccId,sFolId)
{
	var sActiveMail = dataSet.get('active_mails', [sAccId, sFolId]);
	if (sActiveMail){

		//check if folder is blank
		var aItems = dataSet.get('items', [sAccId, sFolId]);
		if (!aItems || !aItems['/'] || !parseInt(aItems['/'])){
			dataSet.remove('active_mails', [sAccId, sFolId]);
			dataSet.remove('mailview');
			return;
		}

		var v = gui.frm_main.main.list._value();
		if (inArray(v,sActiveMail)<0){
			v.push(sActiveMail);
			gui.frm_main.main.list._value(v);
		}

		OldMessage.open([sAccId, sFolId, sActiveMail]);
	}
};

_me.__logout = function(){

	if (this._destructed) return;

	this._destruct();

	//stop cookies auto-saving
	if (window.Cookie){
		window.clearInterval(window.Cookie._interval);
		window.Cookie = null;
	}

	//#catch all opened compose windows
	var aChild = gui._getChildObjects('','frm_compose');
	for (var i in aChild){
		if (!aChild[i].__logoutOnDestruct && aChild[i]._onclose())
			aChild[i]._destruct();
		else{
			aChild[i].__show();
			aChild[i].__logoutOnDestruct = true;
			return;
		}
	}

	//if external login was used
	var sURL = dataSet.get('main',['referrer_url']);

	//logout user
	auth.logout();

	//remove datasets
	dataSet.remove('main','',true);
	dataSet.remove('cookies','',true);
	dataSet.remove('accounts','',true);
	dataSet.remove('folders','',true);
	dataSet.remove('items','',true);
	dataSet.remove('mailview','',true);
	dataSet.remove('active_mails','',true);
	dataSet.remove('active_folder','',true);
	dataSet.remove('settings','',true);

	window.onbeforeunload = null;

	//disable connection manager
	if (gui.connection)
		gui.connection._destruct();

	if (sURL)
		document.location.replace(sURL);
	else
		document.location.replace(document.location.protocol +'//'+ document.location.hostname + (document.location.port?':'+document.location.port:'') + document.location.pathname);

	return;
	/*
	// destruct everything in gui
	gui._clean();
	
	//clear CSS
 	storage.remove_all_css();
 	
 	inspect2(document.location,1);

	//forward to external login page
	if (sURL)
        document.location.href = sURL;
	//create login page
    else
		gui._create('frm_login','frm_login');
	*/
};