_me = frm_virtual.prototype;
function frm_virtual(){};

_me.__constructor = function(sFolderID, aHandler)
{
	this._title('VIRTUAL::VIRTUAL');
	this._size(700,365,true);
	
	this.__aHandler = aHandler;
    this.__fid = sFolderID;
    
    this.__aData = {};
    
	//Switch to Edit Mode
	if (sFolderID && sFolderID.indexOf('__@@VIRTUAL@@__/') == 0){
		this.__edit = true;
		WMFolders.list({aid:sPrimaryAccount,fid:sFolderID},'','',[this,'__prepareData']);
	}
	else{
		var out = {};
		    out.TYPE = this.__fid?WMFolders.getType({aid:sPrimaryAccount,fid:this.__fid}):'M';
			if (this.__fid){
				out.VIRTUAL = {FOLDERS:{}};
			    out.VIRTUAL.FOLDERS[this.__fid] = true;
			}
		    
		this.__loadItems(out);
	}
};

_me.__prepareData = function(aData){
	this.__loadItems(aData[sPrimaryAccount][this.__fid]);
};

_me.__loadItems = function (aData){

	var me = this;

	if (this.__fid && aData.VIRTUAL && aData.VIRTUAL.FOLDERS)
		this.__aData = aData.VIRTUAL.FOLDERS;

	//Fill TYPE option
	var aFill = {M:getLang('FOLDER_TYPES::MAIL')};
	if (sPrimaryAccountGW>0){
		var dgw = GWOthers.getItem('RESTRICTIONS', 'disable_gw_types');
		if(!dgw || dgw.indexOf('c')<0)
			aFill.C = getLang('FOLDER_TYPES::CONTACT');
		if(!dgw || dgw.indexOf('e')<0)
			aFill.E = getLang('FOLDER_TYPES::EVENT');
		if(!dgw || dgw.indexOf('j')<0)
			aFill.J = getLang('FOLDER_TYPES::JOURNAL');
		if(!dgw || dgw.indexOf('n')<0)
			aFill.N = getLang('FOLDER_TYPES::NOTE');
		if(!dgw || dgw.indexOf('t')<0)
			aFill.T = getLang('FOLDER_TYPES::TASK');
		if(!dgw || dgw.indexOf('f')<0)
			aFill.F = getLang('FOLDER_TYPES::FILE');
	}

	//Footer
	this._create('btn_ok', 'obj_button', 'footer');
	this.btn_ok._value('FORM_BUTTONS::OK');
	this.btn_ok._tabindex(5001);
	this.btn_ok._disabled(true);
	this.btn_ok._onclick = function() {
		me.__save();
		me._destruct();
	};

	this._create('btn_cancel', 'obj_button', 'footer');
	this.btn_cancel._value('FORM_BUTTONS::CANCEL');
	this.btn_cancel._tabindex(5002);
	this.btn_cancel._onclick = function() { me._destruct(); };

	//Main
	this._draw('frm_virtual', 'main', {aid:sPrimaryAccount,type:aData.TYPE});

	// Preselect folder
	var sFullFolderPath = sPrimaryAccount;
	if (this.__edit){
		for (var i in this.__aData){
			sFullFolderPath = sPrimaryAccount +'/'+ i;
			break;
		}
	}
	else
	if (this.__fid)
		sFullFolderPath = sPrimaryAccount +'/'+ this.__fid;
	
	var tGlobal = this.maintab.global;
		tGlobal.tree._setActive(sFullFolderPath);
		tGlobal.tree._ondblclick = function(e,elm,id,idt){
			if (idt.aid && idt.fid && idt.ftype){

				if (!me.__aData[idt.fid])
					me.__aData[idt.fid] = count(me.__aData)?false:true;

				me._fill();
				return true;
			}
		};
		
		tGlobal.add._onclick = function (){
		    var tmp = this._parent.tree._getActive();

			if (tmp && tmp[1] && !me.__aData[tmp[1]]){
				me.__aData[tmp[1]] = count(me.__aData)?false:true;
				me._fill();
			}
		};

		if (this.__edit) tGlobal.select_type._disabled(true);
		tGlobal.select_type._fill(aFill);
		tGlobal.select_type._value(aData.TYPE);
	    tGlobal.select_type._onchange = function(){
			me.maintab.global.tree._filter_folder(this._value());
			me.maintab.global.tree._fill();

			me.__aData = {};
			me._fill();
		};

		tGlobal.btn_primary._onclick = function (){
			var id = this._parent.list._value();
				id = id[0];

			if (id && this._parent.list._aData[id] && this._parent.list._aData[id].arg.folder)
				var folder = this._parent.list._aData[id].arg.folder;
			else
			    return;

			for (var i in me.__aData)
				me.__aData[i] = false;

			me.__aData[folder] = true;

			me._fill();
		};

		tGlobal.btn_remove._onclick = function (){
			var id = this._parent.list._value(),
    			bMain = false,
				folder;

			for(var i in id)
				if (this._parent.list._aData[id[i]] && this._parent.list._aData[id[i]].arg.folder){
					folder = this._parent.list._aData[id[i]].arg.folder;
					if (me.__aData[folder])
						bMain = true;

					delete me.__aData[folder];
				}

			//set first as primary
			if (bMain)
				for (var i in me.__aData){
					me.__aData[i] = true;
					break;
				}

			me._fill();
		};

	var aCData ={main:{width:20,css:'col_main',type:'static'},folder:{title:"COMMON::FOLDER",width:225,type:'static'}};
	tGlobal.list._addColumns(aCData);

	tGlobal.list._ondblclick = function(e,elm,arg,id0,id1){
		if (id0 && id1)
			this._parent.btn_primary._onclick();
	};

	if (this.__fid){
		tGlobal.name._value(Path.basename(this.__fid));
        this._fill();
	}

	tGlobal.name._onerror = function(){
		me._checkOk();
	};
};


_me._fill = function(){
	var aData = [], sw;
	for(var i in this.__aData)
		aData.push({data:{folder:Path.basename(i)}, arg:{folder:i}, css: this.__aData[i]?'main':''});

    sw = aData.length?false:true;
	this.maintab.global.btn_remove._disabled(sw);
	this.maintab.global.btn_primary._disabled(sw);

	this.maintab.global.list._fill(aData);
	
    this._checkOk();
};

_me._checkOk = function(){
	if (this.maintab.global.list._aData && this.maintab.global.list._aData.length && this.maintab.global.name.__check())
		this.btn_ok._disabled(false);
	else
		this.btn_ok._disabled(true);
};

_me.__save = function (){

	var sFolderName = '__@@VIRTUAL@@__/'+this.maintab.global.name._value();

	var out = {'aid':sPrimaryAccount,'name':sFolderName,'type':this.maintab.global.select_type._value(),'virtual':{}};
		out.virtual.folders = this.__aData;



	if (this.__edit)
        out.fid = this.__fid;
    else
	if (dataSet.get('folders',[sPrimaryAccount, sFolderName])){
		alert(getLang('FORM_FOLDERS::CREATE_ERROR'));
		return;
	}

	WMFolders.add(out,'folders','',this.__aHandler);
};