_me = obj_attach_edit_cert.prototype;
function obj_attach_edit_cert(){};

/**
 * @date : 14.7.2006 10:26:59
 **/
_me.__constructor = function(bPublic){
	var me = this;
	this.__public = bPublic;
	this.__atts = {};

	this.attachments.__sortColumn = 'expires';

	if (this.__public)
		this.attachments._addColumns({name:{title:"DATAGRID_ITEMS_VIEW::SNDOWNER",width:200,arg:{sort:'asc'}},serial:{title:"CERTIFICATE::SERIAL",width:200,arg:{sort:'asc'}},expires:{title:"DATAGRID_ITEMS_VIEW::EXPIRES",width:100,arg:{sort:'asc'}}});
	else
		this.attachments._addColumns({name:{title:"DATAGRID_ITEMS_VIEW::SNDOWNER",width:200,arg:{sort:'asc'}},email:{title:"DATAGRID_ITEMS_VIEW::CONTACT_EMAIL",width:200,arg:{sort:'asc'}},expires:{title:"DATAGRID_ITEMS_VIEW::EXPIRES",width:100,arg:{sort:'asc'}}});

	this.attachments._ondblclick = function(e,elm,arg,id){
		if (id)
			me.__viewItem([id]);
	};

	
	this.attachments._oncontext = function(e,elm,arg,sLineId,sColumn){
		//Klikly jsme na místo bez položek?
		if (!sLineId) return;

		gui._create("cmenu","obj_context",'','',me);
		var aMenu = [{"title":'ATTACHMENT::SAVE','arg':[me,'_save',[{'atid':sLineId}]]},
                    {"title":'ATTACHMENT::VIEW','arg':[me,'__viewItem',[[sLineId]]]},
					{"title":'ATTACHMENT::REMOVE','arg':[me,'__deleteItems',[[sLineId]]]}];

		gui.cmenu._fill(aMenu);
		gui.cmenu._place(e.clientX,e.clientY);
	};

	this.download._onclick = function() {
		var v = me.attachments._value();
		if (v.length)
			me._save({atid:v[0]});
	};
	
	this.remove._onclick = function() {
		me.__deleteItems(me.attachments._value());
	};
};

_me._onuploadstart = function(){
	this.__disable_save_all = true;
};

_me._save = function(arg,id) {

	var aUrl = {'sid': dataSet.get('main', ['sid'])};

    if (this.__atts[arg['atid']].state == 'saved'){
		if (this.__public){
			aUrl['class'] = 'contact_certificate';
			aUrl.fullpath = this._gwPath+'/'+this.__atts[arg['atid']].id;
		}
		else{
	        aUrl['class'] = 'personal_certificate';
			aUrl.fullpath = this.__atts[arg['atid']].id;
		}
	}
	else{
        aUrl['class'] = 'uploaded_certificate';
		aUrl.fullpath = this._form['folder'].value+'/'+this.__atts[arg['atid']].id;
	}

	downloadItem(buildURL(aUrl));
};

_me.__viewItem = function(aIDs) {
	for(var i in aIDs)
		gui._create('certificate','frm_certificate','','',this.__atts[aIDs[i]].data);
};

_me._addGuiElement = function(aArg,id) {

	if (!aArg.state){
		//aArg.name .p12, .pxf ->>> dotaz na Heslo
		//RegExp have to me doubled because of crazy FF implementation
		if (/\.(p12|pxf)$/gi.test(aArg.name) || /\.(p12|pxf)$/gi.test(aArg.name))
		    gui._create('passphrase','frm_password','','',[this,'__infoQuery',[aArg]],'CERTIFICATE::PASSPHRASE');
		else
			this.__infoQuery('',aArg);
	}
	else{
		this.__atts[aArg['id']] = aArg;
	    this.__fillDataGrid();
    }
};

_me.__infoQuery = function (sPass, aArg){
	if (sPass)
	    aArg.passphrase = sPass;

	storage.library('wm_upload');
	var oUP = new wm_upload();
	    oUP.certificate(this._form['folder'].value, aArg.id,sPass,[this,'__infoResponse',[aArg]]);
};

_me.__infoResponse = function(aData,aArg){

	if (!aData)
		gui._create('bad_cert','frm_alert','','','','','CERTIFICATE::INVALID');
	else{
        if (!this.__public && aData.TYPE[0].VALUE == 'public')
            gui._create('bad_cert','frm_alert','','','','','CERTIFICATE::BADTYPE');
		else{
			aArg.data = aData.INFO[0];
			if (aData.INFO[0].SUBJECT){
                if (aData.INFO[0].SUBJECT[0].CN)
					aArg.name = aData.INFO[0].SUBJECT[0].CN[0].VALUE;
				if (aData.INFO[0].SUBJECT[0].EMAILADDRESS)
					aArg.email = aData.INFO[0].SUBJECT[0].EMAILADDRESS[0].VALUE;
			}
			if (aData.INFO[0].SERIALNUMBER)
				aArg.serial = aData.INFO[0].SERIALNUMBER[0].VALUE;
			if (aData.INFO[0].VALIDTO)
				aArg.expires = aData.INFO[0].VALIDTO[0].VALUE;

			this.__atts[aArg['id']] = aArg;
		    this.__fillDataGrid();

			return;
		}
    }
    
    //Error, remove from idtable
	if (this.__idtable && aArg && typeof aArg.id != 'undefined')
		for(var n in this.__idtable)
			if (aArg.id == this.__idtable[n]['id'])
	            this.__idtable.splice(n,1);
};


_me.__fillDataGrid = function(){

	var aData = {},
	    d = new Date ();

	for (var i in this.__atts)
		if (this.__atts[i]['state'] != 'to_delete'){

			d.setUTCT(this.__atts[i].expires);
		
            if (this.__public)
				aData[i] = {id:i,data:{name:this.__atts[i].name, serial:this.__atts[i].serial, expires:[d.toWMString(true), this.__atts[i].expires]},arg:{path:this.__atts[i].fullpath}};
			else
				aData[i] = {id:i,data:{name:this.__atts[i].name, email:this.__atts[i].email, expires:[d.toWMString(true), this.__atts[i].expires]},arg:{path:this.__atts[i].fullpath}};
		}

	this.attachments._serverSort(aData);
};

_me.__deleteItems = function(aIDs) {

	for (var i in aIDs) {
		if (!this.__atts[aIDs[i]])
			continue;
		
		if (this.__atts[aIDs[i]]['state'] == 'saved' || this.__atts[aIDs[i]]['state'] == 'to_delete')
			this.__atts[aIDs[i]]['state'] = 'to_delete';
		else
			delete this.__atts[aIDs[i]];

		this._remove(aIDs[i]);
	}

	this.__fillDataGrid();
};

_me._value = function(v) {

	// Setting value is not supported
	if (Is.Defined(v)) {
		this._gwPath = v['path'];
		var aValues = v['values'];
		var tmp;

		for (var i in aValues){
			tmp = aValues[i];
			tmp.id = i;
            tmp.state = 'saved';
			this._add(tmp);
		}

	}
	else {
	    var aResult = [];
	    var aValue;
	    for (var i in this.__atts) {
			switch (this.__atts[i]['state']) {
			    case 'to_delete':
					aValue = {'uid': this.__atts[i].id};
					aResult.push(aValue);
					break;
			    case 'saved':
					break;
			    default:
					aValue = {'fullpath': this._form['folder'].value +'/'+ this.__atts[i].id};

					if (this.__atts[i].passphrase)
						aValue.passphrase = this.__atts[i].passphrase
						
					aResult.push(aValue);
			}
		}
		return aResult;
	}
};