_me = obj_chat.prototype;
function obj_chat(){};

_me.__constructor = function() {
	this._counter = 0;
	var me = this;
	this._main.onclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName =='A')
			if (elm.href.toLowerCase().indexOf('mailto:')==0){
				NewMessage.compose({to:elm.href.substr(7)});
				return false;
			}
	};

	this._main.oncontextmenu = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName =='A')
			if (elm.href.toLowerCase().indexOf('mailto:')==0){
				me._context_link(e, elm.href.substr(7), elm.innerHTML);
				return false;
			}
	};
};

_me._add = function(sFrom, sBody, bReply, date){
    var	toDay
	if (!date)
		toDay = date = new Date();
	else{
		toDay = new Date();
		toDay.setHours(0,0,0);
	}

	//translate jid
	if (!bReply)
		sFrom = dataSet.get('xmpp',['roster',sFrom,'name']) || sFrom;

	this._main.innerHTML +=	'<div class="obj_chat_row'+ (GWOthers.getItem('IM','block_chat')>0?'':' obj_chat_row_inline')+' obj_chat_'+(this._counter%2)+(bReply?' obj_chat_reply':'')+'"><div><span class="obj_chat_date">['+ (date<toDay?date.toWMString():date.format('isoTime')) +']</span> <span class="obj_chat_from">&lt;'+ sFrom.escapeHTML() +'&gt;</span></div>'+
							'<pre class="obj_chat_body">'+ sBody.entityify().highlite_links() +'</pre></div>';

	this._counter++;
	this._scroll();
};

_me._context_link = function(e, sMail, sName){
		var c = gui._create('context','obj_context_link','','',sName,sMail);
			c._place(e.clientX,e.clientY);
			c = null;
};

_me._status = function (sFrom, sStatus){
	var date = new Date();
	sFrom = dataSet.get('xmpp',['roster',sFrom,'name']) || sFrom;
	this._main.innerHTML += '<div class="obj_chat_status"><span class="obj_chat_date" title="'+date+'">['+ date.format('isoTime') +']</span> <span class="obj_chat_from">&lt;'+ sFrom +'&gt;</span> <span class="obj_chat_info">'+ getLang('STATUS::'+(sStatus || 'OFFLINE').toUpperCase()) +'</span></div>';

	this._scroll();
};

_me._clear = function(){
	this._main.innerHTML = '';
	this._counter = 0;
};

_me._scroll = function(){
	var n;
	if ((n = this._main.scrollHeight-this._main.clientHeight)>0)
		this._main.scrollTop = n;
};

_me._fill = function(aData){
	this._clear();

	var str = '',
		bReply,
		sName,
		bBloc = GWOthers.getItem('IM','block_chat')>0,
		aRoster = dataSet.get('xmpp',['roster']),
		toDay = new Date();
		toDay.setHours(0,0,0);

	var prev, sdate;
	for (var i in aData){
		sName = aData[i]['from'];
		if (aRoster[aData[i]['from']] && aRoster[aData[i]['from']].name)
			sName = aRoster[aData[i]['from']].name;

		//check date
        sdate = aData[i]['date'].getFullYear() +''+ aData[i]['date'].getMonth() +''+ aData[i]['date'].getDate();
		if (prev!=sdate)
			str += '<div class="obj_chat_split">'+aData[i]['date'].toWMString(true)+'</div>';

		str +=	'<div class="obj_chat_row'+ (bBloc?'':' obj_chat_row_inline')+' obj_chat_'+(this._counter%2)+(aData[i]['reply']?' obj_chat_reply':'')+'"><div><span class="obj_chat_date" title="'+aData[i]['date']+'">['+ (aData[i]['date']<toDay?aData[i]['date'].toWMString():aData[i]['date'].format('isoTime')) +']</span> <span class="obj_chat_from">&lt;'+ sName.escapeHTML() +'&gt;</span></div>'+
				'<pre class="obj_chat_body">'+ (aData[i]['body']?aData[i]['body'].entityify().highlite_links():'') +'</pre></div>';

		prev = sdate;
		this._counter++;
	}
	
	if (sdate && sdate<toDay.getFullYear() +''+ toDay.getMonth() +''+ toDay.getDate())
		str += '<div class="obj_chat_split">'+toDay.toWMString(true)+'</div>';

	this._main.innerHTML = str;

	this._scroll();
};