/**
 * PopUp menu
 * Inherite: obj_hmenu
 **/
_me = obj_context.prototype;
function obj_context(){};

_me.__constructor = function(owner){
	var me = this;

	this._owner = owner;

	this._add_destructor('__destructClickEvn');
	this.__click = function (){
		me._destruct();
		return true;
	};
	gui._obeyEvent('click',[this.__click]);
};

_me.__destructClickEvn = function(){
	//return original event handler
	gui._disobeyEvent('click',[this.__click]);
	this.__click = null;
};

_me._onclick = function(e, elm, id, arg) {
	if (arg)
		executeCallbackFunction(arg);
};

_me._place = function(x,y){

	var pos = getSize(this._main);

	//stupid MSIE fix
	if (pos.w>300) pos.w = 200;


	//HEIGHT
	var h = 0;
	if (window.innerHeight)
	    h = window.innerHeight;
	else
	if (window.document.body)
		h = window.document.body.clientHeight;

	if (h && y+pos.h>h)
		y = h - pos.h;

	//WIDTH
	var w = 0;
	if (window.innerWidth)
	    w = window.innerWidth;
	else
	if (window.document.body)
	    w = window.document.body.offsetWidth;

	if (w && x+pos.w>w)
		x = w - pos.w;


	this._main.style.top= y +'px';
	this._main.style.left= x +'px';
};