_me = obj_context_folder.prototype;
function obj_context_folder(){};

_me._onclick = function(e,elm,id,arg){
	var me = this;

	if (!arg) return;

	switch(arg['method'])
	{
		//DEFAULT Folder
		case 'default':
			WMFolders.add({'aid': arg.aid, 'fid': arg.fid, 'default': arg['default']}, 'folders',''); //,[me,'__ativateFolder']
		    break;
		    
		//SHARING
		case 'share':
			gui._create('frm_sharing','frm_sharing','','',{aid:arg.aid,fid:arg.fid});
			break;

		//FAVORITES
		case 'remove_favorite':
			if (this._owner._type == 'obj_barmenu_favorites'){
				var aData = dataSet.get(this._owner._listener,this._owner._listenerPath);
				for(var i=0; i<aData.length; i++)
					if (aData[i].arg && aData[i].arg.aid == arg.aid && aData[i].arg.fid == arg.fid){
						aData.splice(i,1);
						dataSet.add(this._owner._listener,this._owner._listenerPath,aData,true);
						dataSet.update(this._owner._listener,this._owner._listenerPath);
						break;
					}
			}
			break;

		//ACCOUNTS
		case 'add_account':
			gui._create('add_account', 'frm_addaddress', '', '',[this, '__addSharedFolder'], ['ADDRESS_BOOK::SELECT_ADDRESSES'],[''],'','',3);
			break;

		//FOLDERS
		case 'add_virtual':
			gui._create('frm_virtual','frm_virtual','','',arg.fid, [this,'__openFolder']);
			break;

		case 'add_folder':
			gui._create('frm_add_folder','frm_add_folder','','',arg.aid,arg.fid, [this,'__openFolder']);
			break;

		case 'delete_folder':
			if (WMFolders.getRights(arg,'remove'))
				gui._create('frm_confirm','frm_confirm','','',[me, '__deleteFolder', [arg.aid, arg.fid]],'CONFIRMATION::DELETE_FOLDER_CONFIRMATION','CONFIRMATION::DELETE_FOLDER',[Path.basename(arg['fid'])]);
			else
				alert(getLang('CONTEXT_FOLDER::CANTDELETE'));
			break;

		case 'move_folder':
			if (WMFolders.getRights(arg,'modify'))
				gui._create('frm_select_folder','frm_select_folder','','','POPUP_FOLDERS::MOVE_FOLDER',arg['aid'],arg['fid'],[this,'__moveFolder',[arg['fid']]],false,true);
			else
				alert(getLang('CONTEXT_FOLDER::CANTMOVE'));
			break;

		case 'empty_folder':
			var sFullPath = arg['aid'] + '/' + arg['fid'];
			var sTrashFolder = GWOthers.getItem('DEFAULT_FOLDERS', 'trash');
			var sFolderType = dataSet.get('folders',[arg['aid'],arg['fid'],'TYPE']);

			if (sFullPath == sTrashFolder || sFolderType == 'R' || parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL', 'delete_emptyfolder'))>0)
				gui._create('frm_confirm', 'frm_confirm', '', '',[WMFolders, '__emptyFolder',
					[arg['aid'], arg['fid']]],
					'CONFIRMATION::EMPTY_FOLDER_CONFIRMATION', 'CONFIRMATION::EMPTY_FOLDER'
				);
			else
				gui._create('frm_confirm', 'frm_confirm', '', '',[WMFolders, '__emptyFolder',
					[arg['aid'], arg['fid'], true]],
					'CONFIRMATION::EMPTY_FOLDER_CONFIRMATION', 'CONFIRMATION::EMPTY_TO_TRASH'
				);
			break;

		case 'mark_all_as_read':
		case 'mark_all_as_unread':
			var bRead = arg['method'] == 'mark_all_as_read' ? true : false;
			WMFolders.markItemsRead({'aid':arg.aid,'fid':arg.fid},'folders','',bRead);
			break;

		case 'change_channel':
			gui._create('frm_change_channel','frm_change_channel','','',arg.aid,arg.fid);
			break;

		case 'rename_folder':
			if (WMFolders.getRights(arg,'modify'))
			{
				var oFolders = gui.frm_main.bar.tree.folders;

				// some istance already exists
				if (oFolders.rename) oFolders.rename._onclose();

				var sLiId	= oFolders._pathName+'/'+arg.aid + (arg.fid?'/'+arg.fid:'');
				var hDiv	= document.getElementById(sLiId).getElementsByTagName('DIV')[0];
				var hLink	= document.getElementById(sLiId).getElementsByTagName('B')[0];

				// aby se neprekresloval tree!!
				oFolders._norefresh = true;

				// hide link
				var oldStyle = hLink.style.display;
				hLink.style.display = 'none';

				// create editDiv anchor and ID to hDiv
				var sAnchor = sLiId + 'editDiv';
				oFolders._anchors['editDiv'] = sAnchor;
				hDiv.id = sAnchor;

				// create obj_input in oFolders' editDiv anchor
				var rinput = oFolders._create('rename','obj_input','editDiv');
					rinput._restrict('![/\\\\:\*\?\"\<\>\|\~]+','','^.{1,255}$');

				// remove anchor immediately (better solution)
				delete oFolders._anchors['editDiv'];

				// set value
				var nPos = arg.fid.lastIndexOf('/');
				var sParentName = arg.fid.substring(0,nPos);
				var sFolderName = arg.fid.substring(nPos + 1);

				rinput._value(sFolderName);
				rinput._focus();
				rinput._onsubmit = function(e){
					if (this._checkError && this._checkError.length) return;

					var snew = this._value();
					var sold = sFolderName;

					if (sold == snew){
						this._onclose();
						return;
					}

					//var folders = new wm_folders;
					var sNewFolderID = (sParentName ? sParentName + '/' : '') + snew;

					WMFolders.add({'aid': arg.aid, 'fid': arg.fid, 'name': sNewFolderID, 'type': arg.ftype}, 'folders','',[me,'__ativateFolder']);

					this._onclose();
				};

				oFolders.rename._onclose = function(e){

					if (this._destructed) return false;

					// aby se zase prekresloval tree
					oFolders._norefresh = false;
					if (oFolders._updateBuffer)
						oFolders.__update('folders');

					// zrusit input objekt
					this._destruct();
					hLink.style.display = oldStyle;
				}

				oFolders.rename._onblur = oFolders.rename._onclose;
			}
			else
				alert(getLang('CONTEXT_FOLDER::CANTRENAME'));

		//gui._create('frm_rename_folder', 'frm_rename_folder', '', '', arg.aid, arg.fid);
		break;
	}
};

_me.__addSharedFolder = function(bOK, aAddresses){
	if (bOK && aAddresses[0].length){

		var tmp, aAccountInfo = {aid:sPrimaryAccount,subscription:[]};
		for(var i = 0; i<aAddresses[0].length; i++){
			tmp = MailAddress.splitEmailsAndNames(aAddresses[0][i]);
			if (tmp && tmp[0] && tmp[0].email){
				if (tmp[0].email.indexOf('@')<0)
				    tmp[0].email+= '@'+dataSet.get('main',['domain']);
				    
				aAccountInfo.subscription.push(tmp[0].email);
			}
		}

		WMAccounts.subscribe(aAccountInfo,[this,'__addSharedFolderResult']);
	}
};
_me.__addSharedFolderResult = function(aData){
	try{
		if (aData.IQ[0].ERROR)
			gui._create('subscribe_error','frm_alert','','','','','ERROR::SUBSCRIBE_ERROR',[aData.IQ[0].ERROR[0].VALUE]);
	}
	catch(r){}
};

_me.__deleteFolder = function(sAccountID,sFolderID){

	WMFolders.remove({'aid':sAccountID,'fid':sFolderID},'folders');

	var aFolders = dataSet.get('folders',[sAccountID]);
	var bPerfm = false;
	for(var i in aFolders){
		if (i == sFolderID || i.indexOf(sFolderID+'/') === 0){
            bPerfm = true;
			delete aFolders[i];
		}
	}

	//	bNoRefresh = true protoze pracujeme primo s datasetem, proto po add neni zmena dat (add je jen pro sychr)
    //	Notne vyvolat refresh manualne
	if(bPerfm){
		dataSet.add('folders',[sAccountID],aFolders,true);
		dataSet.update('folders',[sAccountID]);
	}

	var aItems = dataSet.get('items');
	for(var sAccId in aItems)
		for(var sFolId in aItems[sAccId]);

	if (sAccId == sAccountID && sFolId == sFolderID)
	{
		if (gui.frm_main.main)
			gui.frm_main.main._destruct();

		gui.frm_main._lastView = '';
		gui.frm_main.hmenu3._fill();

		dataSet.remove('items');
		dataSet.remove('mailview');
	}
};

_me.__moveFolder = function(sAccount,sNewFolder,sOldFolder){
	sNewFolder = (sNewFolder?sNewFolder + '/':'') + Path.basename(sOldFolder);

	gui.frm_main.bar.tree.folders._invalidateActive();

	WMFolders.add({'aid':sAccount,'fid':sOldFolder,'name':sNewFolder},'folders');
};

_me.__deleteAccount = function(sAccId)
{
	var accounts = new wm_accounts;
	accounts.remove({'aid':sAccId},'accounts','','folders');
	
	//Remove account from dataSet
	dataSet.remove('accounts',[sAccId]);
	dataSet.remove('folders',[sAccId]);
};

_me.__ativateFolder = function (aFolderInfo){
    if (dataSet.get('active_folder') == aFolderInfo.aid+'/'+aFolderInfo.fid){
		if (aFolderInfo.name)
			aFolderInfo.fid = aFolderInfo.name;

		try{
			gui.frm_main.bar.tree.folders._setActive(aFolderInfo.aid+'/'+aFolderInfo.name);
		}
		catch(r){}
	}
};

_me.__openFolder = function (aFolderInfo){
	if (aFolderInfo.name)
		aFolderInfo.fid = aFolderInfo.name;

	try{
		var p;
		if ((p = aFolderInfo.fid.lastIndexOf('/'))>-1)
            gui.frm_main.bar.tree.folders._open(aFolderInfo.aid +'/'+ aFolderInfo.fid.substr(0,p),'minus');
			//gui.frm_main.bar.tree.folders._openup ('minus',aFolderInfo.aid +'/'+ aFolderInfo.fid.substr(0,p));
		else
            gui.frm_main.bar.tree.folders._open(aFolderInfo.aid,'minus');
			//gui.frm_main.bar.tree.folders._openup ('minus',aFolderInfo.aid);
	}
	catch(r){}
};