/*
 +	nejak si to pamatuje total i kdyz se skoci na jinej folder
	mel by se mazat uz v _serverSort, je-li jinej folder
	
 +	cisteni copntaineru, zustavaj sloupce a nekdy i jejich obsah
	repro:  z events list JUMP to Journal

 -	__update, if count(item) != subcount -> serversort();

 - pri zmene folderu promazat "me.__cursor"
 
*/
_me = obj_datagrid2.prototype;
function obj_datagrid2(){};

_me.__constructor = function(bDontListen){
	var me = this;

	this._cookiesEnabled = true;
	
	//data vars
	this._aFolder = null;   	//set in serverSort
	this._aFolderLast = null;   //set in Update

	this.__total = 0;
	this.__offset = 0;
	this.__preload = parseInt(GWOthers.getItem('LAYOUT_SETTINGS', 'dgrid_preload'));
	if (isNaN(this.__preload) || this.__preload<20) this.__preload = 20;

	this.__limit = [0,0];

	//view vars
	this.__row_count = 0;
	this.__row_offset = 0;

	//Listen to items dataset
	if (!bDontListen)
		this._listen_data('items','',true); //listen but do not update immediately


	//*** SCROLLING
	this.__iScroll_left = 0;
	this.__iScroll_top = -1;
	this.__eContainer2.onscroll = function(e){

		if (me.__iScroll_left != this.scrollLeft){
			me.__iScroll_left = this.scrollLeft;
			me.__eHeader.style.marginLeft = -me.__iScroll_left;
		}

		//LIMIT
		var pre1 = me.__preload,pre2 = me.__preload,r = me.__getRange();
		if (me.__limit[1]<=me.__limit[0] || (r[0]+r[1]>me.__limit[1]-10 && me.__limit[1]<me.__total) || (r[0]<me.__limit[0]+10 && me.__limit[0]>0)){

			// add another +10 items to scroll end
			if (me.__iScroll_top>-1){
				if (me.__iScroll_top > this.scrollTop)
					pre1 += 10;
				else
					pre2 += 10;
			}
			
			me.__limit[0] = r[0]>pre1?r[0]-pre1:0;
			me.__limit[1] = r[0] + r[1] + pre2;

			me.__offset = me.__limit[0];

			if (me.__scrolltime)
				clearTimeout(me.__scrolltime);

			me.__scrolltime = setTimeout(me._pathName+'._serverSort()',300);
		}
		else
		if (me.__scrolltime && me.__iScroll_top>-1 && (me.__iScroll_top != this.scrollTop)){
			clearTimeout(me.__scrolltime);
			me.__scrolltime = setTimeout(me._pathName+'._serverSort()',300);
		}

		if (me.__iScroll_top != this.scrollTop)
			me.__iScroll_top = this.scrollTop;
	};


	//KEYBOARD HANDLERs
	this._getAnchor('input').onkeydown = function(e){
		var e = e || window.event;
		if (!me.__value.length)
			return;

		var act = me.__value[me.__value.length-1];

		//Find next position
		switch(e.keyCode){
			//Enter
			case 13:
				if (me.__value[0]){
					var data = me._aData[me.__value[0]];

					if (!data) return;

					if (me._onclick){
						var arg = data.arg || {};
						me._onclick(e,null,arg,me.__value[me.__value.length-1],null,[]);
					}
					me.__exeEvent('onclick',null,{"arg":arg,"id":data.id,"owner":me});
				}
				return;

			//End
			case 35:
				me.__eContainer2.scrollTop = me.__eContainer2.scrollHeight;//me.__total*me._row_height - me.__eContainer2.offsetHeight;
				return;
			//Home
			case 36:
				me.__eContainer2.scrollTop = 0;
				return;
			//Left
			case 37:
				var s = 0;
				if ((s = me.__eContainer2.scrollLeft)>0){
					s -= 20;
					me.__eContainer2.scrollLeft = s<0?0:s;
				}
				return;

			//Right
			case 39:
				me.__eContainer2.scrollLeft += 20;
				return;

			//Up
			case 38:

				var iPos;
				for(var i in me._aData){
					if (i == act) break;
					iPos = i;
				}

				if ((!e.shiftKey || me._select_single) && typeof iPos != 'undefined')
					me._value([iPos]);

				break;

			//Down
			case 40:
				var found = false;
				for(var iPos in me._aData){
					if (found)
						break;
					if (iPos == act)
						found = true;
				}

				if (!e.shiftKey || me._select_single)
					me._value([iPos]);

				break;

			default:
				//Select all in view (Ctrl+A)
				if (e.ctrlKey && e.keyCode == 65){
					var tmp = [];
					for(var i in me._aData)
						tmp.push(i);
					me._value(tmp);
				}

				if (me._onkeydown) me._onkeydown(e);

				return; //DEV FALSE
		}

		//SHIFT + Up | Down
		if (!me._select_single && e.shiftKey && (e.keyCode == 38 || e.keyCode == 40))
			me.__blockselection(iPos);
	};
};



_me.__check_size = function(){
	var h = this.__eContainer2.offsetHeight;
	if (this.__lastHaight && this.__lastHaight != h)
		this.__eContainer2.onscroll();

	this.__lastHaight = h;
};

_me._default_values = function (sFolType){
	return WMItems.default_values(sFolType);
};

_me._default_columns = function (sFolType){
	var aDefaultColumns;
	
	switch(sFolType){
		case 'C':
			aDefaultColumns = {'ITMCLASSIFYAS':{'width':140,'arg':{'sort':'asc'}},'ITMCOMPANY':{'width':120,'arg':{'sort':'asc'}},'ITMDEPARTMENT':{'width':120,'arg':{'sort':'asc'}},'CONTACT_EMAIL':{'width':160,'arg':{'sort':'asc'}},'ITMCATEGORY':{'width':120,'arg':{'sort':'asc'}}};
			break;

		case 'E':
			aDefaultColumns = {'EVNTITLE':{'width':190,'arg':{'sort':'asc'}},'EVNLOCATION':{'width':120,'arg':{'sort':'asc'}},'EVENT_STARTDATE':{'width':120,'arg':{'sort':'desc'}},'EVENT_ENDDATE':{'width':120,'arg':{'sort':'desc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'RECCURENCE':{'width':20,'css':'recurence','arg':{'sort':'desc'},"text":'&nbsp;'},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			break;

		case 'J':              //'EVNLOCATION':{'width':120,'arg':{'sort':'asc'}},
			aDefaultColumns = {'EVNTITLE':{'width':190,'arg':{'sort':'asc'}},'EVENT_STARTDATE':{'width':120,'arg':{'sort':'desc'}},'EVENT_ENDDATE':{'width':120,'arg':{'sort':'desc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			break;

		case 'F':
			aDefaultColumns = {'EVNFILENAME':{'width':120,'arg':{'sort':'asc'}},'EVNNOTE':{'width':190,'arg':{'sort':'asc'}},'EVNFILEMODIFIED':{'width':120,'arg':{'sort':'desc'}},'EVNFILESIZE':{'width':50,'arg':{'sort':'asc'},'css':'ralign'},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			break;

		case 'M':

			var folders = GWOthers.get('DEFAULT_FOLDERS','storage')['VALUES'];
			var sFolderID = this._aFolder.aid + '/' + this._aFolder.fid;
			
			if (sFolderID == folders['drafts'] || sFolderID == folders['sent'])
				aDefaultColumns = {'PRIORITY':{'width':12,'arg':{'sort':'desc'},'css':'priority',"type":'static',"text":'&nbsp;'},'HAS_ATTACHMENT':{'width':18,'arg':{'sort':'desc'},'css':'attachment',"type":'static',"text":'&nbsp;'},'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'TO':{'width':160,'arg':{'sort':'asc'}},'SUBJECT':{'width':300,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'SIZE':{'width':60,'arg':{'sort':'desc'},'css':'ralign'},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			else
				aDefaultColumns = {'PRIORITY':{'width':12,'arg':{'sort':'desc'},'css':'priority',"type":'static',"text":'&nbsp;'},'HAS_ATTACHMENT':{'width':18,'arg':{'sort':'desc'},'css':'attachment',"type":'static',"text":'&nbsp;'},'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'FROM':{'width':160,'arg':{'sort':'asc'}},'SUBJECT':{'width':300,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'SIZE':{'width':60,'arg':{'sort':'desc'},'css':'ralign'},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};

			break;

		case 'R':
				aDefaultColumns = {'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'SUBJECT':{'width':400,'arg':{'sort':'asc'}},'FROM':{'width':160,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			break;

		case 'T':
			aDefaultColumns = {'EVNSTATUS':{'width':18,'arg':{'sort':'asc'},"type":'static',"text":'&nbsp;','css':'status'},'EVNTITLE':{'width':240,'arg':{'sort':'asc'}},'TASK_STARTDATE':{'width':200,'arg':{'sort':'desc'}},'TASK_ENDDATE':{'width':200,'arg':{'sort':'desc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'RECCURENCE':{'width':20,'css':'recurence','arg':{'sort':'desc'},"type":'static',"text":'&nbsp;'},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			break;

		case 'N':
			aDefaultColumns = {'EVNTITLE':{'width':500,'arg':{'sort':'asc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
			break;

		case 'Q':
			aDefaultColumns = {'SNDEMAIL':{'width':150,'arg':{'sort':'asc'}},'SNDSUBJECT':{'width':250,'arg':{'sort':'asc'}},'QDATE':{'width':110,'arg':{'sort':'desc'}},'SNDOWNER':{'width':100,'arg':{'sort':'asc'}},'SNDDOMAIN':{'width':80,'arg':{'sort':'asc'}}};
            this.__dragtype = ''; // No Drag & Drop
			break;

		case 'QL':
			aDefaultColumns = {'SNDEMAIL':{'width':160,'arg':{'sort':'asc'}},'SNDOWNER':{'width':160,'arg':{'sort':'asc'}},'SNDDOMAIN':{'width':160,'arg':{'sort':'asc'}},'QDATE':{'width':110,'arg':{'sort':'desc'}}};
			this.__dragtype = ''; // No Drag & Drop
			break;
	}
	
	return aDefaultColumns;
};

_me._serverSort = function(aFolder,sColumn,sSortType,aHandler){

	if (this.__scrolltime){
		clearTimeout(this.__scrolltime);
		this.__scrolltime = '';
	}

	//swich folder => scroll DG to the TOP
	if (aFolder && this._aFolder != null && (this._aFolder.aid!=aFolder.aid || this._aFolder.fid!=aFolder.fid)){
		if (this.__eContainer2.scrollTop>0){
			this.__iScroll_top = 0; // to avoid refresh
			this.__eContainer2.scrollTop = 0;
		}

		this.__total = 0;
		this.__limit = [0,0];
		/*
		this._SQLfulltext_last = '';
		this._SQLfilter_last = '';
		*/

		//this.__value = [];
		this._value([]);
	}
	else
	if (!(aFolder = aFolder || this._aFolder))
		return false;

	this._aFolder = aFolder;

	//LIMIT
	var r = this.__getRange();
	if (this.__limit[1]<=this.__limit[0]){

		if ((r[0]+r[1]>this.__limit[1]-10 && (this.__limit[1]<this.__total || this.__total==0)) || (r[0]<this.__limit[0]+10 && this.__limit[0]>0)){
			this.__limit[0] = r[0]>this.__preload?r[0]-this.__preload:0;
			this.__limit[1] = r[0] + r[1] + this.__preload;
			this.__offset = this.__limit[0];
		}
	}
	//Vzdy se ptej na pohledovy Limit
	else
	if (this.__limit[1]<r[0]+r[1]+this.__preload)
		this.__limit[1] = r[0]+r[1]+this.__preload;
		
	var aFilter = {'offset':this.__limit[0],'limit':this.__limit[1]-this.__limit[0]};

	var sFolType = dataSet.get('folders',[aFolder['aid'],aFolder['fid'],'TYPE']);
	var aValues = this._default_values(sFolType);
    var aDefaultColumns = this._default_columns(sFolType);


	//SORT
	if (sSortType)
        sSortType = sSortType == 'desc'?1:0;

	//get sort from cookies
	if (this._cookiesEnabled){
		if (!sColumn){
			var aSort = Cookie.get(['views',aFolder.aid,aFolder.fid,'sort']);
			if (aSort){
				sColumn = aSort.column;
				sSortType = aSort['type'] == 'desc'?1:0;
			}
			aSort = null;
		}

		if (sColumn){
			//check
            if (aDefaultColumns && !aDefaultColumns[sColumn]){
	            var srt = Cookie.__defaultViews[sFolType].sort;
				sColumn = srt.column;
				sSortType = srt.type;
			}
			Cookie.set(['views',aFolder['aid'],aFolder['fid'],'sort'],{column:sColumn,type:sSortType?'desc':'asc'});
		}
	}
	else{
        sColumn = typeof sColumn == 'undefined'?this.__sortColumn:sColumn;
		sSortType = typeof sSortType == 'undefined'?this.__sortType:sSortType;
        //check
		if (aDefaultColumns && !aDefaultColumns[sColumn]){
			sColumn = '';
			sSortType = '';
		}
	}

	this.__sortColumn = sColumn;
	this.__sortType = sSortType;


	//ORDER
	var sOrder = this._serverOrder(sColumn,sSortType);
	if (sOrder)
		aFilter.order_by = sOrder;

	//SQL FILTER
	if (this._SQLfilter_last != this._SQLfilter){
		//this.__value = [];
		this._value([]);
		
		this._SQLfilter_last = this._SQLfilter;
	}
	if (this._SQLfilter)
		this._SQLfilter_last = aFilter['sql'] = this._SQLfilter;

	//FULLTEXT SEARCH
	if (this._SQLfulltext_last != this._SQLfulltext){
		//this.__value = [];
		this._value([]);
		
		this._SQLfulltext_last = this._SQLfulltext;
	}
	if (this._SQLfulltext)
		aFilter['fulltext'] = this._SQLfulltext;

	WMItems.list({'aid':aFolder['aid'],'fid':aFolder['fid'],'values':aValues,'filter':aFilter},this._listener_data,this._listenerPath_data,'',aHandler);
};


_me._serverOrder = function(sColumn,iType){

	var sOrderBy = '';
	var sSortType = iType?'desc':'asc';

	switch(sColumn)
	{
		//Contacts
		case 'CONTACT_EMAIL':
			var aContactEmailParts = ['LCTEMAIL1','LCTEMAIL2','LCTEMAIL3'];

			for (var n in aContactEmailParts){
				if (sOrderBy)
					sOrderBy += ',';

				sOrderBy += aContactEmailParts[n] + ' ' + sSortType;
			}
			break;

		//Events
		case 'EVENT_ENDDATE':
			sOrderBy = 'EVNENDDATE ' + sSortType + ',EVNENDTIME ' + sSortType;
			break;

		case 'EVENT_STARTDATE':
			sOrderBy = 'EVNSTARTDATE ' + sSortType + ',EVNSTARTTIME ' + sSortType;
			break;

		case 'EVNFILESIZE':
			sOrderBy = 'EVNCOMPLETE ' + sSortType;
			break;

		case 'EVNFILEMODIFIED':
			sOrderBy = 'EVN_MODIFIED ' + sSortType;
			break;

		case 'EVNFILENAME':
			sOrderBy = 'EVNLOCATION ' + sSortType;
			break;

		//Mails
		case 'FROM':
			sOrderBy = 'HEADER_FROM ' + sSortType;
			break;

		case 'TO':
			sOrderBy = 'HEADER_TO ' + sSortType;
			break;
		//Tasks
		case 'TASK_STARTDATE':
			sOrderBy = 'EVNENDDATE ' + sSortType;
			break;

		case 'TASK_ENDDATE':
			sOrderBy = 'EVNSTARTDATE ' + sSortType;
			break;

		case 'RECCURENCE':
			sOrderBy = 'EVNRCR_ID ' + sSortType;
			break;

		case 'ITMCOMPANY':
			sOrderBy = 'ITMCOMPANY ' + sSortType +', ITMDEPARTMENT ' + sSortType
			break;

		case 'ITMDEPARTMENT':
			sOrderBy = 'ITMDEPARTMENT ' + sSortType +', ITMCOMPANY ' + sSortType
			break;

		default:
			if (sColumn)
				sOrderBy = sColumn + ' ' + sSortType;
	}

	//Order also by item_id, some DB doesn't do so automaticaly
	var f = this._getFolder();
	if (dataSet.get('folders',[f.aid,f.fid,'TYPE'])=='M')
		sOrderBy += (sOrderBy?', ':'') + 'item_id ' + sSortType;

	return sOrderBy;
};

//return actual visible range
_me.__getRange = function(){
	var a = Math.floor(this.__eContainer2.scrollTop/this._row_height);

	//Browsers sometime return 0 at first time
	if (!this.__eContainer2.clientHeight)
		h = document.getElementsByTagName('body')[0].offsetHeight;
	else
		h = this.__eContainer2.offsetHeight
	
	var b = Math.floor(h/this._row_height);
	
	return [a,b];
};

_me._listen_data = function(sDataSet,aDataPath,bNoUpdate){
	this._listener_data = sDataSet;
	if (typeof aDataPath == 'object') this._listenerPath_data = aDataPath;

	dataSet.obey(this,'_listener_data',sDataSet,bNoUpdate);
};

_me.__update = function(sName,aDPath){

	// columns  - do budoucna pro vyreseni optional columns
	if (sName == this._listener)
		this._addColumns(dataSet.get(this._listener,this._listenerPath));
	else
	// data
	if (sName != this._listener_data)
		return;

	var aItems = dataSet.get(this._listener_data,this._listenerPath_data);
	
	//clear DG if no data response
	if (!aItems || !this._aFolder){
		this._addColumns([]);
		return;
	}

	//check for proper folder response
	for(var sAccId in aItems){
		for(var sFolId in aItems[sAccId])
			break;
		break;
	}
	
	//check if data are from latest request
	if (sAccId != this._aFolder.aid || sFolId != this._aFolder.fid)
		return;

	//Check if folder is the same or new
	var bNewFolder = true;
	if (this._aFolderLast && this._aFolderLast.aid == this._aFolder.aid && this._aFolderLast.fid == this._aFolder.fid)
		bNewFolder = false;

	var sFolType = dataSet.get("folders",[sAccId,sFolId,'TYPE']);
	
/*	Edit just one row value (Part 1)
	if value in column with is same as sort	column is changet than whole list is refreshed
	if column name (aDPath[3]) is undefined then only row's CSS is changed */
	if (aDPath && aDPath[2] && aItems[aDPath[0]][aDPath[1]][aDPath[2]] && (!aDPath[3] || (aDPath[3] && this.__sortColumn!=aDPath[3]))){

		var tmp,rowOffset = -1;
		for(var sCol in this._aCols){
			if (!(tmp = document.getElementById(this._pathName+'/'+aDPath[2]+'/'+sCol)))
				return;

			if (rowOffset<0)
				rowOffset = parseInt(tmp.style.top);
			
			tmp.parentNode.removeChild(tmp);
			tmp = null;
		}

		if (rowOffset<0)
			return;

		try{
			var aTmp = {};
				aTmp[aDPath[2]] = clone(aItems[aDPath[0]][aDPath[1]][aDPath[2]],true);
			
			aItems = aTmp;
		}
		catch(e){
			return;
		}
	}
	else{

		aItems = clone(aItems[sAccId][sFolId],true);
		
		//TOTAL
		if (typeof aItems['/'] != 'undefined' && aItems['/'] >= 0){
			if (!(this.__total = aItems['/']*1))
				this._value([]);
		}
		else
		    this.__total = count(aItems);

		delete aItems['/'];
		

		//SUBTOTAL
		if (typeof aItems['#'] != 'undefined' && aItems['#']>=0){
			this.__subtotal = aItems['#']*1;
			this.__limit[1] = Math.min(this.__limit[1],this.__total);
		}
		delete aItems['#'];

		//OFFSET
		if (typeof aItems['$'] != 'undefined' && aItems['$']>=0){
			if (this.__offset!= aItems['$']*1)
				return;
			else
				this.__offset = aItems['$']*1;
		}
		delete aItems['$'];
		
		//LOAD NEW DATA IF COUNT DOESNT CORESPOND WITH SUBTOTAL
		if (count(aItems) != this.__subtotal){
			this._serverSort();
			return;
		}

		if (bNewFolder){

			this.__dragtype = 'item';
            
			///////////////////////
			///// FILL HEADER /////
			///////////////////////
            var aDefaultColumns = this._default_columns(sFolType);

			var aColumns = {};

			//cookies
			if (this._cookiesEnabled)
			{
				var aCookieColumns = Cookie.get(['views',sAccId,sFolId,'columns']);
				var bRepair = false;

				if (aCookieColumns)
				{
					for(var sColumn in aDefaultColumns)
						if (typeof aCookieColumns[sColumn] == 'undefined'){
							bRepair = true;
							break;
						}

					if (!bRepair)
						for(var sColumn in aCookieColumns)
							if (typeof aDefaultColumns[sColumn] == 'undefined'){
								bRepair = true;
								break;
							}
				}
				else
				{
					//bRepair = true; - rem to avoid worthless saving
					aColumns = aDefaultColumns;
				}

				if (bRepair)
				{
					aCookieColumns = {};

					for(var sColumn in aDefaultColumns)
						aCookieColumns[sColumn] = aDefaultColumns[sColumn]['width'];

					Cookie.set(['views',sAccId,sFolId,'columns'],aCookieColumns);
					aColumns = aDefaultColumns;
				}
				else
				for(var sColumn in aCookieColumns)
				{
					aColumns[sColumn] = aDefaultColumns[sColumn];
					aColumns[sColumn]['width'] = aCookieColumns[sColumn];
				}

				var aSort = Cookie.get(['views',sAccId,sFolId,'sort']);

				this.__sortColumn = aSort.column;
				this.__sortType = aSort.type == 'desc'?1:0;
			}
			else
				aColumns = aDefaultColumns;


			var aHeaders = {};
			for(var sTitle in aColumns){

				aHeaders[sTitle] = {};
				if (!aColumns[sTitle].text)
					aHeaders[sTitle]['title'] = 'DATAGRID_ITEMS_VIEW::' + sTitle;

				for(var sProperty in aColumns[sTitle])
					aHeaders[sTitle][sProperty] = aColumns[sTitle][sProperty];
			}

			this._addColumns(aHeaders);
		}
	}
	

	///////////////////////
	///// PEPARE BODY /////
	//////////////////////
	var aResult = this._prepareBody(aItems, sFolType);

	if (this.info){

		if (this.__value.length>this.__total)
			this._value([]);
			//this.__value = [];

		this.info._value(this.__value.length,this.__total);
	}

	/////////////////////
	///// FILL BODY /////
	/////////////////////
	// Refill whole body
	if (typeof rowOffset == 'undefined')
		this._fill(aResult);
	// Edit just one row value (Part 2)
	else
		this._fill(aResult,rowOffset);

	this._aFolderLast = this._aFolder;
};

/**
 *	Naplnění pole pro datagrid
 **/
_me._prepareBody = function (aItems, sFolType){

	var aResult = {};
	var aRow,scss;
	var aColors =  {'1':'red','2':'blue','3':'green','4':'gray','5':'orange','6':'cyan',
					'7':'brown','8':'purple','9':'light_blue','A':'yellow','Y':'complete'};

	var aNoteColors =  {'1':'blue','2':'green','3':'red','5':'gray','6':'yellow'};
//inspect2(aItems,1);
	for(var sItId in aItems)
	{
		aRow = {};
		scss = '';

		for(var sTitle in this._aCols)
		{

			switch(sTitle)
			{
				//Contacts
				case 'CONTACT_EMAIL':
					var sContactEmail = '';

					//Nezobrazujeme maily pro distribuční seznam
					if (aItems[sItId]['ITMCLASS'] == 'C') {
						var aContactEmailParts = ['LCTEMAIL1','LCTEMAIL2','LCTEMAIL3'];

						for (var n in aContactEmailParts)
							if (aItems[sItId][aContactEmailParts[n]]){
								if (sContactEmail)
									sContactEmail += ', ';

								sContactEmail += aItems[sItId][aContactEmailParts[n]];
							}
					}
					aRow[sTitle] = sContactEmail;
					break;

				case 'ITMCLASSIFYAS':
					if (aItems[sItId][sTitle]){
						if (Is.String(aItems[sItId][sTitle]))
							aRow[sTitle] = [aItems[sItId][sTitle].entityify(),aItems[sItId][sTitle]];
						else
							aRow[sTitle] = aItems[sItId][sTitle];

						break;
					}

				// Events
				case 'EVENT_ENDDATE':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNENDDATE'],aItems[sItId]['EVNENDTIME']),parseInt(aItems[sItId]['EVNENDDATE'])*10000 + parseInt(aItems[sItId]['EVNENDTIME'])];
					break;

				case 'EVENT_STARTDATE':
				case 'EVNFILEMODIFIED':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNSTARTDATE'],aItems[sItId]['EVNSTARTTIME']),parseInt(aItems[sItId]['EVNSTARTDATE'])*10000 + parseInt(aItems[sItId]['EVNSTARTTIME'])];
					break;

				case 'RECCURENCE':
					if (aItems[sItId]['EVNRCR_ID']) {
						scss += ' recurence';
						aRow[sTitle] = ['',1];
					} else
						aRow[sTitle] = ['',0];
					break;

				case 'EVNFILENAME':
					aRow[sTitle] = aItems[sItId]['EVNLOCATION'];
					break;

				case 'EVNSTATUS':
					switch (aItems[sItId][sTitle]) {
						case 'B': scss += ' not_started'; break;
						case 'I': scss += ' in_progress'; break;
						case 'M': scss += ' completed'; break;
						case 'Q': scss += ' delegated'; break;
						case 'N': scss += ' needs_action'; break;
					}
					aRow[sTitle] = ['',aItems[sItId][sTitle]];
					break;
				//Tasks
				case 'TASK_STARTDATE':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNENDDATE']),parseInt(aItems[sItId]['EVNENDDATE'])];
					break;

				case 'TASK_ENDDATE':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNSTARTDATE']),parseInt(aItems[sItId]['EVNSTARTDATE'])];
					break;
				//Mails
				case 'DATE':	//EMAIL
				case 'QDATE':	//Quarantine
					aRow[sTitle] = [this.__parseTime(aItems[sItId][sTitle]),parseInt(aItems[sItId][sTitle])];
					break;

				case 'PRIORITY':
					switch (aItems[sItId]['PRIORITY']) {
						case '1':
						case '2':
							scss += ' priority_high';
							aRow[sTitle] = ['',2];
							break;

						case '4':
						case '5':
							scss += ' priority_low';
							aRow[sTitle] = ['',0];
							break;

						default:
							aRow[sTitle] = ['',1];
					}
					break;

				case 'EVNCOLOR':
				case 'COLOR':
					var sTag = WMItems.getColorTag(sFolType);
					if (sTag) {
						if (aItems[sItId][sTag] && Is.Defined(aColors[aItems[sItId][sTag]])){
							scss += ' bg_';
							if (sFolType == 'N')
							    scss += aNoteColors[aItems[sItId][sTag]];
							else
								scss += aColors[aItems[sItId][sTag]];
						}
						aRow[sTitle] = ['', aItems[sItId][sTag]];
					}
					break;

				case 'FLAGS':
					var nFlags = aItems[sItId]['FLAGS'];
					var flag = '';

					if (!WMItems.hasFlag(nFlags, 'SEEN')) {
						flag = 'unread';
						aRow[sTitle] = ['',nFlags];
					}
					else
					if (WMItems.hasFlag(nFlags, 'ANSWERED')) {
						if (WMItems.hasFlag(nFlags, 'FORWARDED'))
							flag = 'replied_and_forwarded';
						else
							flag = 'replied';

						aRow[sTitle] = ['',nFlags];
					}
					else
					if (WMItems.hasFlag(nFlags, 'FORWARDED')) {
						flag = 'forwarded';
						aRow[sTitle] = ['',nFlags];
					}
					else
						aRow[sTitle] = ['',nFlags];

					switch(parseInt(aItems[sItId]['SMIME_STATUS'])){
						case 2: flag = 'serror' + (flag?'_'+flag:''); break;
						case 3: flag = 'smime' + (flag?'_'+flag:''); break;
						case 4: flag = 'sign' + (flag?'_'+flag:''); break;
						case 5: flag = 'ssmime' + (flag?'_'+flag:''); break;
					}

					if (flag)
						scss += ' ' + flag;
					break;

				case 'HAS_ATTACHMENT':
					if (aItems[sItId]['HAS_ATTACHMENT']=='true') {
						scss += ' attachment';
						aRow[sTitle] = ['',1];
					}
					else
						aRow[sTitle] = ['',0];
					break;

				case 'FROM':
				case 'TO':

					aRow[sTitle] = MailAddress.parseMail(aItems[sItId][sTitle],'name_list');
					if (sTitle == 'TO' && aItems[sItId]['SMS'])
						aRow[sTitle] += (aRow[sTitle]?', ':'') + MailAddress.parseMail(aItems[sItId]['SMS'],'name_list');

					break;

				case 'SMS':
					//aRow['TO'] == 'xxx';
					break;
				
				case 'SIZE':
					aRow[sTitle] = [this.__parseSize(aItems[sItId][sTitle]),parseInt(aItems[sItId][sTitle])];
					break;

				case 'EVNFILESIZE':
					var sSize = aItems[sItId]['EVNCOMPLETE'];
					if (!Is.Defined(sSize))
						sSize = 0;
					aRow[sTitle] = [this.__parseSize(sSize),parseInt(sSize)];
					break;

				default:
					if (Is.String(aItems[sItId][sTitle]))
						aRow[sTitle] = [aItems[sItId][sTitle].entityify(),aItems[sItId][sTitle]];
					else
						aRow[sTitle] = aItems[sItId][sTitle];

					break;
			}
		}

		aResult[sItId] = {"id":sItId,"css":scss,"data":aRow,"arg":{'aid':this._aFolder.aid,'fid':this._aFolder.fid,'iid':sItId}};
	}

	return aResult;
};

// FUNCTION(s) FOR PARSING DATA
_me.__parseSize = function(nSize){
	return Math.round(nSize*10/1024)/10+' kB';
};

_me.__parseTime = function(nUTime)
{
	if (!nUTime) return '';

	var oDate = new Date(nUTime*1000);
	return oDate.toWMString(false);
};

_me.__parseGwTime = function(sDate,sTime)
{
	if (typeof sTime == 'undefined')
		if (typeof sDate == 'undefined' || sDate == 0)
			return '';
		else
			sTime = -1;

	// string muze na zacatku obsahovat # - v tom pripade by se mel zobrazit pouze Date (nikoliv Time)
	var bDateOnly;

	if (sTime == -1){
		bDateOnly = true;
		sTime = 0;
	}
	else
		bDateOnly = false;

	var oDate = new Date();
		oDate.setGWTime(sDate,sTime);

	return oDate.toWMString(bDateOnly);
};


/**
 * historical reasons, it can be called from outside
 **/
_me._getFolder = function(){
	return this._aFolder;
};