_me = obj_rich.prototype;
function obj_rich(){};

/**
 * @brief: CONSTRUCTOR, create select HTML element to __eIN variable
 * @date : 20.4.2006 17:26:58
 **/
_me.__constructor = function(){
	var me = this;

	// Browser detection
	this._MSIE = currentBrowser().indexOf('MSIE')>-1;

	this.__oldFcolor = '#000000';
	this.__oldBcolor = '#FFFFFF';
	this.__disabled = false;

	this.__coded = false;

	this.__eFrame = mkElement('iframe');
	this.__eFrame.name = this._pathName;
	this.__eFrame.setAttribute('frameBorder',0);
	this.__eFrame.setAttribute('marginWidth',0);
	this.__eFrame.setAttribute('marginHeight',0);

	this._getAnchor('frame').appendChild(this.__eFrame);

	this.__doc = this.__eFrame.contentDocument;
	if (typeof this.__doc == 'undefined' || this.__doc == null)
		this.__doc = this.__eFrame.contentWindow.document;

	var html =	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"+
				"<html>\n<head>\n"+
				(this._MSIE?'<link type="text/css" rel="stylesheet" href="client/skins/default/css/obj_rich_body.css" />':'')+
				"\n</head>\n<body></body>\n</html>";

	if (currentBrowser() != 'Opera' && currentBrowser() != 'Mozilla')
		this.__doc.designMode = 'on';

	this.__doc.open('text/html','replace');
	this.__doc.write(html);
	this.__doc.close();

	if (currentBrowser() == 'Opera')
		this.__doc.designMode = 'on';
	else
	//FFox cart rix part1
	if (currentBrowser() == 'Mozilla')
		this.__doc.onfocus = function(){
			this.designMode = 'on';
			this.onfocus = null;
		};
	
	// Append Style Sheet (all browsers except MSIE)
	if (!this._MSIE){
		var link = this.__doc.createElement('link');
			link.setAttribute("type","text/css");
			link.setAttribute("rel","stylesheet");
			link.setAttribute("href","client/skins/default/css/obj_rich_body.css");
			this.__doc.getElementsByTagName('head')[0].appendChild(link);
			link = null;
	}

	// Pass events to parent window
	var eFrame = this.__eFrame;
	var win = eFrame.contentWindow;

	function mouseEvn(e){
		var e = e || win.event;

		if (e.type == 'click')
			me.__checkMenu();

		//Send event to richarea object
		if (me['_on'+e.type]) if(!me['_on'+e.type](e)) return false;
		//Send event to richtext document
		if (me.__doc.designMode == 'on' &&  me.__doc['on'+e.type])
			if (!me.__doc['on'+e.type](e)) return false;

		if (window.document['on'+e.type]){
			var pos = getSize(eFrame);
			var evn = {"type":e.type,"clientX":e.clientX + pos.x,"clientY":e.clientY + pos.y};
			window.document['on'+e.type](evn);
		}
	};
	
	if (win.addEventListener){		
		win.addEventListener("mousemove", mouseEvn, false);
		win.addEventListener("mousedown", mouseEvn, false);
		win.addEventListener("mouseup", mouseEvn, false);
		win.addEventListener("click", mouseEvn, false);
		win.addEventListener("contextmenu", mouseEvn, false);

		win.addEventListener("focus", mouseEvn, false);
		win.addEventListener("blur", mouseEvn, false);

		// richtext shortcuts for Mozilla browsers
		function keyEvn(e){

			if (me._onkeydown) me._onkeydown(e);
			var e = e || win.event;

			if (me.__disabled){
				//Ctrl+S
				if (e.ctrlKey && e.keyCode == 83){
					//disable mozilla UI shortcuts
					if (e.preventDefault) e.preventDefault();
					if (e.stopPropagation) e.stopPropagation();
					return false;
				};
				return true;
			}

			if (e.ctrlKey && !e.altKey){
			
				//Z, X, C, V
				if (e.keyCode == 17 || e.keyCode == 88 || e.keyCode == 67 || e.keyCode == 86)
					return true;
					
				var ret = false;

				switch(e.keyCode){
				case 66:	//B
					if (currentBrowser()!='Opera'){
						me.__docmd('bold');
						ret = true;
					}
					break;

				case 85:	//U
					if (currentBrowser()!='Opera'){
						me.__docmd('underline');
						ret = true;
					}
					break;

				case 73:	//I
   					if (currentBrowser()!='Opera'){
						me.__docmd('italic');
						ret = true;
					}
					break;

				case 76:	//L
					me.__docmd('justifyLeft'); ret = true; break;
				case 69:	//E
					me.__docmd('justifyCenter'); ret = true; break;
				case 82:	//R
					me.__docmd('justifyRight'); ret = true; break;
				case 74:	//J
					me.__docmd('justifyFull'); ret = true; break;
				}

				if (ret){
					//disable mozilla UI shortcuts
					e.cancelBubble = true;
					if (e.preventDefault) e.preventDefault();
					if (e.stopPropagation) e.stopPropagation();
					return false;
				}
			}

			return true;
		};

		win.addEventListener("keydown", keyEvn, false);

		win.addEventListener("keyup", function(e){
			var e = e || this.event;

			if (me._onkeyup)
				me._onkeyup(e);

			if (me.__checkTimer){
				clearTimeout(me.__checkTimer);
				me.__checkTimer = null;
			}

			me.__checkTimer = setTimeout(function(){
				if (me && me.__checkMenu)
				    try{
						me.__checkMenu();
					}
					catch(e){};
			},200);
		},false);
	}
	else{ 
		this.__doc.onmousemove = function(e){ mouseEvn(e); };
		this.__doc.onmousedown = function(e){ mouseEvn(e); };
		this.__doc.onmouseup = function(e){ mouseEvn(e); };
		this.__doc.onclick = function(e){ mouseEvn(e); };
		this.__doc.oncontextmenu = function(e){ mouseEvn(e); };
		this.__eFrame.onfocus = function(e){ if (e) mouseEvn(e); };
		this.__eFrame.onblur = function(e){ if (e) mouseEvn(e); };

		//MSIE Selection fix
		this.__doc.onselectionchange = function(){
			me.__curSelection = this.selection.createRange();
		};


		// Disable richtext shortcuts in MSIE
		this.__doc.onkeydown = function(e){
			var e = e || win.event;

			if (me._onkeydown) me._onkeydown(e);

			//Prevest na text
			if (me.__coded && e.ctrlKey && !e.altKey && e.keyCode == 86)
				try{
					var content = window.clipboardData.getData('Text');
					if (content) content = content.replace(/\&nbsp;/gi, ' ');
					window.clipboardData.clearData();
					window.clipboardData.setData('Text', content);
					return true;
				}
				catch(e){
					return false;
				}
						
			if (me.__disabled && e.ctrlKey && !e.altKey && inArray([66,85,73,76,69,82,74],e.keyCode)>-1){
				if (!e.cancelBubble) e.cancelBubble = true;

				if (me.__disabled)
					return false;
				else
					return true;
			}
		};
		
		this.__doc.onkeyup = function(e){
			var e = e || win.event;
			if (me._onkeyup)
				me._onkeyup(e);

			if (me.__checkTimer){
				clearTimeout(me.__checkTimer);
				me.__checkTimer = null;
			}

			me.__checkTimer = setTimeout(function(){
				if (me && me.__checkMenu)
					try{
						me.__checkMenu();
					}
					catch(e){};
			},200);
		};
	}

	// HEADER stuff...

	// MSIE browser detection
	if (!this._MSIE){
		document.getElementById(this._pathName+'#cut').style.display = 'none';
		document.getElementById(this._pathName+'#copy').style.display = 'none';
		document.getElementById(this._pathName+'#paste').style.display = 'none';
	}

	//buttons
	this._getAnchor('header').onclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;
		if (elm.tagName != 'A' || !elm.id) return false;

		var id = elm.id.substr(me._pathName.length);

		switch(id){
		case '#spell':
			if (!me.__coded)
				me.__spell();
				
			return false;

		case '#code':
			if (!(me.__spelled || (!me.__coded && me.__disabled)))
				me.__code();

			return false;
		}

		if (me.__disabled) return false;

		switch(id){
		case '#left': me.__docmd('justifyLeft');  break;
		case '#center': me.__docmd('justifyCenter'); break;
		case '#right': me.__docmd('justifyRight'); break;
		case '#justify': me.__docmd('justifyFull'); break;

		case '#ordered': me.__docmd('insertOrderedList'); break;
		case '#unordered': me.__docmd('insertUnorderedList'); break;
		case '#outdent': me.__docmd('outdent'); break;
		case '#indent': me.__docmd('indent'); break;

		case '#bold': me.__docmd('bold'); break;
		case '#italic': me.__docmd('italic'); break;
		case '#underline': me.__docmd('underline'); break;

		case '#bgcolor':

			if (me._MSIE)
				me.__lastSlc = me.__doc.selection.createRange();

			var pos = getSize(elm);
			if ((e.clientX - pos.x) > 20)
				me.__initpopup('B',pos);
			else
				me._setBColor(me.__oldBcolor);

			break;
		case '#color':

			if (me._MSIE)
				me.__lastSlc = me.__doc.selection.createRange();

			var pos = getSize(elm);
			if ((e.clientX - pos.x) > 20)
				me.__initpopup('F',pos);
			else
				me._setFColor(me.__oldFcolor);

			break;
		case '#table':
			var pos = getSize(elm);
			me.__initpopup('T',pos);

			break;
		case '#cut': me.__docmd('cut'); break;
		case '#copy': me.__docmd('copy'); break;
		case '#paste': me.__docmd('paste'); break;

		//case '#image': me.__docmd('insertimage', false, url); break;

		case '#link':
			if (me._MSIE)
				me.__docmd('createLink');
			else {
				var url = prompt('URL:', 'http://');
				if (url && url != 'http://') me.__docmd('createLink', url);
			}
			break;
		}
		
		return false;
	};

	this.p._onchange = function(){
		var val = this._value();
		if (!val) return false;

		if (val=='removeFormat')
			me.__docmd('removeFormat');
		else
			me.__docmd('formatBlock',(["","<P>","<H1>","<H2>","<H3>","<H4>","<H5>","<H6>"])[val]);

		//this._value(0);
	};
	this.font._onchange = function(){
		var val = this._value();
		if (!val) return false;

		me.__docmd('fontName',val);
		//this._value(0);
	};
	this.size._onchange = function(){
		var val = this._value();
		if (!val) return false;

		me.__docmd('fontSize',val);
		//this._value(0);
	};
};

_me.__checkMenu = function(){

	if (this.__coded) return;

	var tag, buffer = {},
		elms = this.__getAncestors();
/*
	if (!elms.length)
		elms = [this.__doc.getElementsByTagName('body')[0]];
*/
	for(var i in elms){
		tag = elms[i].tagName.toUpperCase();

		//Bold
		if (!buffer.BOLD)
			buffer.BOLD = this.__testStyle(elms[i],'font-weight', 'bold') || tag == 'B' || tag == 'STRONG';
		if (!buffer.ITALIC)
			buffer.ITALIC = this.__testStyle(elms[i], 'font-style', 'italic') || tag == 'I' || tag == 'EM';
		if (!buffer.UNDERLINE)
			buffer.UNDERLINE = this.__testStyle(elms[i], 'text-decoration', 'underline') || tag == 'U';

		//Align
		if (!buffer.LEFT && !buffer.RIGHT && !buffer.CENTER && !buffer.JUSTIFY){
        	buffer.LEFT = this.__testStyle(elms[i], 'text-align', 'left');
            if (!buffer.LEFT){
            	buffer.RIGHT = this.__testStyle(elms[i], 'text-align', 'right');
                if (!buffer.RIGHT){
                	buffer.CENTER = this.__testStyle(elms[i], 'text-align', 'center');
                    if (!buffer.CENTER){
                    	buffer.JUSTIFY = this.__testStyle(elms[i], 'text-align', 'justify');

                    	//attribute align=""
                    	var tmp = elms[i].getAttribute('align');
                    	if (tmp)
                    		buffer[tmp.toUpperCase()] = true;
                    }
                }
            }
        }

		//Lists
		if (!buffer.UNORDERED && tag == 'UL') buffer.UNORDERED = true;
		if (!buffer.ORDERED && tag == 'OL') buffer.ORDERED = true;

		/*
		//Direction
        if (!buffer.LTR)
        	buffer.LTR = elms[i].getAttribute('dir') == 'ltr';
        if (!buffer.RTL)
        	buffer.RTL = elms[i].getAttribute('dir') == 'rtl';
        */

		//Headings
		if (!buffer.HEAD)
		    switch(tag){
		    case 'H1': buffer.HEAD = 2; break;
		    case 'H2': buffer.HEAD = 3; break;
		    case 'H3': buffer.HEAD = 4; break;
		    case 'H4': buffer.HEAD = 5; break;
		    case 'H5': buffer.HEAD = 6; break;
		    case 'H6': buffer.HEAD = 7; break;
			}

		//Indent
        if (!buffer.INDENT){
        	var tmp = getStyle(elms[i], 'margin-left');
        	buffer.INDENT = (tmp && tmp != 0 && tmp != '0px');
		}

		//Font
		if (!buffer.FAMILY)
			buffer.FAMILY = getStyle(elms[i], 'font-family') || elms[i].getAttribute('face');

		if (!buffer.SIZE){
			buffer.SIZE = elms[i].getAttribute('size');
			/* tohle stejne nejde
			if (!buffer.SIZE2)
				buffer.SIZE2 = getStyle(elms[i], 'font-size',this.__doc);
			*/
		}
		/*
        if (!buffer.FONT)
			buffer.FONT = getStyle(elms[i], 'font');
		*/

		//Color
		/*
		if (!buffer.COLOR){
			if (this.__MSIE)
				buffer.COLOR = elms[i].getAttribute('color');
			else{
				var style = elms[i].getAttribute('style');
				if (style){
					var bkgPattern = new RegExp('color:[^;"]*');
				}
			}
		*/
	}

//document.title = count(buffer);


	//Set menu
	var tmp = document.getElementById(this._pathName+'#left');
	if (buffer.LEFT) addcss(tmp,'active'); else removecss(tmp,'active');
    tmp = document.getElementById(this._pathName+'#center');
	if (buffer.CENTER) addcss(tmp,'active'); else removecss(tmp,'active');
    tmp = document.getElementById(this._pathName+'#right');
	if (buffer.RIGHT) addcss(tmp,'active'); else removecss(tmp,'active');
    tmp = document.getElementById(this._pathName+'#justify');
	if (buffer.JUSTIFY) addcss(tmp,'active'); else removecss(tmp,'active');

    tmp = document.getElementById(this._pathName+'#ordered');
	if (buffer.ORDERED) addcss(tmp,'active'); else removecss(tmp,'active');
    tmp = document.getElementById(this._pathName+'#unordered');
	if (buffer.UNORDERED) addcss(tmp,'active'); else removecss(tmp,'active');

    tmp = document.getElementById(this._pathName+'#indent');
	if (buffer.INDENT) addcss(tmp,'active'); else removecss(tmp,'active');

    tmp = document.getElementById(this._pathName+'#bold');
	if (buffer.BOLD) addcss(tmp,'active'); else removecss(tmp,'active');
    tmp = document.getElementById(this._pathName+'#italic');
	if (buffer.ITALIC) addcss(tmp,'active'); else removecss(tmp,'active');
    tmp = document.getElementById(this._pathName+'#underline');
	if (buffer.UNDERLINE) addcss(tmp,'active'); else removecss(tmp,'active');

	this.size._value(buffer.SIZE || buffer.SIZE2 || 0, true);

	var f = 0;
	if (buffer.FAMILY){
		buffer.FAMILY = buffer.FAMILY.toLowerCase();
		
		if (buffer.FAMILY.indexOf('verdana')>-1)
			f = 'Verdana,Arial,Helvetica';
		else
        if (buffer.FAMILY.indexOf('times')>-1)
            f = 'Times New Roman,Times,Serif';
        else
        if (buffer.FAMILY.indexOf('trebuchet')>-1)
            f = 'Trebuchet MS,Arial,Helvetica';
        else
		if (buffer.FAMILY.indexOf('serif')>-1)
		    f = 'MS Sans Serif,sans-serif';
		else
		if (buffer.FAMILY.indexOf('comic')>-1)
		    f = 'Comic Sans MS';
		else
		if (buffer.FAMILY.indexOf('arial')>-1 || buffer.FAMILY.indexOf('helvetica')>-1)
			f = 'Arial,Helvetica';
		else
		if (buffer.FAMILY.indexOf('courier')>-1 || buffer.FAMILY.indexOf('monospace')>-1)
		    f = 'Courier New,Courier,Monospace';
		else
		if (buffer.FAMILY.indexOf('cursive')>-1)
		    f = 'Cursive';
		else
		if (buffer.FAMILY.indexOf('fantasy')>-1)
		    f = 'Fantasy';
	}
	this.font._value(f, true);

	this.p._value(buffer.HEAD || 0, true);
};

//Dynamic text analyse
_me.__testStyle = function(elm, attr, styleValue){
	var style = getStyle(elm, attr);
	var font = getStyle(elm, 'font');
	if (style || font)
		return (style.toLowerCase() == styleValue || font.toLowerCase().indexOf(styleValue.toLowerCase()) != -1) ? true : false;
	else
		return false;
};

_me.__getAncestors = function(){
	 var ancestors = [];
	 var parent = this.__getSelectedParentNode();

	 while (parent && (parent.nodeType == 1) && (parent.tagName != "BODY")) {
		 ancestors.push(parent);
		 parent = parent.parentNode;
	 }

	 return ancestors;
};

	_me.__getSelectedParentNode = function() {
		var sel = this.__getRange();
		if (sel){
			if (this._MSIE) {
				try {
					sel.collapse();
					return sel.parentElement();
				}
				catch(e) {
					return;
				}
			}
			else{
                while (sel.nodeType == 3)
					sel = sel.parentNode;

				return sel;
			}
		}
	};

	_me.__getRange = function() {
		if (this.__doc.selection)
			return this.__doc.selection.createRange();
		else
		try {
            return this.__eFrame.contentWindow.getSelection().focusNode;
		}
		catch(e) {
			return null;
		}
	};



_me.__code = function(){

	var txt = this.__doc.getElementsByTagName('body')[0].innerHTML.replace(/\r/gm,'').replace(/\n/gm,"\r\n");
	if (this.__coded){
		this._disable(0,'obj_richcode');

		this.__coded = false;

		if (currentBrowser().indexOf('MSIE')==0)
			txt = txt.replace(/<\/?P>/gm,'');

		txt = txt.replace(/<\/?BR>/igm,'');
		this._value(txt.unescapeHTML());
	}
	else{
		this._disable(1,'obj_richcode');

		this._value(txt.escapeHTML());
		this.__coded = true;
	}
};

_me.__getSpellLang = function(){
	storage.library('gw_others');
	return GWOthers.getItem('MAIL_SETTINGS_DEFAULT','spellchecker');
};

_me.__spell = function(){

	this.__spellwords = [];

	// Disable spellchecker
	if (this.__spelled){
		if (this.__spelled == 2)
		    return;
		else
			this.__spelled = 2;
        
		var elm = this.__doc.getElementsByTagName('body')[0].getElementsByTagName('span');
		var str,node;

		for(var i = elm.length-1; i>=0;i--){
			if (!(elm[i].className && elm[i].className.indexOf('spell')>-1)) continue;

			str = elm[i].innerHTML;
			node = elm[i].parentNode;
			node.replaceChild(this.__doc.createTextNode('#^SPL^#'), elm[i]);
			node.innerHTML = node.innerHTML.replace('#^SPL^#',str);
		}

		//this.__doc.onclick = null;
		this._onclick = null;

		this.__spelled = false;
		this._disable(this.__disable_status);
		removecss(document.getElementById(this._pathName + '#spell'),'spellactive');

		return;
	}

    this.__spelled = 2;
    
	// Enable spellchecker
	this.__disable_status = this.__disabled;

	var arr = [];
	var str = this._value();

	//prepare text for Aspell
	var sOld = str.removeTags(' ');
		sOld = sOld.replace(/([\.,…„;\:\"\`\“\”\[\]\{\}\(\)\~\—\-\=\_\!\¿\?\|\\/\<\> ]+)/gm,' '); // removed: \'\‘\’

	var checklang = this.__getSpellLang();
	if (!checklang) return;
	
	storage.library('wm_spellchecker');
	var iqspell = new wm_spellchecker();

	var aStr = iqspell.get({type:'check',lang:checklang,input:sOld});

	if (!count(aStr)) return;

	var tmp = '',istart = 0,iend = 0, ilen = str.length,arr = [];
	var tmpIndex,tmpString,tmpLength;

	var regexp = /^([\.,…„;\:\"\'\`\‘\“\”\’\[\]\{\}\(\)\~\—\s\-\=\_\!\¿\?\<\>\|\\/]+)$/g;

	while(true){

		iend = str.indexOf('<',istart);

		if (iend<0)
			iend = ilen;
		else
		if (iend == 0){
			istart = str.indexOf('>');
			if (istart<0) break;
			istart++;
			continue;
		}

		tmp = str.substring(istart,iend);

		//nahradit
		if (tmp.trim()){
			tmp = tmp.toLowerCase();

			for (var j in aStr){

				tmpLength = aStr[j].length;

				while(true){
					tmpIndex = tmp.indexOf(aStr[j],tmpIndex);
					if (tmpIndex<0) break;

					tmpString = '';
					if (tmpIndex > 0)
						tmpString += tmp.charAt(tmpIndex-1);
						
					if (tmpIndex+tmpLength < (iend-istart))
						tmpString += tmp.charAt(tmpIndex+tmpLength);

					if (tmpString.length == 0 || tmpString.match(regexp))
						arr.push([istart+tmpIndex,tmpLength,aStr[j]]);

					tmpIndex += tmpLength;
				}
			}
		}

		if (iend==ilen) break;

		istart = str.indexOf('>',iend);
		istart = istart>0?istart+1:iend;
	} //while end

	if (count(arr)){

		function sortarr(a,b){
			return a[0]-b[0];
		}
		arr.sort(sortarr);

		var subcount = 0;
		for(var i in arr){
			str = str.substring(0,arr[i][0]+subcount) +'<span class="spell">'+ str.substr(arr[i][0]+subcount,arr[i][1]) +'</span>'+ str.substring(arr[i][0]+arr[i][1]+subcount);
			subcount += 27;
		}

		//DISABLE RICHAREA
		this._disable(true);

		addcss(document.getElementById(this._pathName + '#spell'),'spellactive');

		var me = this;
		this._onclick = function(e){

			var e = e || me.__doc.parentWindow.event;
			var elm = e.target || e.srcElement;

			if (!(elm.tagName == 'SPAN' && elm.className.indexOf('spell')>=0)) return true;

			var aMenu = [];
			if (elm.id){
				aMenu.push({text:me.__spellwords[elm.id].entityify(),arg:[me,'__swapword',[elm,me.__spellwords[elm.id]],true]});
				if (me.__spellwords[elm.id] != elm.innerHTML)
					aMenu.push({text:elm.innerHTML.entityify(),arg:[me,'__swapword',[elm,elm.innerHTML]]});
			}
			else{
				elm.id = me.__spellwords.length;
				me.__spellwords[elm.id] = elm.innerHTML;
				aMenu.push({text:elm.innerHTML.entityify(),arg:[me,'__swapword',[elm,elm.innerHTML]]});
			}
			aMenu.push({"title":'-'});

			try{
				var aSuggest = iqspell.get({type:'suggest',lang:checklang,input:me.__spellwords[elm.id]});
					aSuggest = aSuggest[aSuggest[0]]

				var j = 0;
				for(var i in aSuggest){
					if (j>15) break;
					aMenu.push({text:aSuggest[i].entityify(),arg:[me,'__swapword',[elm,aSuggest[i],true]]});
					j++;
				}
			}
			catch(er){}

			me.spell = gui._create('spellcheck','obj_context');
			me.spell._fill(aMenu);

			var pos1 = getSize(me.__eFrame);
			var pos2 = getSize(elm,me.__doc);
			
			me.spell._place(pos1.x+pos2.x,pos1.y+pos2.y+pos2.h);

			return false;
		};

		this._value(str,true);
		this.__spelled = true;
	}
};


_me.__swapword = function(elm, str, ok){
	if (elm){
		elm.innerHTML = str;
		if (ok)
			addcss(elm, 'spellok');
		else
			removecss(elm, 'spellok');
	}
};



_me.__destructor = function(){
	if (this._eFloat)
		this._eFloat.parentNode.removeChild(this._eFloat);
};

_me.__initpopup = function(type,pos){
	var me = this;
	
	// create div inside body
	if (!this._eFloat){
		this._eFloat = mkElement('div',{id:this._pathName+'float'});
		this._eFloat.className = this._type+'float';
		document.body.appendChild(this._eFloat);
	}

	// place div
	this._eFloat.style.top = (pos.y + pos.h) + 'px';
	var x = pos.x+pos.w - 150;

	var pos2 = getSize(this._main);
	if (pos2.x+pos2.w<x+300) x = pos2.x+pos2.w-300;
	if (x<pos2.x) x = pos2.x;
	this._eFloat.style.left = x + 'px';

	this._eFloat.style.display = 'block';

	if (type == 'B' || type == 'F'){

		if (!this.color){
			if (this.table) this.table._destruct();

			this._create('color','obj_color','float');

			this.color._create('ok','obj_button','button');
			this.color.ok._value('FORM_BUTTONS::OK');

			this.color._create('cancel','obj_button','button');
			this.color.cancel._value('FORM_BUTTONS::CANCEL');
			this.color.cancel._onclick = function(){
				this._parent._destruct();
				this._parent._parent._eFloat.style.display = 'none';
			};
		}

		this.color._value(this[type=='B'?'__oldBcolor':'__oldFcolor']);
		this.color.ok._onclick = function(){
			var c = this._parent._value();
			if (c) me[type=='B'?'_setBColor':'_setFColor']('#' + c);
			this._parent.cancel._onclick();
		};
	}
	else
	if (type == 'T'){
		if (this.table) return;
		if (this.color) this.color._destruct();
		this._create('table','obj_rich_table','float');
	}
};


/* NEFUNGUJE V FFOXU */
_me._focus = function(bNow, bTop){
	if (bNow){
		this.__eFrame.contentWindow.focus();
		if (bTop){
			var sel,
				elm = this.__doc.getElementsByTagName("body");
			try{
				sel = this.__eFrame.contentWindow.getSelection();
			}
			catch(e){
				sel = this.__doc.selection.createRange();
			}
			if (sel && elm)
			    sel.collapse(elm[0],0);
		}
	}
	else{
		var me = this;
		setTimeout(function(){try{ me._focus(true,bTop); }catch(e){}},300);
	}
};

_me._disable = function(b,css){
	var eHeader = this._getAnchor('header');
	if (b){
		if (this.__spelled && this.__spelled!==2)
			this.__disable_status = true;

		if (this.__coded && !css)
			this.__code();

		this.__disabled = true;

		eHeader.className = 'obj_richdisabled'+(css?' '+css:'');

		this.p._disabled(true);
		this.font._disabled(true);
		this.size._disabled(true);
	}
	else{
		if (this.__spelled && this.__spelled!==2)
			this.__disable_status = false;
		else{
			this.__disabled = false;
			/*
			if (css)
				removecss(eHeader,css);
			else
			*/
				eHeader.className = '';

			this.p._disabled(false);
			this.font._disabled(false);
			this.size._disabled(false);
		}
	}
	eHeader = null;
};

_me._value = function (v,bSkipSpell){

	if (!bSkipSpell && this.__spelled)
		this.__spell();

	if (typeof v != 'undefined'){
		this.__doc.getElementsByTagName('BODY')[0].innerHTML = this.__coded?v.escapeHTML():v;
		//FFox cart rix part2 (cart is invisible in Reply: without this)
		if (this.__doc.onfocus)
			this.__doc.onfocus();
	}
	else{
		var sBody
		if (this.__coded)
			sBody = this.__doc.getElementsByTagName('body')[0].innerHTML.unescapeHTML();
		else
			sBody = this.__doc.getElementsByTagName('body')[0].innerHTML;

		//safari uses <div><br></div> instead of <br>
		if (currentBrowser() == 'Safari'){
			var xtmp = mkElement('div');
				xtmp.innerHTML = sBody;

			var arr = xtmp.getElementsByTagName('BR');
			for(var i = arr.length-1; i>-1;i--)
				if (arr[i].parentNode.tagName == 'DIV' && arr[i].parentNode.childNodes.length == 1)
					arr[i].parentNode.parentNode.replaceChild(arr[i],arr[i].parentNode);

			sBody = xtmp.innerHTML;
		}

		return (this._MSIE?'<style>p{margin:0;padding:0;}</style>':'') + sBody.replace(/\r/gm,'').replace(/\n/gm,"\r\n");
	}
};

_me.__exec = function(cmd,opt){
	try{
        if (this._MSIE && this.__curSelection){
            this.__curSelection.execCommand(cmd, false, opt);
            this._focus(true);
        }
        else
			this.__doc.execCommand(cmd, false, opt);
	}
	catch(r){
		//alert(cmd + ": not supported");
	}
};

_me.__docmd = function(cmd, opt) {

	if (this._MSIE){
		if (!this.__curSelection){
	       	this._focus(true);
			this.__curSelection = this.__getRange();//this.__doc.selection.createRange();
		}
	}
	else
		this._focus(true);

	if (cmd && opt){
		if (cmd == 'insertHTML' && this._MSIE){
            this._focus(true);
            this.__curSelection = this.__getRange();
			this.__curSelection.pasteHTML(opt);
		}
		else
		if (cmd == 'createLink' && !this._MSIE){
			var slc = this.__eFrame.contentWindow.getSelection();

			if (slc.toString().length==0)
				this.__exec('insertHTML', '<a href="'+opt.entityify()+'">'+opt.escapeHTML()+'</a>');
			else
				this.__exec(cmd, opt);
		}
		else{
			this.__exec(cmd, opt);
			this.__checkMenu();
		}
	}
	else
	/* optional non-standard solution */
	if (cmd == 'removeFormat' && this._MSIE)
		this.__curSelection.pasteHTML(this.__curSelection.text);
	else
	if (cmd){
		this.__exec(cmd);
		this.__checkMenu();
	}

	if (this._MSIE)
		this.__curSelection = 0;
};

_me._insTable = function(aData){

	var html = '<span>&nbsp;</span><table border="'+ aData.border +'"'+ (aData.border && aData.color?' bordercolor="#'+aData.color+'"':'') + (aData.padding?' cellpadding="'+aData.padding+'"':'') + (aData.spacing?' cellspacing="'+aData.spacing+'"':'')+'>';
	for(var i=0;i<aData['rows'];i++){
		html += '<tr>';
		for(var j=0;j<aData['columns'];j++)
			html += '<td></td>';
		html += '</tr>';
	}
	html +='</table><span>&nbsp;</span>';

	this.__docmd('insertHTML', html);
	this._focus(true);
};

_me._setFColor = function(color){

	if (this.__lastSlc && this.__lastSlc!=null){
		this.__lastSlc.select();
		this.__lastSlc = null;
	}

	this.__exec('foreColor', color);

	this.__oldFcolor = color;
	document.getElementById(this._pathName + '#color').getElementsByTagName('SPAN')[0].style.backgroundColor = color;
	this._focus(true);
};

_me._setBColor = function(color){
	if (this._MSIE){
		if (this.__lastSlc && this.__lastSlc!=null){
			this.__lastSlc.select();
			this.__lastSlc = null;
		}
		this.__exec('backColor', color);
	}
	else
		this.__exec('hiliteColor', color);

	this.__oldBcolor = color;
	document.getElementById(this._pathName + '#bgcolor').getElementsByTagName('SPAN')[0].style.backgroundColor = color;
	this._focus(true);
};