/*
	FFox has issue with onmouseover so we have to create this tooltip object in advance (like in obj_im)
	otherwise it creates multiple asynchronous requests for .tpl, .xml and .js objects

	This is just temporary solution, should be reported to Mozilla
*/
_me = obj_tooltip.prototype;
function obj_tooltip(){};

_me.__constructor = function(elm, sBody){
	this.__originator = elm;
	this.__originatorPos;
	this.__myPos;
	
	this.__fade = 0;
	
	this.__value = sBody;
	
	this._add_destructor('__destructor');

	this.__startTimeout = setTimeout(this._pathName+'._show();',1000);
	this.__checkTimeout;
	this.__fadeTimeout;
};

_me._show = function(){

	var me = this,
		x = gui.__X,
		y = gui.__Y;

	if (this.__originator){
		try{
			this.__originatorPos = getSize(this.__originator);
		}
		//originator was corrupted (MSIE)
		catch(r){
            this._destruct();
			return;
		}

		if (this.__originatorPos.x<x && this.__originatorPos.x+this.__originatorPos.w>x &&
			this.__originatorPos.y<y && this.__originatorPos.y+this.__originatorPos.h>y){

			//vykreslit blok
			this._main = mkElement('div');
			this._main.className = this._type + (this._css?' '+this._css:'');
			this._main.onmouseout = function(e){
				me._destruct();
			};

			this._main.innerHTML = '<div id="'+this._pathName+'body" class="'+this._type+'_body">' + this.__value.replace(/r\n|\n|\r/g,'<br>') + '</div><div id="'+this._pathName+'arrow" class="'+this._type+'_arrow'+(this._css?' '+this._css+'_arrow':'')+'"></div>';
			this._main.style.left = x>5?x-5:x;
			this._main.style.top = y+5;

			gui._main.appendChild(this._main);

			var w = this._main.offsetWidth;
			if (w && gui._main.offsetWidth<w+x+5){
				this._main.style.left = 'auto';
				this._main.style.right = 0;
			}

			var h = this._main.offsetHeight;
			if (h && gui._main.offsetHeight<h+y+5){
				this._main.style.top = 'auto';
				this._main.style.bottom = 0;
			}

			var elm = this._getAnchor('arrow');
			if (elm){
				var tmp = getSize(this._main);
				elm.style.left = (x - tmp.x<5?5:x - tmp.x); //Position
			}

			this.__checkTimeout = window.setInterval('try{'+this._pathName+'._hide();}catch(r){}',300);
			this.__fadeTimeout = window.setInterval('try{'+this._pathName+'._fade();}catch(r){}',30);

			return;
		}
	}


	this._destruct();
};

_me._fade = function (){
	if (this.__fade<11){
		this._main.style.opacity = this.__fade/10;
		this._main.style['-moz-opacity'] = this.__fade/10;
		this._main.style.filter = 'alpha(opacity='+(this.__fade*10)+')';

		this.__fade++;
	}
	else
		clearInterval(this.__fadeTimeout);
};

_me._hide = function(){
	if (this.__originator && this._main){
		var x = gui.__X,
			y = gui.__Y;

		if (this.__originatorPos.x<x && this.__originatorPos.x+this.__originatorPos.w>x &&
			this.__originatorPos.y<y && this.__originatorPos.y+this.__originatorPos.h>y){
			return;
		}
		else
			this._destruct();
	}
};

_me._check = function (elm){
	return this.__originator == elm;
};

_me.__destructor = function (){
	clearTimeout(this.__startTimeout);
	clearInterval(this.__fadeTimeout);
	clearInterval(this.__checkTimeout);
};