#include <stdio.h>
#include "icewarp_api.h"

int main(int argc, char *argv[])
{
  char *instance;
  char *version;

  // create API object
  instance = icewarp_apiobjectcall("0", "", "IceWarpServer.APIObject", "", "", "", "");
  printf("IceWarpServer.APIObject: %s\n", instance);

  // get property
  version = icewarp_apiobjectcall(instance, "GetProperty", "C_Version", "", "", "", "");
  printf("C_Version: %s\n", version);

  // destroy object
  icewarp_apiobjectcall(instance, "", "", "", "", "", "");

  // free returned strings
  icewarp_freeresult(instance);
  icewarp_freeresult(version);

  return 0;
}
