/* IceWarp Merak Mail Server
 * (c) IceWarp Ltd. 2009
 *
 *       All rights reserved.
 *
 * http://www.icewarp.com
 *
 * file: icewarp_api.h - Merak API header file
 * version: 1.1
 */

/* Use this header file to call functions from file api.dll on Windows or libapi.so on Linux. */

#ifndef __ICEWARP_API_H__
#define __ICEWARP_API_H__ 1

#ifdef __cplusplus
extern "C" {
#endif

/* Calling function icewarp_apiobjectcall() is same as in PHP API.
 * Please see file classes.txt for available objects and methods.
 */

char *icewarp_apiobjectcall(char *_Object,
                            char *_Method,
                            char *Parameter1,
                            char *Parameter2,
                            char *Parameter3,
                            char *Parameter4,
                            char *Parameter5);

/* Function must be called to free every result
 * returned from icewarp_apiobjectcall()
 */
void icewarp_freeresult(void *_Result);

#ifdef __cplusplus
}
#endif

#endif /* __ICEWARP_API_H__ */
