_me = frm_certificate.prototype;
function frm_certificate(){};

/**
 * View Certificate
 */         
_me.__constructor = function(aData) {

	var me = this;

    this._resizable = false;
	this._size(450,300,true);
	
	this._title ('CERTIFICATE::CERTIFICATE');

	var date = new Date(),
		aOut = {purposes:{},data:aData};

        date.setUTCT(aData.VALIDFROM[0].VALUE);
		aOut.from =	date.toWMString();
		
        date.setUTCT(aData.VALIDTO[0].VALUE);
	    aOut.to = date.toWMString();

	if (aData.PURPOSES && aData.PURPOSES[0] && aData.PURPOSES[0].ITEM)
	    for (var i in aData.PURPOSES[0].ITEM)
			if (aData.PURPOSES[0].ITEM[i].VAR1 && aData.PURPOSES[0].ITEM[i].VAR1[0] && aData.PURPOSES[0].ITEM[i].VAR1[0].VALUE == '1' &&
				aData.PURPOSES[0].ITEM[i].VAR3 && aData.PURPOSES[0].ITEM[i].VAR3[0] && aData.PURPOSES[0].ITEM[i].VAR3[0].VALUE)
				switch(aData.PURPOSES[0].ITEM[i].VAR3[0].VALUE){
				case 'sslclient':
					aOut.purposes.SSL = true;
				    break;
				case 'smimeencrypt':
				case 'smimesign':
					aOut.purposes.SMIME = true;
				    break;
				}

	this._draw('frm_certificate', 'main', aOut);

	// Create 'OK' button
	this._create('btn_ok', 'obj_button', 'footer');
	this.btn_ok._value('FORM_BUTTONS::OK');
    this.btn_ok._tabindex(5000);
	this.btn_ok._onclick = function() {
		me._destruct();
	};

	this.btn_ok._focus();
};