_me = frm_compose.prototype;
function frm_compose(){};

_me.__constructor = function(oMessage) {

	//default size - this line has to be presented after all elements of a window are created
	this._defaultSize(-1,-1,800,500);
	
	var me = this;

	this.__bDisableSave = false;
	this.__bContactsOpened = false;  //addContacts are opened
	this.__logoutOnDestruct = false; //try to logout on compose destruct

	this.__message = oMessage;

	//email je otevren z drafts
	if (!this.__message.__id)
		this.__removeOnDestruct = true;

	this._title('COMPOSE::NEWMAIL');

	// Load mail settings
	storage.library('gw_others');
	this._aSettings = GWOthers.get('MAIL_SETTINGS_DEFAULT','storage');

	/*** TOP MENU ***/
	this._create('menu','obj_hmenu','header','compose_menu');
	
	this._create('select','obj_select','header','obj_composeselect');
	this.select._fillLang({'html': "COMPOSE::HTML", 'text': "COMPOSE::TEXT"});
	this.select._onchange = function() {
		if (this._value() == 'html')
			me.body._disable(false);
		else
			me.body._disable(true);
	};

	this._draw('frm_compose','main',{disable_ab:sPrimaryAccountGW<1,disable_sa:sPrimaryAccountGW<1 || GWOthers.getItem('RESTRICTIONS', 'disable_smart')>0});

	if (this.att_type)
		this.att_type._value(this._aSettings['VALUES'].smart_attach>0?'1':'0');


	//Load headers
	function sendme(e){
		if (e.ctrlKey)
			me.__send(false, false); return false;
	};
	
	this.to._value(this.__message.sTo);
	this.to.__eIN.tabIndex = 1;
	this.to._onsubmit = sendme;
	this.cc._value(this.__message.sCc);
	this.cc.__eIN.tabIndex = 2;
	this.cc._onsubmit = sendme;
	this.bcc._value(this.__message.sBcc);
	this.bcc.__eIN.tabIndex = 3;
    this.bcc._onsubmit = sendme;
	this.subject._value(this.__message.sSubject);
	this.subject.__eIN.tabIndex = 5;
	this.subject._onsubmit = sendme;

    if (sPrimaryAccountSMS && GWOthers.getItem('RESTRICTIONS', 'disable_sms')<1){

		this.sms._onsubmit = sendme;
		this.sms.__eIN.tabIndex = 4;
		if (this.__message.sSMS){
		    this._aSettings.VALUES.sms = 1;
			removecss(me._getAnchor('composetable'),'nosms');

			if (this.__message.sSMS!==true)
				this.sms._value(this.__message.sSMS);
		}

       	this.smsinfo._value(getLang('COMPOSE::SMS_INFO',[0,0]));
		this.body._onkeyup = function(evn){
			if (me._aSettings.VALUES.sms){

				var elm = mkElement('div'),
					pre = me._getAnchor('preview'),
					tmp = this.__eFrame.contentWindow.document.getElementsByTagName('body')[0].innerHTML;

			    tmp = tmp.replace(/[\r\n]/g,'').replace(/(<(div|br|td|p|h[1-6])[ >])/gi,"¤¤$1");
			    elm.innerHTML = tmp;

				//for MSIE
				if (typeof elm.textContent == 'undefined')
					tmp = elm.innerText;
				//Others
				else
					tmp = elm.textContent;
					
				tmp = tmp.trim();
                tmp = tmp.replace(/(^\¤+)|(\¤+$)/,'');
                
                if (me.subject._value())
                	tmp = me.subject._value()+(tmp?'¤¤'+tmp:'');

				var c, bSmall = false;
				for (var i = tmp.length-1;i>-1;i--){
                    c = tmp.charCodeAt(i);
					if (c != 0xA4 && c!=GSM0338_To_Unicode_Charset[c]){
						bSmall = true;
						break;
					}
				}

				var n = bSmall?70:160;
				if (tmp.length/n>1)
                    n = bSmall?67:153;

				c = Math.ceil(tmp.length/n);
				me.smsinfo._value((c>5?'<b>':'') + getLang('COMPOSE::SMS_INFO',[tmp.length,c])+ (c>5?'</b>':''));

				tmp = tmp.escapeHTML();
				pre.getElementsByTagName('P')[0].innerHTML = tmp.replace(/\¤\¤/g,'<br>');
				
				pre.scrollTop = pre.scrollHeight-pre.clientHeight;

                tmp = null;
				pre = null;
				elm = null;
			}
		};
	}

	// SAVE (Ctrl+S) shortcut handler
	this.__eContainer.onkeydown = function(e){
		var e = e || window.event;

		if (e.ctrlKey){
			if(e.keyCode == 83 || e.keyCode == 13){
				if (e.preventDefault)
					e.preventDefault();
				else
				if (e.cancelBubble)
					e.cancelBubble = true;

				if (e.keyCode == 83)
					me.__save();
				else
					me.__send(false, false);

				return false;
			}
		}

		return true;
	};

	this.menu._onclick = function(e,elm,id,arg){
		switch(arg){
		case 'send':
			me.__send(false, false);
			break;
		case 'save':
			me.__save();
			break;

		case 'priority_3':
			me._aSettings.VALUES.priority = 4;
			me.__updateMenu();
			break;
		case 'priority_2':
			me._aSettings.VALUES.priority = 3;
			me.__updateMenu();
			break;
		case 'priority_1':
			me._aSettings.VALUES.priority = 2;
			me.__updateMenu();
			break;

		case 'encrypt':
			me._aSettings.VALUES.encrypt = me._aSettings.VALUES.encrypt>0?0:1;
			me.__updateMenu();
			break;
		case 'sign':
			me._aSettings.VALUES.sign = me._aSettings.VALUES.sign>0?0:1;
			me.__updateMenu();
			break;

		case 'sms':
			me._aSettings.VALUES.sms = me._aSettings.VALUES.sms?0:1;
			if (me._aSettings.VALUES.sms){
				me.body._onkeyup();
				removecss(me._getAnchor('composetable'),'nosms');
				me.sms._focus(true);
			}
			else
				addcss(me._getAnchor('composetable'),'nosms');

			me.__updateMenu();
			break;

		case 'options':
			if (me.frmsettings && !me.frmsettings._destructed)
				me.frmsettings._focus();
			else
				me.frmsettings = gui._create('mail_settings', 'frm_mail_settings', '', '', me._aSettings, true, [me, '__onSettings']);

			break;
		}
	}
	this.__updateMenu();

	this.body._onkeydown = function(e){
		switch(e.keyCode){
		case 13:
			if (!e.ctrlKey) return true;
			me.__send(false, false);
			return false;
		case 83:
			if (!e.ctrlKey) return true;
			me.__save();
			return false;
		case 27:
			if (me._onclose && me._onclose()) me._destruct();
		}
	};

	this.body.__getSpellLang = function(){
		return me._aSettings.VALUES.spellchecker || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','spellchecker');
	};
	//iframe focus
	this.body.__doc.onmousedown = function(){
		me._focus();
	};

	// Load mail settings
/*
	storage.library('gw_others');
	this._aSettings = GWOthers.get('MAIL_SETTINGS_DEFAULT','storage');
*/
	this._aMailSettingsGeneral = GWOthers.get('MAIL_SETTINGS_GENERAL','storage');

	/******************/

	if (sPrimaryAccountGW>0){
		function btn(e) {

			if (me.__bContactsOpened)
				return;

			var id = this.id.substr(me._pathName.length);
			if (id == 'btn_sms'){
				var aTabsNames = {'sms': "DATAGRID_ITEMS_VIEW::PHONE"};
				var aTabsValues = {'sms': me.sms._value()};

				gui._create('add_address', 'frm_addaddress', '', '', [me, '__onPopupClose'], aTabsNames, aTabsValues, 'sms', false, ['L']);
			}
			else{
				var aTabsNames = {'to': "DATAGRID_ITEMS_VIEW::TO", 'cc': "DATAGRID_ITEMS_VIEW::CC", 'bcc': "DATAGRID_ITEMS_VIEW::BCC"};
				var aTabsValues = {'to': me.to._value(), 'cc': me.cc._value(), 'bcc': me.bcc._value()};

				switch(id) {
					case 'btn_to': gui._create('add_address', 'frm_addaddress', '', '', [me, '__onPopupClose'], aTabsNames, aTabsValues, 'to', true); me.__bContactsOpened = true; break;
					case 'btn_cc': gui._create('add_address', 'frm_addaddress', '', '', [me, '__onPopupClose'], aTabsNames, aTabsValues, 'cc', true); me.__bContactsOpened = true; break;
					case 'btn_bcc': gui._create('add_address', 'frm_addaddress', '', '', [me, '__onPopupClose'], aTabsNames, aTabsValues, 'bcc', true); me.__bContactsOpened = true; break;
				}
			}
		}

		this._getAnchor('btn_to').onclick = btn;
		this._getAnchor('btn_cc').onclick = btn;
		this._getAnchor('btn_bcc').onclick = btn;
		this._getAnchor('btn_sms').onclick = btn;
	}

	/******************/

	this.select._value(this.__message.isHtml() ? 'html' : 'text');

	//Copy subject into window title
	this.subject._onkeyup = function(){
		var sTitle = this._value();
		if (sTitle){
			if (sTitle.length>48)
				sTitle = sTitle.substr(0,48)+'...';

			me._title(sTitle,true);
		}
		else
			me._title('COMPOSE::NEWMAIL');
			
        if (me._aSettings.VALUES.sms)
			me.body._onkeyup();
	};
	this.subject._onkeyup();

	//Meanwhile FOCUS solution
	this.ecatch.__eIN.tabIndex = 5;
	this.ecatch._onfocus = function(){
		me.body._focus(true);
	};



	this.attach._value(this.__message.aAttachments);
	this.body._value(this.__message.sBody);

	this.attach._onuploadstart = function(){
        me.__updateMenu(true);
	};

	this.attach._onuploadend = function(){
        me.__updateMenu();
        
        /*
		me.menu._fill([
			{"title":'COMPOSE::SEND',"arg": 'send'},
			{"title":'COMPOSE::SAVE',"arg": 'save'},
			{"title":'COMPOSE::OPTIONS',"arg": 'options'}
			]);
			*/
	};

	this._onclose = function() {

		if (!me.__bDisableSave && (me.__changed() || (me.__removeOnDestruct && me.__message.__id))) {
			//bring frm to front
			me._focus();
			//call save confirmation
			if (!dataSet.get('main',['sid'])){
				try{
					var cnf = gui._create('frm_confirm','frm_confirm', '','', [me, '__confirmed'], 'CONFIRMATION::EXPIRED','CONFIRMATION::EXPIRED_MSG');
				}
				catch(r){
					inspect2(r);
				}
			}
			else
			if (!this.cdialog || this.cdialog._destructed){
				this.cdialog = gui._create('frm_confirm','frm_confirm_threestates', '','', [me, '__confirmed'], 'CONFIRMATION::SAVE_TITLE','CONFIRMATION::SAVE_CONFIRMATION', '','CONFIRMATION::SAVE','CONFIRMATION::DONTSAVE');
				this.cdialog.btn_cancel2._onclick = function() {
					//me.__logoutOnDestruct = false;
					this._parent._destruct();
				};
			}
			else
				this.cdialog._focus();
			

			return false;
		}
		else
			return true;
	};

	this._bAutoSave = parseInt(this._aMailSettingsGeneral['VALUES']['autosave']);
	this._nAutoSaveInterval = parseInt(this._aMailSettingsGeneral['VALUES']['autosave_minutes'])*60000;

	if (this._bAutoSave && this._nAutoSaveInterval)
		setTimeout('try{'+this._pathName+'.__autoSave()}catch(e){}',this._nAutoSaveInterval);

	this._add_destructor('__onDestruct');

	this.__rememberState();

	if (oMessage){
		if (oMessage.sTo || (oMessage.sSMS && oMessage.sSMS!==true))
			this.body._focus(true, true);
		else
		if (oMessage.sSMS===true)
			this.sms._focus();
		else
			this.to._focus();
	}
	else
		this.to._focus();
};

_me.__updateMenu = function(bUpload){

	var sPriority = '';
	switch(parseInt(this._aSettings.VALUES.priority)){
	case 1:
	case 2:
		sPriority = 'HIGH';
		break;
	case 3:
		sPriority = 'NORMAL';
		break;
	case 4:
	case 5:
		sPriority = 'LOW';
		break;
	}

	var aData = [
		{"title":'COMPOSE::SEND',"arg": 'send',"disabled":bUpload || false},
		{"title":'COMPOSE::SAVE',"arg": 'save',"disabled":bUpload || false},
		{"title":'COMPOSE::OPTIONS',"arg": 'options'},
		{"title":'-'},
		{"title":'EMAIL_PRIORITY::'+sPriority, "css":'ico_priority_'+sPriority.toLowerCase(),
		nodes:[
			{"title":'EMAIL_PRIORITY::HIGH',"arg": 'priority_1', "css":'ico_priority_high'},
			{"title":'EMAIL_PRIORITY::NORMAL',"arg": 'priority_2', "css":'ico_priority_normal'},
			{"title":'EMAIL_PRIORITY::LOW',"arg": 'priority_3', "css":'ico_priority_low'}
		]},
		{"title":'-'},
		{"title":'SETTINGS::ENCRYPT',"arg": 'encrypt', "css": this._aSettings.VALUES.encrypt>0?'active':''},
		{"title":'SETTINGS::SIGN',"arg": 'sign', "css": this._aSettings.VALUES.sign>0?'active':''}
	];
	

	if (sPrimaryAccountSMS && GWOthers.getItem('RESTRICTIONS', 'disable_sms')<1)
		aData.push({"title":'-'},{"title":'COMPOSE::SMS',"arg": 'sms',"css":this._aSettings.VALUES.sms?'active':''});

	this.menu._fill(aData);
};

_me.__onDestruct = function() {
	if (this.__removeOnDestruct && this.__message.__id)
		Item.remove(makeIDSFromID(this.__message.__id), true);

	this.__message.dispose();
};

_me.__autoSave = function() {
	if (this._destructed)
		return;

	if (!this.__bDisableSave && this.__changed())
		this.__save(true);

	setTimeout('try{'+this._pathName+'.__autoSave();}catch(e){}',this._nAutoSaveInterval);
};

_me.__onSettings = function(aValues) {
	for(var i in aValues)
		this._aSettings['VALUES'][i] = aValues[i];

	this.__updateMenu();
};

_me.__rememberState = function() {
	this.__sSavedTo = this.to._value();
	this.__sSavedCc = this.cc._value();
	this.__sSavedBcc = this.bcc._value();
	this.__sSavedSubject = this.subject._value();

	this.__sSavedAtt = [];
	if (this.__message.aAttachments){
		var tmp = this.__message.aAttachments.attachments;
		for (var i in tmp)
			this.__sSavedAtt.push(tmp[i].values || tmp[i]);
	}

	this.__sSavedBody = this.body._value();
};

_me.__changed = function() {
	var att = this.attach._value();
	if (att && (att = att.attachments) && !arrayCompare(att,this.__sSavedAtt))
		return true;

	return this.__sSavedTo != this.to._value() || this.__sSavedCc != this.cc._value() || this.__sSavedBcc != this.bcc._value() || this.__sSavedSubject != this.subject._value() || this.__sSavedBody != this.body._value();
};

_me.__confirmed = function(bSave) {
	if (bSave)
		this.__save();

	this.__bDisableSave = true;
	this._destruct();

	//we need to call confirms in all opened compose windows before logout
	if (this.__logoutOnDestruct && gui.frm_main)
		gui.frm_main.__logout();
};

_me.__send = function(bSave, bKeepAttachments) {

	if (this.__bDisableSand) return;
	
	this.__bDisableSand = true;
	this.__bDisableSave = false;

	this.__message.sTo = this.to._value();
	this.__message.sCc = this.cc._value();
	this.__message.sBcc = this.bcc._value();

	if (this._aSettings.VALUES.sms)
		this.__message.sSMS = this.sms._value();

	this.__message.sSubject = this.subject._value();
	this.__message.aAttachments = this.attach._value();
	this.__message.sBody = this.body._value();

	var bHtml = (this.select._value() == 'html') ? true : false;

	this.__message.setHtml(bHtml);


    if (this.att_type)
		this._aSettings['VALUES'].smart_attach = parseInt(this.att_type._value());
	else
		this._aSettings['VALUES'].smart_attach = 0;

	if (bSave) {
		if (!this.__message.save(bKeepAttachments, [this, '__messageSaved'],this._aSettings['VALUES']))
			alert(getLang('ALERTS::MESSAGE_NOT_SAVED'));
		else
			this.__bDisableSave = true;
	}
	else {
		if (GWOthers.getItem('RESTRICTIONS', 'disable_personalities')>0)
			this._aSettings.VALUES.from = getPrimaryAccountFromAddress();

		if (this.__message.send(bKeepAttachments, [this, '__messageSent'], this._aSettings['VALUES'])){
			this.__hide();
			return;
		}
	}

	this.__bDisableSand = false;
};

_me.__save_recipients = function(){

	var rcp = (this.__message.sTo || '') +';'+ (this.__message.sCc || '') +';'+ (this.__message.sBcc || '');

	if (!rcp) return;   //!this.__bDisableSave ||

	//clean duplicity
	function clean(emails){
		for(var i = emails.length-1;i>=0;i--){
			if (emails[i].email){
				for(j = i-1;j>=0;j--){
					if (emails[j].email && emails[i].email.toLowerCase() == emails[j].email.toLowerCase()){
						emails.splice(i,1);
						break;
					}
				}
			}
			else
				emails.splice(i,1);
		}

		return emails;
	};

	var emails = clean(MailAddress.splitEmailsAndNames(rcp).reverse());

	if ((rcp = Cookie.get(['suggest_address']))){
		emails = emails.concat(MailAddress.splitEmailsAndNames(rcp));
		emails = clean(emails);
	}

	emails = emails.slice(0,10);

	var out = '';
	for(var i=0;i<emails.length;i++)
		out += (out.length>0?';':'')+(emails[i].email.indexOf('[')==0?emails[i].email:MailAddress.createEmail(emails[i].name,emails[i].email));

	Cookie.set(['suggest_address'],out);
};

_me.__messageSaved = function(bOK, bFirstTime) {

	/*
	stejne se nic nestane protoze email je precteny
	if (bOK && bFirstTime){
		folders.list({'aid':sPrimaryAccount},'folders');
	}
	*/

	if (this._destructed)
		return;

	if (bOK)
		this.__rememberState();
	else
		alert(getLang('ALERTS::MESSAGE_NOT_SAVED'));

	this.__bDisableSave = false;
};

_me.__messageSent = function(bOK, sUID, sError)
{
	if (this._destructed)
		return;

	this.__save_recipients();

	if (bOK){
		this.__bDisableSave = true;
		this._destruct();
	}
	else {
		var sErrOut = '';

		this.__show();

		this.__bDisableSave = false;
		this.__bDisableSand = false;
		
		switch (sUID) {
			case 'SMTP_from_failed':
			case 'SMTP_recipients_failed':
				sErrOut = getLang('ALERTS::MESSAGE_NOT_SENT') + '\n\n' + getLang('ALERTS::'+sUID.toUpperCase());
				break;

			case 'SMTP_data_not_accepted':
				sErrOut = getLang('ALERTS::MESSAGE_NOT_SENT') + '\n\n' + getLang('ALERTS::'+sUID.toUpperCase());
				break;

			default:
				sErrOut = getLang('ALERTS::MESSAGE_NOT_SENT')+'\n';
		}

		if (sError)
			sErrOut += "\n"+ sError.unentityify();

		alert(sErrOut);
	}
	
	return false;
};

_me.__onPopupClose = function(bOK, aAddresses)
{
	if (bOK){
		if (aAddresses['sms'])
			this.sms._value(aAddresses['sms'].join(', '));
		else{
			this.to._value(aAddresses['to'].join(', '));
			this.cc._value(aAddresses['cc'].join(', '));
			this.bcc._value(aAddresses['bcc'].join(', '));
		}
	}

	this.__bContactsOpened = false;
};

_me.__save = function(bAuto) {

	if (this._destructed)
		return false;

	if (!bAuto)
		this.__removeOnDestruct = false;

	if (!this.__bDisableSave && this.__changed())
		this.__send(true, true);

	return true;
};