_me = frm_im_gateways.prototype;
function frm_im_gateways(){};

_me.__constructor = function(xmpp,sGroup) {
	var me = this;

	this._defaultSize(-1,-1,500,350);
	
	this._title('IM::ADD_GATEWAY');

	this._create('grid','obj_datagrid');
	this.grid.__sortColumn = 'name';
	this.grid._addColumns({
		'name':{title:"DATAGRID_ITEMS_VIEW::NAME",width:200,arg:{sort:'asc'}},
		'jid':{title:"IM::JABBER_ID",width:200,arg:{sort:'asc'}},
		'type':{title:"DATAGRID_ITEMS_VIEW::TYPE",width:80,arg:{sort:'asc'}}
	});

	// Create 'REGISTR' button
	this._create('reg','obj_button','footer','footer');
	this.reg._value('IM::REGISTR');
	this.reg._tabindex(5001);
	this.reg._onclick = function (){
		var v = me.grid._value();
		if (v && v[0] && me.grid._aData[v[0]])
			gui._create('addgtw','frm_im_addgtw','','',xmpp,me.grid._aData[v[0]].id,sGroup);
	};

	// Create 'CANCEL' button
	this._create('btn_cancel', 'obj_button', 'footer');
	this.btn_cancel._value('FORM_BUTTONS::CANCEL');
	this.btn_cancel._tabindex(5001);
	this.btn_cancel._onclick = function() {
		me._destruct();
	};

	this.grid._ondblclick = function(){
		me.reg._onclick();
	};

	//Load Gateways
	xmpp.gateway_list(dataSet.get('main',['domain']),[this,'_refresh']);
};

_me._refresh = function(aResponse){
/*
 [QUERY]
.. [0]
.... [ITEM]
...... [0]
........ [ATTRIBUTES]
.......... [JID](string) = 007guard.com
.......... [CATEGORY](string) = gateway
.......... [TYPE](string) = icq
.......... [NAME](string) = 007guard.com
.... [ATTRIBUTES]
...... [XMLNS](string) = http://jabber.org/protocol/disco#items
 [ATTRIBUTES]
.. [TYPE](string) = result
.. [ID](string) = 7806114882435644001244646523706
.. [FROM](string) = merakdemo.com
.. [TO](string) = admin@merakdemo.com/Webmail
*/
	if (aResponse && aResponse.ATTRIBUTES && aResponse.ATTRIBUTES.TYPE == 'result'){
		var aData = [];
		for (var i in aResponse.QUERY[0].ITEM)
			if (aResponse.QUERY[0].ITEM[i].ATTRIBUTES.CATEGORY == 'gateway')
				aData.push({
				id:aResponse.QUERY[0].ITEM[i].ATTRIBUTES.JID,
				data:{
				'name':aResponse.QUERY[0].ITEM[i].ATTRIBUTES.NAME,
				'jid':aResponse.QUERY[0].ITEM[i].ATTRIBUTES.JID,
				'type':aResponse.QUERY[0].ITEM[i].ATTRIBUTES.TYPE
				}});

		this.grid._serverSort(aData);
	}
};