_me = frm_settings.prototype;
function frm_settings(){};

_me.__constructor = function()
{
	var me = this;

	this._defaultSize(-1,-1,780,470);

	this._title('MAIN_MENU::OPTIONS');

	storage.library('wm_storage');
	storage.library('gw_others');
	storage.library('gw_holidays');

	this._others = new gw_others;
	this._holidays = new gw_holidays;
	this._holidaysUId = [];

	//Načteni potřebných resource
	var aRsc = [
		'skins',
		'autoresponder',
		'forwarder',
		'certificate',
		'antispam',
		'languages',
		'spellchecker_languages',
		'restrictions',
		'signature',
		'personalities',
		'read_confirmation',
		'gw_mygroup',
		'sip',
		'default_folders'
	];

	if (sPrimaryAccountGW>0)
		aRsc.push('holidays');

	if (sPrimaryAccountIM>0)
		aRsc.push('im');

	WMStorage.get({'resources': aRsc},'storage','',[this,'__loadItems'],true);

	this._curLanguage = GWOthers.getItem('LAYOUT_SETTINGS', 'language');

	//storeDataFromFormular
	this.x_btn_ok._onclick = function(){
		me.__saveItems();
		if (GWOthers.getItem('LAYOUT_SETTINGS', 'language') != me._curLanguage)
			alert(getLang('LANGUAGES::ONCHANGE_INFO'));
	}
};

/*
_me.__onPopupCloseSharedAccounts = function(bOK,aAddresses)
{
	if (bOK)
	{
		var sMail,aArg = [];

		for (var i in aAddresses[0]){
			sMail = MailAddress.splitEmailsAndNames(aAddresses[0][i])[0].email;
			if (sMail) aArg.push({'email':sMail});
		}
			
		this.maintab.gw_settings.maintab.shared_accounts.emailslist._add(aArg);
	}
	// TODO: allow only one instance of frm_addaddress
};

_me.__onPopupCloseFriends = function(bOK,aAddresses)
{
	if (bOK)
	{
		var tmp = [];

		if (aAddresses[4] && aAddresses[4].length){
			for(var i in aAddresses[3])
				if (inArray(aAddresses[4],aAddresses[3][i])>-1)
				    aAddresses[3].splice(i,1);

			tmp = tmp.concat(aAddresses[4],aAddresses[3]);
		}
		else
  			tmp = tmp.concat(aAddresses[3]);
  			
		if (tmp.length){
			for(var i in aAddresses[2])
				if (inArray(tmp,aAddresses[2][i])>-1)
				    aAddresses[2].splice(i,1);
		}
		tmp.concat(aAddresses[2]);

		if (tmp.length)
			for(var i in aAddresses[1])
				if (inArray(tmp,aAddresses[1][i])>-1)
				    aAddresses[1].splice(i,1);

		var aArg = [],r = ['0','3','4','1','2'];
        for (var i in aAddresses)
			for (var j in aAddresses[i])
				aArg.push({'usremail':aAddresses[i][j],'usrfriend':r[i]});

		this.maintab.gw_settings.maintab.my_friends.friends_list._add(aArg);
	}
	// TODO: allow only one instance of frm_addaddress
};
*/
_me.__loadItems = function()
{
	var me = this;

    var drw_arr = {
		'settings':true,
		'im_access':sPrimaryAccountIM>0 && GWOthers.getItem('RESTRICTIONS', 'disable_im')<1?true:false,
		'sip_access':sPrimaryAccountSIP>0 && GWOthers.getItem('RESTRICTIONS', 'disable_sip')<1?true:false,
		'esip_access':sPrimaryAccountSIP>0 && GWOthers.getItem('RESTRICTIONS', 'disable_esip')<1?true:false,
		'gw_access':sPrimaryAccountGW>0,
		'disable_forwarder':GWOthers.getItem('RESTRICTIONS', 'disable_forwarder')>0,
		'disable_antispam':GWOthers.getItem('RESTRICTIONS', 'disable_antispam')>0,
		'disable_personalities':GWOthers.getItem('RESTRICTIONS', 'disable_personalities')>0};
		
	var gw_types = GWOthers.getItem('RESTRICTIONS', 'disable_gw_types') || '';

	var regex = /[cejntf]{6}/g;
	if (sPrimaryAccountGW>0 && gw_types && regex.test(gw_types))
    	drw_arr.gw_access = false;

    if (drw_arr.gw_access){
		drw_arr.gw_c = (gw_types.indexOf('c')<0);
		drw_arr.gw_e = (gw_types.indexOf('e')<0);
		drw_arr.gw_j = (gw_types.indexOf('j')<0);
		drw_arr.gw_n = (gw_types.indexOf('n')<0);
		drw_arr.gw_t = (gw_types.indexOf('t')<0);
		drw_arr.gw_f = (gw_types.indexOf('f')<0);
	}

	this._draw('frm_settings','main',drw_arr);

	// ********************************************
	// MAILSETTINGS
	
	this.maintab.mail_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;
		
		var oTab = this.maintab;
	
		// TAB1 - GENERAL
		oTab.general._onactive = function (bFirstTime) {
			if (bFirstTime) {
				//flag colors
				this.default_flag._fillLang({
					'1':["COLOR_LABELS::RED_FLAG",'bg_red'],
					'2':["COLOR_LABELS::BLUE_FLAG",'bg_blue'],
					'3':["COLOR_LABELS::GREEN_FLAG",'bg_green'],
					'5':["COLOR_LABELS::ORANGE_FLAG",'bg_orange'],
					'8':["COLOR_LABELS::PURPLE_FLAG",'bg_purple'],
					'a':["COLOR_LABELS::YELLOW_FLAG",'bg_yellow']
				});

				var aData = me._others.get('MAIL_SETTINGS_GENERAL','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		}
		
		// TAB2 - DEFAULT
		oTab.mail_default._onactive = function (bFirstTime) {

            //Alias
			if (this.from){
				var aData = {};
				    aData[''] = getPrimaryAccountFromAddress();

				var aPers;
				if (this._parent.personalities && this._parent.personalities.persons && (aPers = this._parent.personalities.persons._value())){
					var out = [];
					if (count(aPers)>0)
						for(var i in aPers)
							if (aPers[i].person)
	                            aData[aPers[i].person] = aPers[i].person;
	            }
	            else{
					aPers = dataSet.get('storage',['PERSONALITIES','ITEMS']);
					for(var i in aPers)
						aData[aPers[i].VALUES.PERSON.VALUE] = aPers[i].VALUES.PERSON.VALUE;
				}
	            this.from._fill(aData);
            }

			if (bFirstTime) {
				//spellchecker default lang
				var aLang = dataSet.get('storage',['SPELLCHECKER_LANGUAGES','ITEMS']);
				var aData = {};
				for (var i in aLang)
					if (aLang[i].VALUES && aLang[i].VALUES.PATH && aLang[i].VALUES.NAME)
						aData[aLang[i].VALUES.PATH.VALUE] = aLang[i].VALUES.NAME.VALUE;

				this.spellchecker._fill(aData);

				var aData = me._others.get('MAIL_SETTINGS_DEFAULT','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);

				//default value for FROM
				if (this.from && !this.from._value())
					this.from._value('');
			}
		};
		
		// TAB4 - AUTORESPONDER
		oTab.autoresponder._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aResponder = me._others.get('AUTORESPONDER','storage');
				var from = aResponder['VALUES']['u_respondbetweenfrom'].split('/');

				aResponder['VALUES']['u_respondbetweenfrom'] = getJulianDate(from[2], from[1], from[0]);
				var to = aResponder['VALUES']['u_respondbetweento'].split('/');
				aResponder['VALUES']['u_respondbetweento'] = getJulianDate(to[2], to[1], to[0]);
				this.autoresponder._value(aResponder);
			}
		}
		
		// TAB5 - FORWARDER
		if (oTab.forwarder)
		oTab.forwarder._onactive = function (bFirstTime) {
			if (bFirstTime) {
				// init
				var oForwarder = this;

				this.u_forwardolder._onclick = function() {
					oForwarder.u_forwardolderdays._disabled(!this._value());
					oForwarder.u_forwardolderto._disabled(!this._value());
				};
				
				this.u_forwardto._onkeyup = function(){
					if (this._value()==''){
						oForwarder.u_null._disabled(1);
						oForwarder.u_null._value(0);
					}
					else
						oForwarder.u_null._disabled(0);
				};

				// load values
				var aForwarder = me._others.get('FORWARDER','storage');
				if (typeof aForwarder == 'object')
					loadDataIntoFormOnAccess(this,aForwarder);
				
				//test null checkbox
				this.u_forwardto._onkeyup();
				
				this.u_forwardolder._onclick();
			}
		}
		
		// TAB6 - READ CONFIRMATION
		oTab.readconfirmation._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = me._others.get('READ_CONFIRMATION','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		}
		
		// TAB7 - SIGNATURE
		oTab.signature._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = me._others.get('SIGNATURE','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		}

		// TAB8 - PERSONALITIES
		if (oTab.personalities)
		oTab.personalities._onactive = function (bFirstTime) {
			if (bFirstTime) {
                var persons = dataSet.get('storage',['PERSONALITIES','ITEMS']);

				//fill persons
				var tmp = [];
				for(var i in persons)
                	tmp.push({'person':persons[i].VALUES.PERSON.VALUE});

				this.persons._add(tmp);

				//init buttons
				this.x_add._onclick = function(){
					var s = (this._parent.x_personality._value() || '').trim();

					if (!s) return;

					var aEmail = MailAddress.splitEmailsAndNames(s);
						s = MailAddress.createEmail(aEmail[0].name,aEmail[0].email);

					if (!s) return;
					
					//domains are unigue
					var old = this._parent.persons._value();
					for(var i in old)
						if(old[i].person == s) return;

					this._parent.persons._add([{'person':s}]);
					
					this._parent.x_personality._value('');
					this._parent.x_personality._focus();
				};
				
				this.x_personality._onsubmit = function(){
					this._parent.x_add._onclick();
				};

				this.x_remove._onclick = function(){
					this._parent.persons._removeSelected();
				};
			}
		}
		// force drawing first tab
		oTab.general._onactive(true);
	};

	// ********************************************
	// IM SETTINGS
	if (this.maintab.im_settings)
		this.maintab.im_settings._onactive = function (bFirstTime) {
			if (!bFirstTime)
				return;

			var oTab = this.maintab;

			oTab.general._onactive = function (bFirstTime) {
                if (bFirstTime){
					var aData = me._others.get('IM','storage');
					if (typeof aData == 'object')
						loadDataIntoFormOnAccess(this,aData);
				}
			};

			oTab.chat._onactive = function (bFirstTime) {
                if (bFirstTime){
					var aData = me._others.get('IM','storage');
					if (typeof aData == 'object')
						loadDataIntoFormOnAccess(this,aData);
				}
			};
			
			// force drawing first tab
			oTab.general._onactive(true);
		};
	
	// ********************************************
	// SIP SETTINGS
	if (this.maintab.sip_settings)
		this.maintab.sip_settings._onactive = function (bFirstTime) {
            if (bFirstTime){

            	if (this.external)
					this.external._onchange = function(){
						var b = !this._value();
						this._parent.user._disabled(b);
						this._parent.pass._disabled(b);
						this._parent.server._disabled(b);
					};
				
				var aData = me._others.get('SIP','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		};
	
	// ********************************************
	// GENERALSETTINGS
	this.maintab.general_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;

		var oTab = this.maintab;

		// TAB1 - LAYOUT
		oTab.layout._onactive = function (bFirstTime) {
			if (bFirstTime) {
				//LANGs
				var aLang = me._others.get('LANGUAGES','storage');
				var aData = {};
				for (var i in aLang['VALUES'])
					aData[i] = aLang['VALUES'][i];

				this.language._fill(aData);

				if (!aData[me._others.getItem('LAYOUT_SETTINGS','language')])
					 me._others.setItem('LAYOUT_SETTINGS','language',me._others.getDefaultValues('LAYOUT_SETTINGS').LANGUAGE);

				//SKINs
				var aSkin = me._others.get('SKINS','storage');
				var aData = {};
				for (var i in aSkin['VALUES'])
					if (i != 'value')
						aData[i] = aSkin['VALUES'][i];

				this.skin._fill(aData);

				if (!aData[me._others.getItem('LAYOUT_SETTINGS','skin')])
					me._others.setItem('LAYOUT_SETTINGS','skin',me._others.getDefaultValues('LAYOUT_SETTINGS').SKIN);

				//DATE
				this.date_format._fill({
					0:'mm/dd/yy',
					1:'mm/dd/yyyy',
					5:'dd-mm-yy',
					2:'dd-mm-yyyy',
					6:'dd/mm/yy',
					3:'dd/mm/yyyy',
					4:'yyyy-mm-dd',
					7:'dd.mm.yy',
					8:'dd.mm.yyyy'
				});

				aData = me._others.get('LAYOUT_SETTINGS','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		}

		// TAB3 - FOLDER MAPPING
		oTab.folders._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = me._others.get('DEFAULT_FOLDERS','storage');

				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		};

		// force drawing first tab
		oTab.layout._onactive(true);
	}


	// ********************************************
	// CALENDARSETTINGS

	if (this.maintab.calendar_settings)
	this.maintab.calendar_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;

		var oTab = this.maintab;

		// TAB1 - MAIN
		oTab.main._onactive = function (bFirstTime) {

			if (bFirstTime) {
				var me1 = this.calendar;
					me1._wasActivated = true;

				this.gw._wasActivated = true;

				// init
				me1.week_begins._fillLang({
					'sunday': "DAYS::SUNDAY",
					'monday': "DAYS::MONDAY",
					'tuesday': "DAYS::TUESDAY",
					'wednesday': "DAYS::WEDNESDAY",
					'thursday': "DAYS::THURSDAY",
					'friday': "DAYS::FRIDAY",
					'saturday': "DAYS::SATURDAY"
				});
				me1.week_begins._value('sunday');
				    
				var aHours = {};
				for (var i=0; i<24; i++)
					aHours[i] = i.toString() + ':00';
				me1.day_begins._fill(aHours);
				me1.day_ends._fill(aHours);
				
				me1.day_begins._onchange = function (){
					if (parseInt(me1.day_begins._value()) > parseInt(me1.day_ends._value()))
						me1.day_ends._value(me1.day_begins._value());
				};
				
				me1.day_ends._onchange = function (){
					if (parseInt(me1.day_begins._value()) > parseInt(me1.day_ends._value()))
						me1.day_begins._value(me1.day_ends._value());
				};
				
				// load data 1
				var aData = me._others.get('CALENDAR_SETTINGS','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(me1,aData);
					
				// load data 2
				var aData = me._others.get('GW_MYGROUP','storage');
				if (typeof aData == 'object'){
					loadDataIntoFormOnAccess(this.gw,aData);
					/*
					if (aData.VALUES && aData.VALUES.grpsharemode)
						this.gw.x_grpsharemode._value(aData.VALUES.grpsharemode=='C'?1:0);
					*/
				}
			}
		}

		// TAB2 - DEFAULT SETTINGS
        if (oTab.default_settings)
		oTab.default_settings._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = me._others.get('DEFAULT_CALENDAR_SETTINGS','storage');
    			if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		}

		// TAB3 - DEFAULT REMINDER
		if (oTab.default_reminder)
		oTab.default_reminder._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = me._others.get('DEFAULT_REMINDER_SETTINGS','storage');
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this,aData);
			}
		}


		// TAB4 - PUBLIC FOLDERS
		if (oTab.hollidays)
		oTab.hollidays._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aHolidays = me._holidays.get('storage');

				if (typeof aHolidays == 'object')
				{
					me._holidaysUId = [];
					var aHolidayTitles = [];
					var aHolidayValues = [];

					for(var n in aHolidays)
					{
						me._holidaysUId.push(aHolidays[n]['UID']);
						aHolidayTitles.push(aHolidays[n]['NAME']);

						if (aHolidays[n]['SUBSCRIBED'] == 'true')
							aHolidayValues.push(n);
					}
					this.holidays_list._fill(aHolidayTitles);
					this.holidays_list._value(aHolidayValues);
				}
			}
		}

		// force drawing first tab
		oTab.main._onactive(true);
	}

	// ********************************************
	// SECURITYSETTINGS
	
	this.maintab.security_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;

		var oTab = this.maintab;

		// TAB1 - CERTIFICATE
		oTab.certificate2._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = dataSet.get('storage',['CERTIFICATE','ITEMS']),
					tmp,aCerts = {};
					
   				for(var i in aData)
   				    if (aData[i].VALUES && aData[i].VALUES.INFO && aData[i].VALUES.INFO.VALUE){
   				    	tmp = XMLTools.Str2Arr(aData[i].VALUES.INFO.VALUE).INFO[0];

						aCerts[aData[i].ATTRIBUTES.UID] = {
									'name':tmp.SUBJECT[0].CN[0].VALUE,
									'email':tmp.SUBJECT[0].EMAILADDRESS[0].VALUE,
									'expires':tmp.VALIDTO[0].VALUE,
									'data':tmp};
					}

				this.X_CERT._value({'values':aCerts});
			}
		};

		
		// TAB1 - ANTISPAM
		if (oTab.antispam)
			oTab.antispam._onactive = function (bFirstTime) {
				if (bFirstTime) {
					var aData = me._others.get('ANTISPAM','storage');
					if (typeof aData == 'object')
						loadDataIntoFormOnAccess(this,aData);
				}
			}

		// force drawing first tab
		oTab.certificate2._onactive(true);
	}
	
	// ********************************************
	// FINALIZATION

	// force drawing first tab
	this.maintab.mail_settings._onactive(true);
};

_me.__saveItems = function()
{
	var me = this;
	var aValues = {};
	
	function storeNonWellKnown(oForm, sResource) {
		var aValues = {};
		if (oForm._wasActivated) {
			storeDataFromForm(oForm,aValues);
			me._others.set(sResource,aValues,'storage');
		}
	}

	// ********************************************
	// MAILSETTINGS
	if (this.maintab.mail_settings._wasActivated) {
		var oTab = this.maintab.mail_settings.maintab;
		storeNonWellKnown(oTab.general, 'MAIL_SETTINGS_GENERAL');
		storeNonWellKnown(oTab.mail_default, 'MAIL_SETTINGS_DEFAULT');
		storeNonWellKnown(oTab.readconfirmation, 'READ_CONFIRMATION');
		storeNonWellKnown(oTab.signature, 'SIGNATURE');

		// Autoresponder
		if (oTab.autoresponder._wasActivated) {
			aValues = oTab.autoresponder.autoresponder._value();
			
			if (aValues['u_respondbetweenfrom']){
				var from = parseJulianDate(aValues['u_respondbetweenfrom']);
				aValues['u_respondbetweenfrom'] = from['year']+'/'+(from['month']<10?'0'+from['month']:from['month'])+'/'+(from['day']<10?'0'+from['day']:from['day']);
			}

			if (aValues['u_respondbetweento']){
				var to = parseJulianDate(aValues['u_respondbetweento']);
				aValues['u_respondbetweento'] = to['year']+'/'+(to['month']<10?'0'+to['month']:to['month'])+'/'+(to['day']<10?'0'+to['day']:to['day']);
			}

			this._others.set('AUTORESPONDER', aValues, 'storage');
		}

		// Forwarder
		if (oTab.forwarder && oTab.forwarder._wasActivated) {
			aValues = {};
			storeDataFromForm(oTab.forwarder, aValues);
			if (!oTab.forwarder.u_forwardolder._value()) {
				delete aValues['u_forwardolderdays'];
				delete aValues['u_forwardolderto'];
			}
			this._others.set('FORWARDER', aValues, 'storage');
		}

		// Personalities
		if (oTab.personalities && oTab.personalities._wasActivated) {

			var v = oTab.personalities.persons._value(),
				out = [];

			if (count(v)>0)
				for(var i in v)
					if (v[i].person)
						out.push({ATTRIBUTES:{ACCESS:'full',DONT_SEND:false},VALUES:{PERSON:{ATTRIBUTES:{ACCESS:'full'},VALUE:v[i].person}}});

			dataSet.add('storage',['PERSONALITIES','ITEMS'],out,1);
			dataSet.add('storage',['PERSONALITIES','ATTRIBUTES','DONT_SEND'],false,1);
		}
	}

	// ********************************************
	// IM SETTINGS
	if (this.maintab.im_settings && this.maintab.im_settings._wasActivated) {
		var oTab = this.maintab.im_settings.maintab;
		storeNonWellKnown(oTab.general, 'IM');
		storeNonWellKnown(oTab.chat, 'IM');
	}

	// ********************************************
	// SIP SETTINGS
	if (this.maintab.sip_settings && this.maintab.sip_settings._wasActivated)
		storeNonWellKnown(this.maintab.sip_settings, 'SIP');

	// ********************************************
	// GENERALSETTINGS
	if (this.maintab.general_settings._wasActivated) {
		var oTab = this.maintab.general_settings.maintab;
		storeNonWellKnown(oTab.layout, 'LAYOUT_SETTINGS');
		storeNonWellKnown(oTab.folders, 'DEFAULT_FOLDERS');

		//Refresh folders because of new Default folders
		dataSet.update('folders');
	}

	// ********************************************
	// CALENDARSETTINGS
	if (this.maintab.calendar_settings && this.maintab.calendar_settings._wasActivated) {
		var oTab = this.maintab.calendar_settings.maintab;
		storeNonWellKnown(oTab.main.calendar, 'CALENDAR_SETTINGS');

		storeNonWellKnown(oTab.main.gw, 'GW_MYGROUP');
		dataSet.add('storage', ['GW_MYGROUP','ITEMS',0,'VALUES','GRPDAILYEVENTSEMAIL'], {'VALUE':dataSet.get('storage',['GW_MYGROUP','ITEMS',0,'VALUES','GRPREMINDEREMAIL','VALUE']),'ATTRIBUTES':[]}, 1);

		/*
		var old_grpsharemode = dataSet.get('storage', ['GW_MYGROUP','ITEMS',0,'VALUES','GRPSHAREMODE','VALUE']);
		dataSet.add('storage', ['GW_MYGROUP','ITEMS',0,'VALUES','GRPSHAREMODE'], {'VALUE':oTab.main.gw.x_grpsharemode._value()?'C':'A','ATTRIBUTES':[]}, 1);
		if (old_grpsharemode != dataSet.get('storage', ['GW_MYGROUP','ITEMS',0,'VALUES','GRPSHAREMODE','VALUE'])){
			dataSet.add('storage', ['GW_MYGROUP','ATTRIBUTES','DONT_SEND'], false, 1);
			dataSet.add('storage', ['GW_MYGROUP','ITEMS',0,'ATTRIBUTES','DONT_SEND'], false, 1);
		}
		*/
		
		storeNonWellKnown(oTab.default_reminder, 'DEFAULT_REMINDER_SETTINGS');
		storeNonWellKnown(oTab.default_settings, 'DEFAULT_CALENDAR_SETTINGS');

		// gw_holidays
		if (oTab.hollidays && oTab.hollidays._wasActivated) {
			aValues = {};
			storeDataFromForm(oTab.hollidays,aValues);
			aValues = aValues['holidays_list'];

			var aHolidays = {};

			//Procházíme všechny groups a nastavíme jejich subscribed parametr na false
			for(var n in this._holidaysUId)
				aHolidays[this._holidaysUId[n]] = 'false';

			//Nastavíme subscribed parametr na true pouze u zvolených group
			for(var n in aValues)
				aHolidays[this._holidaysUId[aValues[n]]] = 'true';

			this._holidays.set(aHolidays,'storage');
		}
	}
	
	// ********************************************
	// SECURITYSETTINGS
	if (this.maintab.security_settings._wasActivated) {
		var oTab = this.maintab.security_settings.maintab;

		//TAB 1 - certificate
		if (oTab.certificate2._wasActivated) {

			var v = oTab.certificate2.X_CERT._value();

			if (count(v)>0){
			    var out = [], tmp;
				for(var i in v)
					if (v[i].uid)
						out.push({ATTRIBUTES:{ACCESS:'full',DONT_SEND:false,UID:v[i].uid}});
					else
					if (v[i].fullpath){
                        tmp = {ATTRIBUTES:{ACCESS:'full',DONT_SEND:false},VALUES:{FILE:{ATTRIBUTES:{ACCESS:'full'},VALUE:v[i].fullpath}}};
						if (v[i].passphrase)
							tmp.VALUES.PASSPHRASE = {ATTRIBUTES:{ACCESS:'full'},VALUE:v[i].passphrase};
                        
						out.push(tmp);
					}

				dataSet.add('storage',['CERTIFICATE','ITEMS'],out,1);
				dataSet.add('storage',['CERTIFICATE','ATTRIBUTES','DONT_SEND'],false,1);
			}
		}

		//TAB 2 - antispam
		if (oTab.antispam && oTab.antispam._wasActivated)
            storeNonWellKnown(oTab.antispam, 'ANTISPAM');
	}


	//Záloha stávajícího storage
	dataSet.add('tmp_storage','',dataSet.get('storage'));

	//Hromadné posílání povolených změn na server
	var nOK = WMStorage.set({'resources':dataSet.get('storage')},'storage','',[this,'__saveItemsHandler']);

	//Na server se nic neposílá?
	if (nOK == 2)
	{
		dataSet.remove('tmp_storage');
		this._destruct();
	}
	else
		this._main.style.display = "none";
};

_me.__saveItemsHandler = function(bOK)
{
	//Přijal server náš dotaz?
	if (bOK)
	{
		dataSet.remove('tmp_storage');
		this._destruct();
		gui.frm_main._getNew();
	}
	else
	{
		dataSet.add('storage','',dataSet.get('tmp_storage'));
		dataSet.remove('tmp_storage');
		this._main.style.display = "block";
	}
};