_me = obj_connection.prototype;
function obj_connection(){};

/**
 *  Inform user about broken connection
 */
_me.__constructor = function() {
	var me = this;
	this.__buffer = [];
	this.__count = 0;

	// Create 'OK' button
	this.btn_ok._tabindex(5000);
	this.btn_ok._onclick = function() {
		//interval
		me.__count = 0;
		if (typeof me.__interval != 'undefined')
			window.clearInterval(me.__interval);

		me._main.style.display = 'none';

		var tmp;
		while(me.__buffer.length){
            tmp = me.__buffer.shift();
            tmp[0].__failed = false;
			executeCallbackFunction(tmp);
		}
	};

	// Create 'Cancel' button
	this.btn_cancel._tabindex(5001);
	this.btn_cancel._onclick = function() {
		//interval
		me.__count = 0;
		if (typeof me.__interval != 'undefined')
			window.clearInterval(me.__interval);

		me._main.style.display = 'none';

		if (gui._loading)
			for (var i = me.__buffer.length;i>0;i--)
				gui._loading();

		me.__buffer = [];
	};
};

_me._add = function (oResponse){
	this.__count = 30;

	if (typeof this.__interval != 'undefined')
		window.clearInterval(this.__interval);

	this._main.style.display = 'block';

	if (oResponse){
		oResponse[0].__failed = true;
		this.__buffer.push(oResponse);
		this.__interval = window.setInterval('try{'+this._pathName+'._refresh()}catch(r){}',1000);
	}
};

_me._refresh = function (){
	if (this.__count>0)
		this.btn_ok._title(getLang('FORM_BUTTONS::RETRY') + ' ('+ (this.__count--) +')');
	else
		this.btn_ok._onclick();
};