_me = obj_im.prototype;
function obj_im(){};

_me.__constructor = function() {
	var me = this;

	/*
	FFox has issue with onmouseover so we have to create this tooltip object in advance
	otherwise it creates multiple asynchronous requests for .tpl, .xml and .js objects

	This is just temporary solution, should be reported to Mozilla
	*/
	if (currentBrowser() == 'Mozilla')
		storage.object('obj_tooltip');


	this.__activeUser;
	this.__aRoster = [];
	this.__chat = null;

	this.__status = 'offline';
	this.__statusTimeout;
	this.__statusText = '';

	this.__showOffline = Cookie.get(['im','online'])?false:true; //sem dat cookie

	this.__chatQueue = [];

	this.__noRefresh = false;
	this.__doRefresh = false;

	this.inp_status._onfocus = function(){
		if (me.__statusText == this._value())
			this._setRange(0,me.__statusText.length);
	};
	this.inp_status._onkeyup = function(e){
		if (me.__statusTimeout)
			window.clearTimeout(me.__statusTimeout);
	};
	this.inp_status._onsubmit = function (){
		me.__statusText = this._value();
		me.__xmpp.set_status(5, me.__status, me.__statusText, [me,'_response',['status']]);

		this._onblur();
	};
	this.inp_status._onclose = function (){
		me.__hide();
	};
	this.inp_status._onblur = function (){
		me.__hide();
	};

	//test
	storage.library('wm_xmpp');
	this.__xmpp = new wm_xmpp([this,'_response']);


	this.__body = this._getAnchor('body');
	this.__body.onclick = function (e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm != this){
			if (elm.tagName == 'A'){
				var sType = elm.className;
				if ((elm = searchParent(elm,'LI')) && elm.id){
					var id = Path.basename(elm.id);

					switch(sType){
					case 'mssg':
						me._chat(id);
						break;
					case 'mail':
						NewMessage.compose({to:id});
						break;
					case 'vcard':
                        if (me.__xmpp && me.__xmpp.__sid)
							gui._create('frm_im_vcard', 'frm_im_vcard', '', '', id, [me.__xmpp,'vcard']);
						break;
					case 'sip':
						if (me.__xmpp)
							me.__xmpp.vcard(id, '', [me,'__call',[id]]);
						break;
					}
				}

				return;
			}

			if (elm.tagName == 'SPAN')
				elm = searchParent(elm,'LI');
			else
			if (elm.tagName == 'I' || elm.tagName == 'IMG' || elm.tagName == 'A')
			    return;

			if (elm.id){
				var id = elm.id.substr(me._pathName.length+1);
				if (elm.tagName == 'DIV')
					me._open(id);
				else
				if (elm.tagName == 'LI')
					me._activate(Path.basename(id));

				return;
			}
		}

		me._activate();
	};

	this.__body.onmouseover = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;


		if (elm.tagName == 'SPAN' || elm.tagName == 'I' || elm.tagName == 'IMG')
			elm = searchParent(elm,'LI');

		if (elm.tagName == 'LI' && elm.id){
			var id = Path.basename(elm.id);

			if (id == me.__activeUser) {
				if (gui.tooltip && gui.tooltip._check(elm))
					gui.tooltip._destruct();

				return;
			}
			
			if (!gui.tooltip || !gui.tooltip._check(elm)){
				var tmp = dataSet.get('xmpp', ['roster',id]);
				if (tmp){
					var str = '<table><tr><th rowspan="2"><img onload="try{if (this.fileSize>10 || this.naturalWidth>10){ addcss(gui.tooltip._getAnchor(\'body\'),\'im_tooltip2\'); if (gui.tooltip._main.style.left == \'auto\') { var tmp = gui.tooltip._getAnchor(\'arrow\').style;	tmp.left = parseInt(tmp.left)+50; }}}catch(r){}" src="./server/download.php?class=avatar&fullpath='+id+'"></th><td class="im_tooltip_adr"><strong>'+MailAddress.createEmail(tmp.name,id).escapeHTML()+'</strong>'+(tmp.resource?tmp.resource:'')+(tmp.status?'<i>'+tmp.status+'</i>':'')+'</td></tr></table>';
					gui._create('tooltip','obj_tooltip','','im_tooltip',elm,str);
				}
			}
		}
	};

	this.__body.ondblclick = function (e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName == 'SPAN' || elm.tagName == 'I' || elm.tagName == 'IMG')
			elm = searchParent(elm,'LI');
/*
		if (elm.tagName == 'SPAN')
			elm = elm.parentNode;
*/
		if (elm.tagName == 'LI' && elm.id) // && me.__xmpp && me.__xmpp.__sid
			me._chat(Path.basename(elm.id));
	};

	//CONTEXT MENU
	this.__body.oncontextmenu = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName == 'SPAN' || elm.tagName == 'IMG' || elm.tagName == 'I')
			elm = elm.parentNode;

		if (elm.id){
			var aMenu,
				bLogin = !me.__xmpp.__sid,
				id = elm.id.split('/').pop();

			//user's JID
			if (elm.tagName == 'LI'){
				var	aTmp = me._getGroups(),
					aGrp = [{'title':'IM::UNSORTED','arg':{method:'grp_set',grp:'',id:id}},{'title':'-'}];

				for (var i in aTmp)
					if (i != '*')
						aGrp.push({'text':i,'arg':{method:'grp_set',grp:i,id:id}});

				if (aGrp.length>2)
					aGrp.push({'title':'-'});

				aGrp.push({'title':'IM::NEW_GROUP','arg':{method:'grp_new',id:id}});

				aMenu = [
				{'title':'IM::CHAT','arg':{'method':'chat',id:id},disabled:bLogin},
				{'title':'IM::VCARD','arg':{'method':'vcard',id:id},disabled:bLogin},
				{'title':'IM::HISTORY','arg':{'method':'history',id:id},disabled:bLogin},
				{'title':'IM::SEND_MAIL','arg':{'method':'send',id:id}},
				{'title':'IM::SEND_FILE','arg':{'method':'file',id:id},disabled:bLogin},
                {'title':'-'},
				{'title':'IM::CALL','arg':{'method':'call',id:id},disabled:bLogin},
				{'title':'-'},
				{'title':'IM::RENAME','arg':{'method':'user_rename',id:id},disabled:bLogin},
				{'title':'-'},
				{'title':'IM::GROUP',nodes:aGrp,disabled:bLogin},
				{'title':'IM::SUBSCRIPTION',nodes:[
					{'title':'IM::SEND','arg':{method:'sub_add',id:id}},
					{'title':'IM::REQUEST','arg':{method:'sub_get',id:id}},
					{'title':'IM::REMOVE','arg':{method:'sub_remove',id:id}}
				],disabled:bLogin},
				{'title':'-'},
				{'title':'IM::REMOVE','arg':{'method':'user_remove',id:id},disabled:bLogin}
				];
			}
			else
			//group
			if (elm.tagName == 'DIV')
				if (elm == me.__body)
					aMenu = [
						{'title':'IM::ADD','arg':{'method':'user_add'},disabled:bLogin},
						{'title':'IM::ADD_GATEWAY','arg':{'method':'user_gate'},disabled:bLogin}];
				else
				if (elm.id)
					aMenu = [
                    {'title':'IM::GROUPMSG','arg':{'method':'chat',id:'~'+id},disabled:bLogin},
					{'title':'IM::ADD','arg':{'method':'user_add',id:id},disabled:bLogin},
					{'title':'IM::ADD_GATEWAY','arg':{'method':'user_gate',id:id},disabled:bLogin},
					{'title':'-'},
					{'title':'IM::RENAME','arg':{'method':'grp_rename',id:id}, 'disabled':id == '*' || id == '~' || bLogin},
					{'title':'-'},
					{'title':'IM::REM_GRP','arg':{'method':'grp_remove',id:id}, 'disabled':id == '*' || id == '~' || bLogin},
					{'title':'IM::REM_GRPC','arg':{'method':'grp_removec',id:id}, 'disabled':id == '*' || id == '~' || bLogin}
					];


			var cmenu = gui._create("cmenu","obj_context",'','',me);
				cmenu._fill(aMenu);
				cmenu._place(e.clientX,e.clientY);
				cmenu._onclick = function(e,elm,id,arg){
					me._oncontext(e,elm,id,arg);
				};
		}

		return false;
	};

	var aMenu =	[
				{title:'STATUS::OFFLINE',css:'im_offline',nodes:[
					{'title':'STATUS::ONLINE',css:'im_online','arg':{status:'online'}},
					{'title':'STATUS::CHAT',css:'im_chat','arg':{status:'chat'}},
					{'title':'STATUS::AWAY',css:'im_away','arg':{status:'away'}},
					{'title':'STATUS::XA',css:'im_xa','arg':{status:'xa'}},
					{'title':'STATUS::DND',css:'im_dnd','arg':{status:'dnd'}},
					{title:'-'},
					{'title':'STATUS::INVISIBLE',css:'im_invisible','arg':{status:'invisible'}},
					{title:'-'},
					{'title':'STATUS::OFFLINE',css:'im_offline','arg':{status:'offline'}}]
				},
				{title:this.__showOffline?'IM::HIDE':'IM::SHOW','arg':{method:'offline'}}
				];

	this.menu._fill(aMenu);
	this.menu._onclick = function(e,elm,id,arg){
		//Show/Hide offline users
		if (arg.method == 'offline'){

			Cookie.set(['im','online'], me.__showOffline?1:'');
			me.__showOffline = !me.__showOffline;

			this.__aData[1].title = 'IM::' + (me.__showOffline?'HIDE':'SHOW');
			this._fill(this.__aData);
			
			me._fill();
			return;
		}
		else
		if (me.__xmpp && me.__xmpp.__sid){
			if (arg.method == 'vcard'){
				var frm = gui._create('frm_im_vcard', 'frm_im_vcard', '', '', '', [me.__xmpp,'vcard'], me.__xmpp/*[,'vcard']*/);
					frm._modal(true);
					frm = null;
				return;
			}
			if (arg.method == 'user_add'){
				me._add_contact();
				return;
			}
		}

		Cookie.set(['im','status'],arg.status);

		var sStatus = (arg.status == 'online'?'':arg.status);
		me.__status = sStatus;
		if (me.__status != 'offline')
			me.__show();

		//do something
		if (!me.__xmpp.__sid){
			if (arg.status == 'offline')
				return;

			me.__xmpp.login('',[me,'_response',['login1']]);
			
			if (arg.status == 'online')
				return;
		}

		if (arg.status == 'offline'){
			me.__xmpp.logout([me,'_response',['logout']]);
		}
		else{
			me.__xmpp.set_status(5, me.__status, me.__statusText, [me,'_response',['status']]);
		}
	};
	
	this.menu2._fill([
		{title:'IM::VCARD','arg':{'method':'vcard'},'css':'im_vcard'},
		{title:'FORM_BUTTONS::ADD','arg':{'method':'user_add'},'css':'im_add'}
		]);
	this.menu2._onclick = this.menu._onclick;

	//roster
	this._listen('xmpp',['roster']);
	
	this._add_destructor('__onDestruct');

	//autologin
	if (GWOthers.getItem('IM','auto_status')>0){
		var sStat = Cookie.get(['im','status']);
		if (sStat && sStat != 'offline')
			this.menu._onclick('','','',{status:sStat});
	}


	//Drag and Drop
	this.__dndtimer = '';
	this._main.onmousedown = function(e){

		if (me.__dndtimer)
			window.clearTimeout(me.__dndtimer);

		var e = e || window.event;
		if (e.button>1) return;
		var elm = e.target || e.srcElement;

        if (elm.tagName == 'SPAN')
            elm = elm.parentNode;
            
		if (elm.tagName == 'LI' && elm.id){

			var id = elm.id.split('/').pop();

			//fire the event :)
			var x = e.clientX, y = e.clientY;
			me.__dndtimer = setTimeout(function(){
				me.__initdrag(id,'jabber',x,y);
			},500);
		}
	};

	this._main.onmouseup = function(e){
		//stop DnD
		if (me.__dndtimer)
			clearTimeout(me.__dndtimer);
	};

	//Registr Drop
	if (gui.frm_main && gui.frm_main.dnd)
		gui.frm_main.dnd.registr_drop(this,['jabber']);
};

_me.__call = function (aData, id){
    var tel;
	try{
		tel = aData.VCARD[0].TEL[0];
	    if (tel.NUMBER && tel.NUMBER[0].VALUE)
	    	tel = [tel.NUMBER[0].VALUE,id];
	    else
	    if (tel.HOME && tel.HOME[0].VALUE)
	        tel = [tel.HOME[0].VALUE,id];
	    else
	    	tel = [id];
    }
    catch(r){
		tel = [id];
	}

    gui._create('dial','frm_dial','','',id,tel);
};

_me._activate = function (id){
	if (this.__activeUser!=id){
		var elm;
		
		if (this.__activeUser && this.__activeUser!=id && (elm = document.getElementById(this._pathName+'/'+(dataSet.get('xmpp', ['roster',this.__activeUser,'group']) || '*')+'/'+this.__activeUser))){
			removecss(elm,'active','noimage');
			elm.innerHTML = '<span>'+(dataSet.get('xmpp', ['roster',this.__activeUser]).name || this.__activeUser).escapeHTML()+'</span>';
		}

        if (id){
			var tmp = dataSet.get('xmpp', ['roster',id]);
			if (tmp && (elm = document.getElementById(this._pathName+'/'+(tmp.group || '*')+'/'+id))){
				addcss(elm,'active', 'noimage');
				elm.innerHTML += (tmp.status?'<i>'+tmp.status+'</i>':'')+'<img src="./server/download.php?class=avatar&fullpath='+id+'" onload="if (this.fileSize>10 || this.naturalWidth>10) {this.style.marginLeft = 0; this.style.position = \'relative\'; removecss(this.parentNode,\'noimage\');}"><a class="vcard"></a><a class="mail"></a>'+
				(sPrimaryAccountSIP?'<a class="sip"></a>':'')+
				'<a class="mssg"></a>';

				//destruct tooltip
				if (gui.tooltip && gui.tooltip._check(elm))
					gui.tooltip._destruct();
			}
		}

		this.__activeUser = id;
	}
};

_me.__show = function (){
	if (this.__statusTimeout)
		window.clearTimeout(this.__statusTimeout);

	addcss(this._main, 'obj_im_show');

	this.__statusTimeout = window.setTimeout('try{ '+ this._pathName +'.__hide(); }catch(r){}',5000);

};
_me.__hide = function (){
	if (this.__statusTimeout)
		window.clearTimeout(this.__statusTimeout);

	if (this.inp_status._hasFocus())
		this.inp_status.__eIN.blur();
		
	removecss(this._main, 'obj_im_show');
};

_me._is_active = function(){
	return this.__xmpp && this.__xmpp.__sid;
};

_me._add_contact = function(sGroup, sJID, sName){
	gui._create('frm_im_add','frm_im_add','','',[this.__xmpp,'user_add'], sGroup, sJID, sName);
};

_me._open = function (id, bForce){
	var elm = document.getElementById(this._pathName+'/'+id);
	if (elm){
		elm = elm.parentNode;

		if (Cookie.get(['im','roster',id])){
			if (bForce)
				return;

			removecss(elm,'close');
			Cookie.set(['im','roster',id]);
		}
		else{
			addcss(elm,'close');
			Cookie.set(['im','roster',id],1);
		}
	}
};

_me.__onDestruct = function(){
	this.__xmpp.logout();
	dataSet.remove(this._listener,this._listenerPath,true);
};

_me._oncontext = function (e,elm,id,arg){

	if (!arg) return;
	
	switch(arg.method){
	case 'send':
		NewMessage.compose({to:arg.id});
	break;
	case 'file':
		gui._create('im_file','frm_im_file','','',this.__xmpp,arg.id);
	break;
	case 'chat':
		this._chat(arg.id);
	break;
	case 'history':
		gui._create('frm_im_history', 'frm_im_history', '', '', this.__xmpp, arg.id);
	break;
	case 'vcard':
		gui._create('frm_im_vcard', 'frm_im_vcard', '', '', arg.id, [this.__xmpp,'vcard']);
	break;
	case 'sub_add':
		this.__xmpp.user_subscribed(arg.id);
	break;

	case 'sub_get':
		this.__xmpp.user_subscribe(arg.id);
	break;

	case 'sub_remove':
		this.__xmpp.user_unsubscribed(arg.id);
	break;

	case 'user_remove':
		gui._create('frm_confirm', 'frm_confirm', '', '', [this.__xmpp,'user_remove',[[arg.id]]], 'IM::REMOVE','IM::REMOVE_ACCOUNT',[arg.id]);
	break;

	case 'user_gate':
		gui._create('frm_im_gateways','frm_im_gateways','','',this.__xmpp,arg.id=='*' || arg.id=='~'?'':arg.id);
	break;
	
	case 'user_add':
		this._add_contact(arg.id=='*' || arg.id=='~'?'':arg.id);
	break;

	case 'call':
		this.__xmpp.vcard(arg.id, '', [this,'__call',[arg.id]]);
	break;
	
	case 'user_rename':
		var aTmp = dataSet.get('xmpp', ['roster', arg.id]);
		this.__renameInput(document.getElementById(this._pathName+'/'+aTmp.group+'/'+arg.id),aTmp.name || arg.id,[this,'_renameUsrResponse',[arg.id]]);
	break;

	case 'grp_set':
		this._addGroup(arg.grp,arg.id);
	break;

	case 'grp_new':
		gui._create('frm_input','frm_input','','',[this,'_addGroup',[arg.id]],'IM::NEW_GROUP');
	break;

	case 'grp_rename':
		this.__renameInput(document.getElementById(this._pathName+'/'+ arg.id),arg.id,[this,'_oncontext',['','',{method:'grp_rename_response',id:arg.id}]]);
	break;
	case 'grp_rename_response':
		//in this case var e contains new GroupName
	case 'grp_remove':

		var aDS = dataSet.get('xmpp',['roster']), aData, aTmp = {IQ:[]};

		for (var i in aDS)
			if (aDS[i].group == arg.id){

				aData = {ITEM:[{ATTRIBUTES:{JID:i}}]};

				if (aDS[i].name)
					aData.ITEM[0].ATTRIBUTES.NAME = aDS[i].name;

				if (arg.method == 'grp_rename_response' && e)
					aData.ITEM[0].GROUP = [{VALUE:e}];

				aTmp.IQ.push(this.__xmpp.create_iq(this.__xmpp.create_query(aData,'jabber:iq:roster'),'set').IQ[0]);
			}

		if (aTmp.IQ.length>0)
			this.__xmpp.create_body(aTmp,'',[this.__xmpp,'response',['exe']]);

	break;

	case 'grp_removec':
		var aID = [],
			aDS = dataSet.get('xmpp',['roster']);

		for (var i in aDS)
			if (aDS[i].group == arg.id)
				aID.push(i);

		if (aID.length)
			this.__xmpp.user_remove(aID);
			//this._user_remove(aID);
	}
};

_me._renameUsrResponse = function(sName, sJID){
	if (sJID){
		var aTmp = dataSet.get('xmpp', ['roster', sJID]);
		if (aTmp && aTmp.name != sName)
			this.__xmpp.user_rename(sJID, sName == sJID?'':sName, aTmp.group);
	}
};

_me._addGroup = function(sGrp,sJID){
	var aTmp = dataSet.get('xmpp', ['roster', sJID]);
	if (aTmp && aTmp.group != sGrp)
		this.__xmpp.user_group(sJID,aTmp.name,(sGrp == '*' || sGrp == '~'?'':sGrp));
};


// Create input for rename inside given html element
_me.__renameInput = function(hAnchor, sText, oResponse){
	var me = this;

	this.__noRefresh = true;

	removecss(hAnchor,'active','noimage');
	hAnchor.innerHTML = '';

	var inp = mkElement('input', {type:'text',className:'rename_input'});
		inp.value = sText;

	hAnchor.appendChild(inp);

		inp.focus();
		inp.onblur = function (e){

			if (this.parentNode)
				this.parentNode.innerHTML = sText.escapeHTML();
				
			me._doRefresh();
		};
		inp.onkeydown = function(e){
			var e = e || window.event;

			switch (e.keyCode) {
				// Enter
				case 13:

					this.parentNode.innerHTML = this.value.escapeHTML();

					if (oResponse)
						executeCallbackFunction(oResponse, this.value);

					me._doRefresh();
					break;
				// Esc
				case 27:
					this.blur();
					break;
			}
		};
		inp.onsubmit = function(){
			return false;
		};
};

_me._translateName = function (sUID){
	if (sUID){
		sUID = sUID.split('/').shift();
		return dataSet.get('xmpp', ['roster', sUID, 'name']) || sUID;
	}
};


_me._chat = function(sFrom, sTo, sBody, dDate){

	if (!this.__xmpp || !this.__xmpp.__sid) return;
	
	sFrom = sFrom.split('/').shift();

	if (sBody && !sTo){
		//Sound
		if (gui.frm_main && gui.frm_main.sound && GWOthers.getItem('IM','sound_notify')>0)
			gui.frm_main.sound._play('chat');

		//Title
		if (gui.frm_main && gui.frm_main.title)
			gui.frm_main.title._add(getLang('TITLE::NEW_IM',[this._translateName(sFrom)]),5);

		//Not Listed user
		if (!dataSet.get('xmpp', ['roster', sFrom]))
			dataSet.add('xmpp', ['roster',sFrom],{show:'from',group:'~',user:sFrom});
	}
	
	if (!this.__chat || this.__chat._destructed == true){

		if ((GWOthers.getItem('IM','auto_chat')>0 && this.__status != 'dnd') || !sBody){
			this.__chat = null;
			this.__chat = gui._create('frm_chat','frm_chat');
			this.__chat.__im = this;
		}
		else{
			this.__chatQueue.push({'from':sFrom, 'to':sTo, 'body':sBody, date: dDate || new Date()});
			dataSet.add('xmpp', ['roster', sFrom, 'action'], 'msg');

			if (gui.frm_main.lister)
				gui.frm_main.lister._checkIM(true);

			return;
		}
	}

	//process queue
	for (var i = 0; i<this.__chatQueue.length; i++){
		if (sFrom == this.__chatQueue[i].from){
			this.__chat._chat(this.__chatQueue[i].from, this.__chatQueue[i].to, this.__chatQueue[i].body, this.__chatQueue[i].date);
			this.__chatQueue.splice(i,1);
			i--;
		}
	}

	this.__chat._chat(sFrom, sTo, sBody, dDate);
	
	if (this.__chat._docked)
		if (this.__status == 'dnd'){
            var dock = this.__chat._mydock || gui._dock;
			if (dock)
				dock._add(this.__chat,this.__chat._title(),'ico_frm_chat-active');
		}
		else
			this.__chat._undock();

	dataSet.remove('xmpp', ['roster', sFrom, 'action']);

	if (gui.frm_main.lister)
		gui.frm_main.lister._checkIM();

	//show roster
	gui.frm_main._showRightDock();
};

_me._send = function(sTo, sBody, aTo){
	if (this.__xmpp.__sid){
		if (!aTo)
			this.__chat._chat(sTo, dataSet.get('main',['fullname']) || dataSet.get('main',['user']), sBody);
		else
		if (this.__chat.__tabIndex[sTo] && this.__chat.tabs[this.__chat.__tabIndex[sTo]])
            this.__chat.tabs[this.__chat.__tabIndex[sTo]]._close();

		this.__xmpp.message(aTo || sTo, sBody);
		return true;
	}
	return false
};

_me._response = function(sType,aData){

//inspect2({sType:sType,aData:aData});

	switch (sType){
	//ERROR
	case 'error':
		if (aData.IQ){
			try{
				//Server Offline
				if (aData.IQ[0].ERROR && aData.IQ[0].ERROR[0] && aData.IQ[0].ERROR[0].ATTRIBUTES && aData.IQ[0].ERROR[0].ATTRIBUTES.STATUS == 410){
				    this.__xmpp.__sid = '';
					this.__xmpp.logout([this,'_response',['logout']]);
				}
				
				alert('IM : '+aData.IQ[0].ERROR[0].VALUE + ' (' + aData.IQ[0].ERROR[0].ATTRIBUTES.STATUS+')');
			}
			catch(e){}
		}
		break;

	//LOGIN SEQUENCE
	case 'login1':
		//get roster
		this.__xmpp.roster_get([this,'_response',['login2']]);
		break;
	case 'login2':
		//set status
		this.__xmpp.set_status(5, this.__status, this.__statusText, [this,'_response',['login3']]);

	case 'status':

		if (gui.frm_main.lister)
			gui.frm_main.lister._checkIM();

		this.menu.__aData[0].css = 'im_'+ (this.__status || 'online');
		this.menu.__aData[0].title = 'STATUS::' + (this.__status || 'online').toUpperCase();
		this.menu._fill(this.menu.__aData);
		break;

	case 'login3':
		//wait signal
		this.__xmpp.listen();
		break;

	case 'logout':

		this.__status = 'offline';

		var aRoster = dataSet.get('xmpp', ['roster']);
		for (var i in aRoster)
			delete aRoster[i].show;

		dataSet.add('xmpp',['roster'],aRoster,true);
		dataSet.update('xmpp',['roster']);

		//change icon
		this._response('status');

		break;
	//MESSAGE
	case 'message':
		if (aData.BODY && aData.BODY[0] && aData.BODY[0].VALUE){

			var date = '', stamp;
			if (aData.X && aData.X[0] && aData.X[0].ATTRIBUTES && (stamp = aData.X[0].ATTRIBUTES.STAMP)){
				date = new Date();
				date.setVersit(stamp);
			}

			this._chat(aData.ATTRIBUTES.FROM,'',aData.BODY[0].VALUE,date);
		}
		break;

		case 'paused':
		if (aData){
			if (gui.frm_main && gui.frm_main.title)
				gui.frm_main.title._refresh();

			if (this.__chat)
				this.__chat._wait(aData);
		}
		break;
	case 'composing':
		if (aData){
			if (gui.frm_main && gui.frm_main.title)
				gui.frm_main.title._add(getLang('IM::COMPOSING',[this._translateName(aData)]),5);

			if (this.__chat)
				this.__chat._compose(aData);
		}
		break;

	//RESPONSE
	case 'subscribe':
		if (aData.ATTRIBUTES.FROM){
			if (GWOthers.getItem('IM','auto_subscribe')>0)
				this.__subscribed(true,aData.ATTRIBUTES.FROM);
			else
				gui._create('subscribe','frm_confirm_threestates','','',[this,'__subscribed',[aData.ATTRIBUTES.FROM]],'IM::SUBSCRIPTION','IM::SUB_ASK',[aData.ATTRIBUTES.FROM],'FORM_BUTTONS::ACCEPT','FORM_BUTTONS::DECLINE');
		}
		break;

	case 'subscribed':
		break;

	case 'unavailable':
		if (aData.ATTRIBUTES && aData.ATTRIBUTES.FROM){
			var sFrom = aData.ATTRIBUTES.FROM.split('/').shift();
			if (dataSet.get('xmpp', ['roster', sFrom])){
				dataSet.remove('xmpp', ['roster', sFrom, 'status'],true);
				dataSet.remove('xmpp', ['roster', sFrom, 'show'],true);
				dataSet.update('xmpp', ['roster', sFrom, 'show']);
			}
		}

		break;

	case 'unsubscribed':

		if (aData.ATTRIBUTES && aData.ATTRIBUTES.FROM){
			var sFrom = aData.ATTRIBUTES.FROM.split('/').shift();
				//sFrom = aData.ATTRIBUTES.FROM;

			if (dataSet.get('xmpp', ['roster', sFrom])){
				dataSet.remove('xmpp', ['roster', sFrom, 'status'],true);
				dataSet.add('xmpp', ['roster', sFrom, 'status'],'from');

				gui._create('unsubscribed','frm_alert','','','','IM::SUBSCRIPTION','IM::UNSUBSCRIBED',[sFrom]);
			}
		}

		break;

	case 'state_change':

		if (aData.ATTRIBUTES && aData.ATTRIBUTES.FROM){

			var aFrom = aData.ATTRIBUTES.FROM.split('/')
				sFrom = aFrom.shift();

			if (dataSet.get('xmpp', ['roster', sFrom])){}
			else
			if (dataSet.get('xmpp', ['roster', aData.ATTRIBUTES.FROM]))
			    sFrom = aData.ATTRIBUTES.FROM;
			else
			    break;

			//set status text
			var sStat = '';
			if (aData.STATUS && aData.STATUS[0] && aData.STATUS[0].VALUE)
				sStat = aData.STATUS[0].VALUE;
			dataSet.add('xmpp', ['roster', sFrom, 'status'], sStat, true);

			//set priority
			//if (aData.PRIORITY && aData.PRIORITY[0] && aData.PRIORITY[0].VALUE)
			//	dataSet.add('xmpp', ['roster', sFrom, 'priority'], aData.PRIORITY[0].VALUE, true);

			//set resource
			if (aFrom[0])
				dataSet.add('xmpp', ['roster', sFrom, 'resource'], aFrom[0], true);
			
			//set status icon
			if (aData.SHOW && aData.SHOW[0] && aData.SHOW[0].VALUE)
				dataSet.add('xmpp', ['roster', sFrom, 'show'],aData.SHOW[0].VALUE.toLowerCase());
			else{
				var oldShow = dataSet.get('xmpp', ['roster', sFrom, 'show']);

				//'to' commented for email gateway
				if (/*oldShow != 'to' && */oldShow != 'from')
					dataSet.add('xmpp', ['roster', sFrom, 'show'],'online');
			}
		}

		break;

	case 'download':
		if (aData && aData.URL && aData.URL[0] && aData.URL[0].VALUE)
			var me = this,
				frm = gui._create('download','frm_confirm','','',[this,'_response',['download_start',aData.URL[0].VALUE]], 'IM::RECEIVE_FILE','IM::RECEIVE_NOTE', [aData.FROM[0].VALUE.split('/').shift(), Path.basename(aData.URL[0].VALUE),(aData.DESC && aData.DESC[0] && aData.DESC[0].VALUE?aData.DESC[0].VALUE:'')]);
				frm.btn_cancel._onclick = function(){
					me._response('download_stop',aData);
					this._parent._destruct();
				};
		break;
		
	case 'download_start':
		window.open(aData, "file", "directories=no,toolbar=no,status=no,menubar=yes,width=200,height=200");
		break;
		
	case 'download_stop':
		var sID = '',sTo = '';
		if (aData.ID){
			var sID = aData.ID[0].VALUE;
			delete aData.ID;
		}
		if (aData.FROM){
			var sTo = aData.FROM[0].VALUE;
			delete aData.FROM;
		}
		this.__xmpp.oob_cancel(aData, sID, sTo);
		break;

	case 'roster':

/*
...... [ATTRIBUTES]
........ [JID](string) = user@merakdemo.com
........ [NAME](string) = uzivatel je frajer
........ [SUBSCRIPTION](string) = both

...... [ATTRIBUTES]
........ [JID](string) = 007guard.com/registered
........ [SUBSCRIPTION](string) = from
*/

		//update roster
		if (aData.ITEM){

			var oldShow, sJID, sSub, sName, bRefresh = false;
			for(var i in aData.ITEM){

				sSub = aData.ITEM[i].ATTRIBUTES.SUBSCRIPTION;
				sJID = aData.ITEM[i].ATTRIBUTES.JID;
				sName= aData.ITEM[i].ATTRIBUTES.NAME;

				if (sSub == 'remove')
					dataSet.remove('xmpp', ['roster', sJID], true);
				else{
					//do not overwrite show icon with subscription ("both")
					oldShow = dataSet.get('xmpp', ['roster', sJID,'show']);
					if (!oldShow || sSub != 'both' || (sSub == 'both' && (oldShow == 'from' || oldShow == 'to')))
						dataSet.add('xmpp', ['roster', sJID,'show'], sSub, true);

					dataSet.add('xmpp', ['roster', sJID,'name'], sName, true);
					dataSet.add('xmpp', ['roster', sJID,'group'],aData.ITEM[i].GROUP?aData.ITEM[i].GROUP[0].VALUE:'*', true);
				}
				bRefresh = true;
			}
			if (bRefresh)
				dataSet.update('xmpp', ['roster']);
		}

		break;
	}
};


_me.__subscribed = function(bOK,sJID){
	if (bOK)
		this.__xmpp.user_subscribed(sJID);
	else
		this.__xmpp.user_unsubscribed(sJID);
};

_me.__update = function(sDataSet, aDName){
	if (aDName && aDName[0] == 'roster')
		this._fill();
};


_me._getGroups = function (){
	var aData = dataSet.get('xmpp', ['roster']), out = {};
	for (var i in aData)
		out[aData[i].group] = true;
		
	return out;
};


_me._doRefresh = function(){
	this.__noRefresh = false;
	if (this.__doRefresh){
		this.__doRefresh = false;
		this._fill();
	}
};

/**
 * Roster
 * @Note: backslashovat i, j, .status
 **/
_me._fill = function (){

	if (this.__noRefresh){
		this.__doRefresh = true;
		return;
	}

	var aTmp,
		aData = {},
		aData2 = {},
		aGet = dataSet.get('xmpp', ['roster']);

	if (typeof aGet == 'object')
		for(var i in aGet){
			if (!aData2[aGet[i].group])
				aData2[aGet[i].group] = [];

			aTmp = aGet[i];
			aTmp.user = i;

			aData2[aGet[i].group].push(aTmp);
		}

	//sort
	function sortUsr (a,b){
		var n1 = (a.name || a.user),
			n2 = (b.name || b.user);

		if (n1<n2)
			return -1;
		else
		if (n1>n2)
			return 1;
		else
			return 0;
	};
	
	var aGrpSort = [];
	for(var i in aData2){
		aGrpSort.push(i);
		aData2[i].sort(sortUsr);
	}


	function sortGrp (n1,n2){

		if (n2 == '*')
			return -1;
		if (n1 == '*')
			return 1;

		if (n1<n2)
			return -1;
		else
		if (n1>n2)
			return 1;
		else
			return 0;
	};

	aGrpSort.sort(sortGrp);
	for(var i in aGrpSort)
		aData[aGrpSort[i]] = aData2[aGrpSort[i]];

	//clear cookie
	var aCookie = Cookie.get(['im','roster']);
	if (aCookie)
		for(var i in aCookie)
			if (!aData2[i])
				Cookie.set(['im','roster',i]);

	//fill
	this.__body.innerHTML = '';

	if (aData){
		var i, j, out, out2 = '', bAction = false, sTitle;
		for(i in aData){

			out = '';

			if (aData[i]){
				var ico = '', txt = '';
				for (j in aData[i]){

					if (!this.__showOffline && aData[i][j].action!='msg' && (!aData[i][j].show || aData[i][j].show == 'both' || aData[i][j].show == 'from' || aData[i][j].show == 'none' || aData[i][j].show == 'to'))
						continue;

					//ico
					ico = 'user_' + (aData[i][j].show || 'offline');
					if (aData[i][j].action)
						ico += ' action_' + aData[i][j].action;
						
					txt = '<span>'+ (aData[i][j].name || aData[i][j].user).escapeHTML() +'</span>';
					if (this.__activeUser == aData[i][j].user){
						ico += ' active noimage';
						txt += (aData[i][j].status?'<i>'+aData[i][j].status+'</i>':'') + '<img src="./server/download.php?class=avatar&fullpath='+aData[i][j].user+'" onload="if (this.fileSize>10 || this.naturalWidth>10) {this.style.marginLeft = 0; this.style.position = \'relative\'; removecss(this.parentNode,\'noimage\');}">'+
							(sPrimaryAccountSIP?'<a class="sip"></a>':'')+
							'<a class="vcard"></a><a class="mail"></a><a class="mssg"></a>';
					}
					out += '<li id="'+ this._pathName +'/'+ i +'/'+ aData[i][j].user +'" class="'+ ico +'" unselectable="on">'+ txt +'</li>';
				}
			}

			if (out)
				out2 += '<li'+((aCookie && aCookie[i]) && !aData[i][j].action?' class="close"':'')+'><div id="'+ this._pathName + '/' + i +'">'+ (i=='*'?getLang('IM::UNSORTED'):(i=='~'?getLang('IM::NOT_LISTED'):i.escapeHTML())) +'</div><ul>'+ out +'</ul></li>';
		}

		if (out2)
			this.__body.innerHTML = '<ul>'+ out2 +'</ul>';
	}
};



/**
 * Drag & Drop
 **/
_me.__initdrag = function(id,sType,x,y){
	if (this.__xmpp.__sid){
		//prepare data
		var aName = dataSet.get('xmpp',['roster',id,'name']),
			sBody = '<div class="drag_folder drag_'+sType+'">'+ (aName || id) +'</div>';

		//create Drag box
		gui.frm_main.dnd.create_drag(sBody, {type:sType,value:id}, x, y);
	}
};

_me._active_dropzone = function(v){
	this.__aDragGroups = [];

	var elms = this.__body.getElementsByTagName('DIV'),
		tmp;
	for(var i = 0; i<elms.length; i++){
		tmp = getSize(elms[i]);
		tmp.id = elms[i].id;
		this.__aDragGroups.push(tmp);
	}
	
	var tmp = getSize(this._main);
	for(var i = 0; i<=this.__aDragGroups.length; i++){
		if (i>0){
            this.__aDragGroups[i-1].h = (this.__aDragGroups[i]?this.__aDragGroups[i].y:tmp.y+tmp.h) - this.__aDragGroups[i-1].y;
		}
	}

	return true;
};

_me._ondragover = function(v){
	var tmp;
	for(var i = 0; i<this.__aDragGroups.length; i++){
		tmp = this.__aDragGroups[i];

		if (v.x > tmp.x && v.x < tmp.x+tmp.w && v.y > tmp.y && v.y < tmp.y + tmp.h){
			this.___lastdragover = tmp.id.split('/').pop();
			return true;
		}
	}

	this.___lastdragover = '';
	return false;
};

_me._ondragout = function(v){
	this.___lastdragover = '';
};

_me._ondrop = function(v){
	if (this.___lastdragover && v.value)
		this._oncontext('','','',{method:'grp_set',grp:this.___lastdragover,id:v.value});
};