_me = obj_popup.prototype;
function obj_popup(){};
/**
 *
 *		_ondock
 *		_onundock
 *		_onresize
 **/
_me.__constructor = function(owner){
	this._owner = owner;

	this._resizable	= true;
	this._closable	= true;
	this._dockable	= true;
	this._moveble	= true;

	this.__zindex;
	this.__position = {}; // position memory for fullscrean

	var me = this;

	/* docking */
	this._mydock;

	/* target elements */
	this.__eTitle		= document.getElementById(this._anchors['title']);
	this.__eContainer	= document.getElementById(this._anchors['container']);
	this.__eMain		= document.getElementById(this._anchors['main']);

	/* set zindex */
	this.__eContainer.style.zIndex = this.__zindex = maxZIndex.get();
	this._add_destructor('__destructor');

	/* onclose event */
	this._add_destructor('_onclose');

	var sResize;
	this.__eContainer.onmousemove = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (this !== elm) return;

		if (!me._resizable) {
			this.style.cursor = 'default';
			return;
		}

		var elmleft  = elm.offsetLeft,
			elmtop   = elm.offsetTop,
			elmwidth = elm.offsetWidth,
			elmheight= elm.offsetHeight;

		// left part
		if (e.clientX - elmleft<9){
			// top corner
			if (e.clientY - elmtop<9){
				this.style.cursor = 'se-resize';
				sResize = 'lt';
			}
			// bottom corner
			else
			if ((elmtop + elmheight) - e.clientY < 9){
				this.style.cursor = 'sw-resize';
				sResize = 'lb';
			}
			// side
			else{
				this.style.cursor = 'w-resize';
				sResize = 'l';
			}
		}
		// right part
		else
		if ((elmleft + elmwidth) - e.clientX<9){
			// top corner
			if (e.clientY - elm.offsetTop<9){
				this.style.cursor = 'sw-resize';
				sResize = 'rt';
			}
			// bottom corner
			else
			if((elmtop + elmheight) - e.clientY < 9){
				this.style.cursor = 'se-resize';
				sResize = 'rb';
			}
			// side
			else{
				this.style.cursor = 'w-resize';
				sResize = 'r';
			}
		}
		// center
		else{
			this.style.cursor = 's-resize';

			// top
			if (e.clientY - elmtop < 8)
				sResize = 't';
			// bottom
			else
			if ((elmtop + elmheight) - e.clientY < 8)
				sResize = 'b';
		}
	}



	/* REMOVE EVENT */
	function dispatch(e){
		me.__hideBlock();
		gui._disobeyEvent('mousemove',[me,'__move_handler']);
		gui._disobeyEvent('mouseup',[dispatch]);
		
		if (me._onresize_end)
			me._onresize_end();
	};


	//DblClick on Title and Ico for MSIE
	if (currentBrowser().indexOf('MSIE') == 0)
		this.__eContainer.ondblclick = function(e){
			var e = e || window.event;
			var elm = e.target || e.srcElement;
			switch (elm.id){
			case me._anchors['top']:
			case me._anchors['title']:
				me._maximize();
				if (me._onresize) me._onresize(e,'max');
				me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'max'});

				return;

			case me._pathName + 'ico':
			    me._close();
			}
		};


	this.__eContainer.onmousedown = function(e){

		var e = e || window.event;
		var elm = e.target || e.srcElement;

		// set max zindex
		me._focus();
		
		var disp = false;

		// resize event
		if (this === elm){
			if (!me._resizable) return;

			me.__resize (e,sResize);

			disp = true;
		}
		else
		switch (elm.id){
			// move
			case me._anchors['top']:
			case me._anchors['title']:

				//DblClick on title for other then MSIE browsers
				if (!this.ondblclick)
					var t = (new Date()).getTime();
					if (this.__lastClick && this.__lastClick+600>t){
						this.__lastClick = 0;

						me._maximize();
						if (me._onresize) me._onresize(e,'max');
						me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'max'});

						return;
					}
					else
						this.__lastClick = t;


				if (!me._moveble) return;

				me.__showBlock('m');

				var difX = e.clientX - me.__eContainer.offsetLeft;
				var difY = e.clientY - me.__eContainer.offsetTop;

				if (me.__move_handler)
					gui._disobeyEvent('mousemove',[me,'__move_handler']);

				me.__move_handler = function(e){
					me._place(e.clientX - difX,e.clientY - difY);
				};
				gui._obeyEvent('mousemove',[me,'__move_handler']);

				disp = true;
				break;
			// maximalize
			case me._anchors['max']:
				me._maximize();
				if (me._onresize) me._onresize(e,'max');
				me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'max'});
				
				disp = true;
				break;
			// minimalize
			case me._anchors['min']:
				me._dock();
				break;
			// close by ico for other then MSIE
			case me._pathName + 'ico':
                if (this.ondblclick)
                    break;
				else
				{
					var t = (new Date()).getTime();
					if (!this.__lastClick || this.__lastClick+600<t){
						this.__lastClick = t;
						break;
					}
				}
			// close
			case me._anchors['rem']:
				me._close();
				break;
		}

		if (disp)
			gui._obeyEvent('mouseup',[dispatch]);
	};
	
	// Close by ESC
	this._main.onkeydown = function(e){
		var e = e || window.event;

		if (e.keyCode == 27 && (!me._onclose || me._onclose()))
			me._destruct();

		return true;
	};

	this.__eMain.scrollTop = 0;
	this.__eContainer.scrollTop = 0;
};

_me.__hide = function(){
	this.__oldZIndex = this.__eContainer.style.zIndex;
	this.__eContainer.style.zIndex = -1000;

	if (this._isModal())
		this.__modaldiv.style.display = 'none';
};
_me.__show = function(){
	this.__eContainer.style.zIndex = this.__oldZIndex;

	if (this._isModal())
		this.__modaldiv.style.display = 'block';
};

_me._maximize = function(bWait){

	if (!this.__position.max && this._resizable==false) return;
	
	if (this.__position.max){
		this._resizable	= true;
		this._moveble	= true;

		this.__position.max = 0;
		
		this._place(this.__position.x,this.__position.y,this.__position.w,this.__position.h);
	}
	else{
		var oCont = this.__eContainer;
		this.__position.max = 1;
		this._resizable	= false;
		this._moveble	= false;

		var tmp = clone(this.__position,true);

		if(bWait){
			this.__position_tmp = tmp;
			window.setTimeout('try{'+this._pathName+'._place(0,0,document.body.offsetWidth ,document.body.offsetHeight + ('+this._pathName+'.__eMain.offsetHeight - '+this._pathName+'.__eContainer.offsetHeight)); '+this._pathName+'.__position = '+this._pathName+'.__position_tmp;}catch(er){}',500);
		}
		else{
			this._place(0,0,document.body.offsetWidth ,document.body.offsetHeight);
			this.__position = tmp;
		}
	}
};

/**
 * Hidden over-div
 * It avoind of gui selections
 * 22.5.2008 14:06:40
 **/
_me.__showBlock = function(sResize){

	//MSIE is too slow :(
	if (currentBrowser()=='MSIE6')
	    return;

	if (!this.__maskDIV){
		this.__maskDIV = mkElement('div',{className:'obj_popup_mask'});

		var me = this;
		this.__maskDIV.onclick = function(){
			me.__hideBlock();
		};

		document.getElementsByTagName('body')[0].appendChild(this.__maskDIV);
	}

	if (sResize)
		this.__maskDIV.style.cursor = {m:'Move',tl:'se-resize',lb:'sw-resize',l:'w-resize',rt:'sw-resize',rb:'se-resize',r:'w-resize',t:'s-resize',b:'s-resize'}[sResize];

	//element selecting in ffox
	setTimeout('try{'+this._pathName+'.__maskDIV.focus();}catch(r){}',0);
};
_me.__hideBlock = function(){
	if (this.__maskDIV){

		//FFox keep selecting after hidding the block
		this.__maskDIV.focus();

		try{this.__maskDIV.parentNode.removeChild(this.__maskDIV);}catch(e){}
		this.__maskDIV = null;
	}
};


_me._dock = function (skip){
	var dock = this._mydock || gui._dock;

	if (!this._dockable || !dock) return;
	if (this._ondock && !this._ondock(dock)) return;

	this._main.style.display = 'none';
	this._docked = true;

	if (!skip) dock._add(this,this._title());

	return true;
};


_me._undock = function (skip){
	var dock = this._mydock || gui._dock;
	if (dock && this._docked){
		this._main.style.display = 'block';
		this._docked = false;

		if (!skip)
			dock._remove(this);

		this._focus();

		if (this._onundock)
			this._onundock(dock);
	}
		
	return true;
};

// _me._ondock = function(){};
// _me._onundock = function(){};

_me.__resize = function(e,sResize){

	var me = this;
	var difX,difY,dif1,dif2,dif3,dif4;

	//remove old handler
	if (me.__move_handler){
		gui._disobeyEvent('mousemove',[me,'__move_handler']);
		me.__move_handler = null;
	}

	this.__showBlock(sResize);

	switch(sResize){
	case 't' :
		difY = e.clientY;
		dif1 = this.__position.h || this.__eContainer.offsetHeight;
		dif2 = this.__position.y || this.__eContainer.offsetTop;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				Y = evn.clientY;

		    Y = Y<0?0:Y;
			Y -= difY;

			if (dif1 - 101<Y)
				Y = dif1 - 100;

			me._place('',(dif2 + Y),'',(dif1 - Y));

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'t');
			me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'t'});
		};

		break;

	case 'lt':
		difY = e.clientY;
		difX = e.clientX;
		dif1 = this.__position.h || this.__eContainer.offsetHeight;
		dif2 = this.__position.y || this.__eContainer.offsetTop;
		dif3 = this.__position.w || this.__eContainer.offsetWidth;
		dif4 = this.__position.x || this.__eContainer.offsetLeft;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				X = evn.clientX,
				Y = evn.clientY;
				
			X = X<0?0:X;
			Y = Y<0?0:Y;

			var size1 = dif1 - Y + difY;
			if (size1<101){
				  Y = dif1 + difY - 100;
				  size1 = 100;
			}
			
			var size3 = dif3 - X + difX;
			if (size3<201){
				X = dif3 + difX - 200;
				size3 = 200;
			}

			var size2 = dif2 + Y - difY;
			var size4 = dif4 - difX + X;

			me._place(size4,size2,size3,size1);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'lt');
			me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'lt'});
		};
		
		break;

	case 'l' :
		difX = e.clientX;
		dif1 = this.__position.w || this.__eContainer.offsetWidth;
		dif2 = this.__position.x || this.__eContainer.offsetLeft;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				X = evn.clientX;

			X = X<0?0:X;

			var size1 = dif1 - X + difX;
			if (size1<201){
				X = dif1 - 200 + difX;
				size1 = 200;
			}
			
			var size2 = dif2 - difX + X;

			me._place(size2,'',size1);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'l');
			me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'l'});
		};
		
		break;

	case 'lb':
		difX = e.clientX;
		difY = e.clientY;
		dif1 = this.__position.w || this.__eContainer.offsetWidth;
		dif2 = this.__position.x || this.__eContainer.offsetLeft;
		dif3 = this.__position.h || this.__eContainer.offsetHeight;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				X = evn.clientX,
				Y = evn.clientY;

			X = X<0?0:X;
			Y = Y<0?0:Y;

			var size1 = dif1 - X + difX;
			if (size1<200){
                X = dif1 - 200 + difX;
                size1 = 200;
			}

			var size2 = dif2 - difX + X;

			var size3 = dif3 + Y - difY;
			if (size3<100)
				size3 = 100;

			me._place(size2,'',size1,size3);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'lb');
			me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'lb'});
		};

		break;
	case 'b' :
		difY = e.clientY;
		dif1 = this.__position.h || this.__eContainer.offsetHeight;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				Y = evn.clientY;
				Y = Y<0?0:Y;

			var size = dif1 + Y - difY;
				size = size<100?100:size;

			me._size('',size);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'b');
			me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'b'});
		};
		
		break;
	case 'rb':
		difX = e.clientX;
		difY = e.clientY;
		dif1 = this.__position.w || this.__eContainer.offsetWidth;
		dif2 = this.__position.h || this.__eContainer.offsetHeight;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				X = evn.clientX,
				Y = evn.clientY;
				
			X = X<0?0:X;
			Y = Y<0?0:Y;

			var size1 = dif1 + X - difX;
				size1 = size1<200?200:size1;
			var size2 = dif2 + Y - difY;
			    size2 = size2<100?100:size2;

			me._size(size1,size2);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'rb');
			me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'rb'});
		};
		
		break;
	case 'r' :
		difX = e.clientX;
		dif1 = this.__position.w || me.__eContainer.offsetWidth;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				X = evn.clientX;
				X = X<0?0:X;
				
			var size1 = dif1 + X - difX;
   				size1 = size1<200?200:size1;

			me._size(size1);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'r');
			me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'r'});
		};

		break;
	case 'rt':
		difX = e.clientX;
		difY = e.clientY;
		dif1 = this.__position.w || this.__eContainer.offsetWidth;
		dif2 = this.__position.h || this.__eContainer.offsetHeight;
		dif3 = this.__position.y || this.__eContainer.offsetTop;

		me.__move_handler = function(evn){
			var evn = evn || window.event,
				Y = evn.clientY,
				X = evn.clientX;
				
			Y = Y<0?0:Y;
			X = X<0?0:X;
				
			var size2 = dif2 - Y + difY;
			if (size2<100){
				Y = dif2 - 100 + difY;
                size2 = 100;
			}

			var size3 = dif3 + Y - difY;

			var size1 = dif1 + X - difX;
            	size1 = size1<200?200:size1;

			me._place('',size3,size1,size2);

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'rt');
			me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'rt'});
		};
		
		break;
	}
	
	if (me.__move_handler && me.__move_handler!= null)
		gui._obeyEvent('mousemove',[me,'__move_handler']);
};

_me._title = function(sVal,bText){
	if (typeof sVal == 'undefined')
		return this.__eTitle.innerHTML;
	else
	if (bText)
		this.__eTitle.innerHTML = sVal?sVal.escapeHTML():'';
	else{
		var tmp = getLang(sVal);
		this.__eTitle.innerHTML = tmp?tmp.escapeHTML():'';
	}
};

_me._autoSize = function(){
	//this.__eContainer.style.height = 'auto';
	//this.__eTable.style.width = 'auto';
};


_me._close = function(){
	if (!this._closable || (this._onclose && !this._onclose())) return;
    this._remove_destructor('_onclose');
	this._destruct();
};

_me._focus = function (){

	if (this._docked) this._undock();

	maxZIndex.remove(this.__zindex);
	this.__eContainer.style.zIndex = this.__zindex = maxZIndex.get();

	// modal window
	if (this.__modaldiv)
	    this.__modaldiv.style.zIndex = (this.__zindex-1);
};

_me._isModal = function(){
	return this.__modaldiv?true:false;
};

_me._modal = function(b){
	if(b && !this.__modaldiv){
		//modal window
		this.__modaldiv = mkElement("div");
		this.__modaldiv.style.zIndex = parseInt(this.__zindex)-1;
	    this._main.insertBefore(this.__modaldiv,this.__eContainer);

		this.__modaldiv.className = 'obj_popup_modaldiv';
    }
    else
	if(!b && this.__modaldiv){
        this._main.removeChild(this.__modaldiv);
        this.__modaldiv = null;
    }
};

_me._defaultSize = function(x,y,w,h,bMax) {

	//any change will be stored into cookie
	this.__defaultSize = {x:x,y:y,w:w,h:h,max:bMax};

	//get proper cookie
	var aSize;
	if (Cookie)
		aSize = Cookie.get(['popup_'+this._type]);

	if (Is.Defined(aSize)) {
		if (typeof aSize['x'] != 'undefined'){
			x = parseInt(aSize['x']);
			x = x<0?0:x;
		}
			
		if (typeof aSize['y'] != 'undefined'){
			y = parseInt(aSize['y']);
			y = y<0?0:y;
		}
		
   		if (aSize['w'])
			w = parseInt(aSize['w']);
		if (aSize['h'])
			h = parseInt(aSize['h']);
		if (aSize['max'])
			bMax = aSize['max'];
	}

	if (Is.Number(x) && Is.Number(y) && x >= 0 && y >= 0) {
		if (Is.Number(w) && w > 0) {
			if (Is.Number(h) && h > 0)
				this._place(x,y,w,h);
			else
				this._place(x,y,w);
		}
		else
			this._place(x,y);
	}
	else
	if (Is.Number(w) && w > 0) {
		if (Is.Number(h) && h > 0)
			this._size(w,h,1);
		else
			this._size(w,'',1);
	}

	if (bMax)
		this._maximize(true);

	// register function that will store current size
	this._add_destructor('__rememberSize');
	
	this.__eMain.scrollTop = 0;
	this.__eContainer.scrollTop = 0;
};

_me.__rememberSize = function(){
    if (Cookie){
		var tmp = clone(this.__position);

		for (var i in tmp)
		    if (tmp[i] == this.__defaultSize[i])
		        delete tmp[i];

		Cookie.set(['popup_'+this._type],tmp);
	}
};

_me._place = function(x,y,w,h){
	if (this.__position.max){
		x = y = w = h = 0;
		this.__eContainer.style.width = '100%';
		this.__eContainer.style.height = '100%';
	}
	else
	if (!Is.Defined(x) && !Is.Defined(y) && !Is.Defined(w) && !Is.Defined(h))
		return this.__position;

	if (Is.Number(x)){
		this.__eContainer.style.left = (x<0?0:x)+'px';
		this.__position.x = x;
	}

	if (Is.Number(y)){
		this.__eContainer.style.top  = (y<0?0:y)+'px';
		this.__position.y = y;
	}

	if (w || h)
		this._size(w,h);
};

_me._size = function (w,h,center){
	var tmp;

	if (w>199){
		this.__eContainer.style.width = w+'px';

		if (center){
			tmp = document.body.clientWidth - w;
			tmp = tmp<0?0:tmp;
			tmp = Math.round(tmp/2);

			this.__eContainer.style.left = tmp+'px';
		}

		this.__position.w = w;
	}

	if (h>99){
		this.__eContainer.style.height = h+'px';

		if (center){
			tmp = (document.body.clientHeight - h)/2;
			tmp = tmp<0?0:tmp;
			tmp = Math.round(tmp/2);

            this.__eContainer.style.top = tmp+'px';
		}

		this.__position.h = h;
	};
	
	this.__eMain.scrollTop = 0;
	this.__eContainer.scrollTop = 0;
};

/**
 * @brief: destructor
 * @date : 4.7.2006 14:38:46
 **/
_me.__destructor = function(){
	this._undock();
	this.__hideBlock();
	// remove object's zindex
	maxZIndex.remove(this.__zindex);
};

/**
 * @brief: onclose method
 **/
//_me._onclose = function(){}
