/*
._onactive(bool)
*/
_me = obj_tab.prototype;
function obj_tab(){};

_me.__constructor = function(){

	this._isActive = false;
	this._isDisabled = false;
	this._wasActivated = false;
	
	var me = this;

	this.__drawTpl = null;
	this.__drawObj = null;
	this.__drawData = null;

	this.__eLink = mkElement('a',{'href':''});

	this.__eLink.onmousedown = function(e){
		var e = e || window.event;
			e.cancelBubble = true;
		try{e.preventDefault();}catch(r){}
		try{e.stopPropagation();}catch(r){}
		
		me._active();
				
		return false;
	};
	this.__eLink.oncontextmenu = function(e){
		var e = e || window.event;

		if (me._oncontext)
			me._oncontext(e);

		return false;
	};

	this.__eLink.onfocus = function(e){
		me._active();
	};

	this.__eLi = mkElement('li');
	this.__eLi.appendChild(this.__eLink);
	
	var elm = this._parent._getAnchor('links');
		elm.appendChild(this.__eLi);
		elm = null;

	/* activate 1st instance in tabs objekt */
	var first = 1;
	for (var i in this._parent){
		if (i.indexOf('_')==0 || this._parent[i]._name == this._name) continue;
		first = 0;
		break;
	}
	if (first) this._active();

	// clear memory
	this._add_destructor('__destruct');
};

/**
 * @Brief: set TITLE for tab
 * @Note predelat na _title() a _text()
 **/
_me._value = function(v,bNoLang){
	if (v){
		this.__tabTitle = v;
		this.__eLink.innerHTML = '<span>'+(bNoLang?v:getLang(v))+'</span>';
	}
	else
	    return this.__tabTitle || '';
};

_me._disabled = function(b){
	if (b == this._isDisabled) return;
	if (b){
		addcss(this.__eLi,'disabled');
		addcss(this._main,'obj_tabdisabled');
	}
	else{
		removecss(this.__eLi,'disabled');
		removecss(this._main,'obj_tabdisabled');
	}
	this._isDisabled = b;
};

/**
 * @Brief: Public function
 **/
_me._active = function(draw){
	if (this._isActive || this._isDisabled) return;

	if (typeof draw != 'undefined')
    	draw = draw;
    else
    if (!this._wasActivated)
        draw = true;
    else
        draw = false;

	this._isActive = true;
	this._wasActivated = true;

	// add <draw>
	if (this.__drawTpl){
		if (count(this.__drawTpl[2]) <= 0 && count(this.__drawData) > 0)
			this.__drawTpl[2] = this.__drawData;
		this._draw(this.__drawTpl[0],this.__drawTpl[1],this.__drawTpl[2]);
		this.__drawTpl = null;
	}

	// add <obj>
	if (this.__drawObj){
		this.__addObjects(this.__drawObj,null,this.__drawData);
		this.__drawObj = null;
	}

	// deactivate previous tab
	if (this._parent.__value) this._parent[this._parent.__value].__deactive();
	this._parent.__value = this._name;

	addcss(this._main,'obj_tab_active');
	addcss(this.__eLi,'active');

	//scroll to be visible
	var eLink = this._parent._getAnchor('links'),
		iLeft = parseInt(this.__eLi.offsetLeft,10) - parseInt(eLink.style.marginLeft || 0),
	    eHead = this._parent._getAnchor('header2');

	if (eHead.clientWidth>0){
		if (currentBrowser().indexOf('MSIE')==0){
			//vlevo
			if (parseInt(eLink.style.marginLeft || 0,10)*-1>parseInt(this.__eLi.offsetLeft,10)){
				eLink.style.marginLeft = parseInt(this.__eLi.offsetLeft,10)*-1;
			}
			else
			//vpravo
			if (parseInt(this.__eLi.offsetLeft,10)+parseInt(this.__eLi.offsetWidth,10)>parseInt(eHead.clientWidth,10)+(eLink.style.marginLeft || 0,10)*-1){
				eLink.style.marginLeft = parseInt(eHead.clientWidth,10) - (parseInt(this.__eLi.offsetLeft,10) + parseInt(this.__eLi.offsetWidth,10));
			}
		}
		else{
			if (eHead.clientWidth < (iLeft + parseInt(this.__eLi.offsetWidth,10)) + parseInt(eLink.style.marginLeft || 0))
				eLink.style.marginLeft =  parseInt(eHead.clientWidth,10) - (iLeft + parseInt(this.__eLi.offsetWidth,10));
			else
			if (iLeft + parseInt(eLink.style.marginLeft || 0)<0)
				eLink.style.marginLeft = iLeft*-1;
		}
	}

	//execute handlers
	if (this._onactive) this._onactive(draw);
	this.__exeEvent('onactive',null,{"draw":draw,"owner":this});
};

/**
 * @Brief: Private function to deactivating tab
 * @Date : 3.5.2006 18:55:40
 **/
_me.__deactive = function(){
	if (this._isActive == false) return;

	removecss(this._main,'obj_tab_active');

	//this._main.style.display = 'none';
	removecss(this.__eLi,'active');

	this._isActive = false;
};

/**
 * switch to other tab and destroy itself
 **/
_me._close = function (){
	if (this._isActive){

		var aObj = this._parent._getChildObjects(),
			oPrev;

		for (var i in aObj)
		    if (aObj[i]._name == this._name){
				if (oPrev){
				    oPrev._active();
				    break;
				}
				else
					oPrev = 1;
			}
		    else
		    if (!oPrev)
		        oPrev = aObj[i];
		    else{
		    	aObj[i]._active();
		    	break;
		    }
	}

	this._destruct();
	
	if (this._onclose)
	    this._onclose();
};

_me.__destruct = function(){

	if (this._isActive)
		this._parent.__value = '';
    
	if (this.__eLink) this.__eLink.parentNode.removeChild(this.__eLink);
	if (this.__eLi) this.__eLi.parentNode.removeChild(this.__eLi);
	
	this.__eLi = null;
	this.__eLink = null;
	this.__eMain = null;
};
