_me = obj_timeinterval.prototype;
function obj_timeinterval(){};

_me.__constructor = function(bWithAllDay) {
	var me = this;

	//START
	this.startDate._ondateselect = function() {
		me.__setFrom();
	};
	this.startTime._onchange = function() {
		me.__setFrom();
	};

	//END
	this.endDate._ondateselect = function() {
  		me.__setEnd();
	};
	this.endTime._onchange = function() {
		me.__setEnd();
	};

	//DURATION
	this.durationTime._onchange = function() {
		me.__setFrom();
	};
	this.durationDays._onkeyup = function() {
		//blank to 0 (or 1 in case of All Day)
		if (this._value()==='' || this._value()=='0')
			this._value(me.__allDayEvent()?1:0,true);

		me.__setFrom();
	};
	this.durationDays._onkeydown = function(e){
		// 01 format is not allowed
		var key = e.keyCode;

		if (key>46 && key<58) key+=48;

		if (this._value() == 0){
			if (key==96)
				return false;
			else
			if (key>96 && key<106){
			    this._value(key-96,true);
			    return false;
			}
		}

		if((key>95 && key<106) || (key>36 && key<41) || key == 8 || key == 46 || key == 16)
		    return true;
		else
		    return false;
	};

	//All Day checkbox
	if (bWithAllDay === true || bWithAllDay == 'true') {
		this._create('allDay', 'obj_checkbox', 'all_day');
		this.allDay._title('TIME_INTERVAL::ALL_DAY_EVENT');
		this.allDay._onchange = function (){

			var bDisable = false
			if (this._value()){
			    bDisable = true;
			    
				me.startTime._value(0, true);
				me.endTime._value(0, true);
			}

			me.__setEnd();

			me.startTime._disabled(bDisable);
			me.endTime._disabled(bDisable);
			me.durationTime._disabled(bDisable);
		};
	}
};

//OK
_me.__setFrom = function (){

	var iEnd = (this.startDate._value() + (this.durationDays._value()*1)) * 86400000;
	if (!this.__allDayEvent())
	    iEnd += this.startTime._value() + this.durationTime._value();

	if (this.__allDayEvent())
		iEnd--;
	else
		this.endTime._value(iEnd%86400000, true);
		
	this.endDate._value(Math.floor(iEnd/86400000), true);

	this.__setEnd();
};

//OK
_me.__setEnd = function (){
	var iStart	= this.startDate._value()*86400000,
		iEnd	= this.endDate._value()*86400000;
		
	if (!this.__allDayEvent()){
        iStart	+= this.startTime._value();
        iEnd 	+= this.endTime._value();
	}

    var iDays = 0, iTime = 0;
	//positive - change duration
	if (iEnd > iStart){
		iDays = Math.floor((iEnd-iStart)/86400000);

		if (!this.__allDayEvent())
			iTime = (iEnd-iStart)%86400000;
	}
	else
	//negatiove change from
	if (iEnd < iStart){
        this.startDate._value(this.endDate._value(), true);

        if (!this.__allDayEvent())
			this.startTime._value(this.endTime._value(), true);
	}

    if (this.__allDayEvent())
        iDays++;

    this.durationDays._value(iDays, true);
	this.durationTime._value(iTime, true);
	

	//On Change Event
	if (this._onchange)
		this._onchange();
};

//OK
_me.__allDayEvent = function() {
	return Is.Defined(this.allDay) && this.allDay._value();
};

_me._value = function(aValues) {

	if (Is.Defined(aValues)) {

   		if (Is.Defined(aValues['EVNSTARTDATE']) && aValues['EVNSTARTDATE'] != 'undefined')
			this.startDate._value(aValues['EVNSTARTDATE'], true);

		if (Is.Defined(aValues['EVNSTARTTIME']) && aValues['EVNSTARTTIME'] != 'undefined' && Is.Defined(aValues['EVNENDDATE']) && aValues['EVNENDDATE'] != 'undefined'){
			if (aValues['EVNSTARTTIME'] > -1 && aValues['EVNENDTIME'] > -1){
				this.startTime._value(aValues['EVNSTARTTIME']*60000, true);

				this.endTime._value(aValues['EVNENDTIME']*60000, true);

                if (this.allDay)
					this.allDay._value(0);
			}
			else
			//all day
			if (this.allDay){

				if (Is.Defined(aValues['EVNENDDATE']) && aValues['EVNENDDATE'] != 'undefined')
					this.endDate._value(aValues['EVNENDDATE']-1, true);

				this.allDay._value(true);
				return;
            }
		}
		else
		if (this.allDay)
			this.allDay._value(0);

		if (Is.Defined(aValues['EVNENDDATE']) && aValues['EVNENDDATE'] != 'undefined')
			this.endDate._value(aValues['EVNENDDATE'], true);

		this.__setEnd();
	}
	else {
		var aReturn = {'EVNSTARTDATE':this.startDate._value(),'EVNENDDATE':this.endDate._value()};

		if (this.__allDayEvent()) {
			aReturn['EVNSTARTTIME'] = -1;
			aReturn['EVNENDTIME'] = -1;
			aReturn['EVNENDDATE']++;
		}
		else {
			aReturn['EVNSTARTTIME'] = this.startTime._value()/60000;
			aReturn['EVNENDTIME'] = this.endTime._value()/60000;
		}
		return aReturn;
	}
};