/**
 * Page Title management object
 **/
_me = obj_title.prototype;
function obj_title(){};

_me.__constructor = function() {
	this.__buffer = [[document.title]];
	this._add_destructor('__destructor');
	
	
};

/**
 * @params:	sTitle	- title text
 *			iTime   - number of seconds
 **/
_me._add = function(sTitle,iTime){
	if (iTime){
		var id = unique_id();
		this.__buffer.push([sTitle, id, iTime]);
		document.title = sTitle;
		setTimeout('try{'+this._pathName+'._remove('+ id +');}catch(r){}', iTime*1000);
		
		return id;
	}
	else{
		this.__buffer[0] = [sTitle];
		if (this.__buffer.length == 1)
			document.title = sTitle;

		return 0;
	}
};

_me._remove = function(id){

	if (typeof gui != 'undefined' && !gui.__focus && typeof id != 'undefined')
		for(var i = 1; i<this.__buffer.length; i++)
		    if (this.__buffer[i][1] == id){
				setTimeout('try{'+this._pathName+'._remove('+ id +');}catch(r){}', (this.__buffer[i][2])*1000);

				//document.title += ';'+(gui.__focus?'F':'B');
				return;
			}

	for(var i = 1; i<this.__buffer.length; i++)
	    if (this.__buffer[i][1] == id){
 			this.__buffer.splice(i,1);
			break;
		}

	this._refresh();
};

_me._refresh = function(){
	document.title = this.__buffer[this.__buffer.length-1][0];
};

_me.__destructor = function(){
	document.title = this.__buffer[0][0];
};