_me = obj_tree_folder_context.prototype;
function obj_tree_folder_context(){};

_me.__constructor = function(){
	this._listen_cookie('tree');
};

_me._onclick = function(e,elm,id,arg){
	if (!arg) return;

	// TYPE contextmenu
	if (e.type == 'contextmenu'){
		var aMenu;
		if (arg['fid'] && !arg.disabled){

			var sFolType = WMFolders.getType(arg);
			var bVirtual = arg['fid'].indexOf('__@@VIRTUAL@@__/') == 0;
			var bArchive = false;

			//get folder access rights
			var aRights = WMFolders.getRights(arg);
			var aAccess = WMFolders.getAccess(arg);

			if (sFolType == 'VA')
				aMenu = [{'title':'POPUP_FOLDERS::DELETE_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'delete_folder'}, 'disabled':!aRights.remove}];
			else
			if (sFolType != 'Q' && sFolType != 'QL'){
				if (bVirtual)
					aMenu = [{'title':'POPUP_FOLDERS::EDIT_VIRTUAL','arg':{'fid':arg['fid'], 'method':'add_virtual'}}];
				else{
					aMenu = [{'title':'POPUP_FOLDERS::ADD_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'add_folder'}, 'disabled':!aRights.write},
							{'title':'POPUP_FOLDERS::MOVE_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'move_folder'}, 'disabled':!aRights.modify || sFolType == 'A'}];

					if (arg['aid']==sPrimaryAccount)
						aMenu.push({'title':'POPUP_FOLDERS::ADD_VIRTUAL','arg':{'fid':arg['fid'], 'method':'add_virtual'}});
				}

				aMenu.push(	{'title':'-'},
							{'title':'POPUP_FOLDERS::RENAME_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'ftype':arg['ftype'],'method':'rename_folder'}, 'disabled':!aRights.modify || sFolType == 'A' || arg['fid'].indexOf('~')==0});

				if (sFolType == 'R')
					aMenu.push(	{'title':'POPUP_FOLDERS::CHANGE_CHANNEL','arg':{'aid':arg['aid'],'fid':arg['fid'],'ftype':arg['ftype'],'method':'change_channel'}, 'disabled':!aRights.modify});
				else
				if (arg['aid']==sPrimaryAccount && !bVirtual){
					var sRoot = arg['fid'].split('/')[0];
					bArchive = dataSet.get('folders',[arg['aid'],sRoot,'ARCHIVE'])?true:false;

					//Default folders
					if (sFolType == 'M'){
						if (!bArchive && arg['fid']!='INBOX' && !dataSet.get('folders',[arg['aid'],arg['fid'],'SPAM']))
							aMenu.push(	{'title':'POPUP_FOLDERS::DEFAULT',nodes:[
										{'title':'COMMON_FOLDERS::DRAFTS','arg':{'aid':arg['aid'],'fid':arg['fid'],'default':'D','method':'default'},disabled:GWOthers.getItem('DEFAULT_FOLDERS','drafts') == arg['aid']+'/'+arg['fid']},
										{'title':'COMMON_FOLDERS::SENT','arg':{'aid':arg['aid'],'fid':arg['fid'],'default':'S','method':'default'},disabled:GWOthers.getItem('DEFAULT_FOLDERS','sent') == arg['aid']+'/'+arg['fid']},
										{'title':'COMMON_FOLDERS::TRASH','arg':{'aid':arg['aid'],'fid':arg['fid'],'default':'H','method':'default'},disabled:GWOthers.getItem('DEFAULT_FOLDERS','trash') == arg['aid']+'/'+arg['fid']}
										]});
					}
					else
					if (sFolType != 'A' && sFolType != 'X')
						aMenu.push({'title':'POPUP_FOLDERS::DEFAULT','arg':{'aid':arg['aid'],'fid':arg['fid'],'default':sFolType,'method':'default'},disabled:GWOthers.getItem('DEFAULT_FOLDERS', {C:'CONTACTS',E:'EVENTS',T:'TASKS',N:'NOTES',J:'JOURNAL',F:'FILES'}[sFolType]) == arg['aid']+'/'+arg['fid']});

					//Sharing
					aMenu.push(	{'title':'-'},
								{'title':'POPUP_FOLDERS::ADD_SHARED_ACCOUNT','arg':{'aid':arg['aid'],'method':'add_account'},disabled:(arg['aid']!=sPrimaryAccount || arg['fid'].indexOf('~')==0)},
								{'title':'POPUP_FOLDERS::SHARING','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'share'},disabled:(sFolType == 'M' && sPrimaryAccountProtocol!='imap') || bArchive});
				}

				aMenu.push({'title':'-'});
				
				if (sFolType == 'M' || sFolType == 'R') {

					if (sFolType == 'M' && arg['fid']!='INBOX' && !bVirtual && !bArchive)
						aMenu.push(	{'anchor':'subscribe'},
									{'title':'-'});

					//aMenu.push({'title':'POPUP_FOLDERS::MARK_ALL_AS_UNREAD','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'mark_all_as_unread'}});
					aMenu.push(	{'title':'POPUP_FOLDERS::MARK_ALL_AS_READ','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'mark_all_as_read'}, 'disabled':!aAccess.modify},
								{'title':'-'},
								{'title':'MAIN_MENU::EMPTY_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'empty_folder'}, 'disabled':!aAccess.remove});
				}

				aMenu.push({'title':'POPUP_FOLDERS::DELETE_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'delete_folder'}, 'disabled':!aRights.remove});
			}
			else
			if (sFolType == 'Q')
				aMenu = [{'title':'MAIN_MENU::EMPTY_FOLDER','arg':{'aid':arg['aid'],'fid':arg['fid'],'method':'empty_folder'}}];
		}
		else
			aMenu = [
			{'title':'POPUP_FOLDERS::ADD_FOLDER','arg':{'aid':arg['aid'],'method':'add_folder'}},
			{'title':'POPUP_FOLDERS::ADD_VIRTUAL','arg':{'method':'add_virtual'}, 'disabled': arg['aid']!=sPrimaryAccount},
			{'title':'-'},
			{'title':'POPUP_FOLDERS::ADD_SHARED_ACCOUNT','arg':{'aid':arg['aid'],'method':'add_account'},disabled:arg['aid']!=sPrimaryAccount},
			{'title':'POPUP_FOLDERS::SHARING','arg':{'aid':arg['aid'],'method':'share'},disabled:arg['aid']!=sPrimaryAccount}
			];

		var cmenu = gui._create("cmenu","obj_context_folder",'','',this);
			cmenu._fill(aMenu);
		if (cmenu._anchors.subscribe){
			var subscribe = cmenu._create('subscribe','obj_checkbox','subscribe');
				subscribe._title('POPUP_FOLDERS::SUBSCRIBE');
				subscribe._value(dataSet.get("folders",[arg['aid'],arg['fid'],'SYNC'])?1:0);
				subscribe._onclick = function(){
					WMFolders.subscribe(arg,'folders','',this._value());
					this._parent._destruct();
				};
		}
		
		cmenu._place(e.clientX,e.clientY);
	}
	else
		return this._handleNode(arg);
};

_me._handleNode = function(arg,bUpdate)
{
	if (arg['aid']){
		var t = dataSet.get("folders",[arg['aid'],arg['fid'],'TYPE']);
		
		//DO NOT handle Shared accounts
		if (arg['fid'] && (t=='A' || t=='VA'))
			return false;

		//DO NOT handle RSS accounts
		if(!arg['fid'] && (t == 'rss' || arg['aid'].indexOf('_rss')==arg['aid'].length-4))
		    return false;

		//Naposledy otevřený folder
		var aFolder = dataSet.get('active_folder');

		//Neotvíráme již otevřený folder?
		if (aFolder != arg['aid']+(arg['fid']?'/'+arg['fid']:'') || bUpdate)
			gui.frm_main._selectView(arg);

		return true;
	 }
};